# Apache Tomcat 7

Version 7.0.96, Jul 24 2019

Links

- Docs Home
- FAQ
- User Comments

User Guide

- 1) Introduction
- 2) Setup
- 3) First webapp
- 4) Deployer
- 5) Manager
- 6) Host Manager
- 7) Realms and AAA
- 8) Security Manager
- 9) JNDI Resources
- 10) JDBC DataSources
- 11) Classloading
- 12) JSPs
- 13) SSL/TLS
- 14) SSI
- 15) CGI
- 16) Proxy Support
- 17) MBeans Descriptors
- 18) Default Servlet
- 19) Clustering
- 20) Load Balancer
- 21) Connectors
- 22) Monitoring and Management
- 23) Logging
- 24) APR/Native
- 25) Virtual Hosting
- 26) Advanced IO
- 27) Additional Components
- 28) Mavenized
- 29) Security Considerations
- 30) Windows Service
- 31) Windows Authentication
- 32) Tomcat's JDBC Pool
- 33) WebSocket

Reference

- Release Notes
- Configuration
- Tomcat Javadocs
- Servlet Javadocs
- JSP 2.2 Javadocs
- EL 2.2 Javadocs
- WebSocket 1.1 Javadocs
- JK 1.2 Documentation

Apache Tomcat Development

- Building
- Changelog
- Status
- Developers
- Architecture
- Functional Specs.
- Tribes

# Changelog

Tomcat 7.0.96 (violetagg)

> Catalina

> > | 63579: Correct parsing of malformed OPTIONS requests and reject them with a 400 response rather than triggering an internal error that results in a 500 response. (markt)

> Coyote

> > | Correct parsing of invalid host names that contain bytes in the range 128 to 255 and reject them with a 400 response rather than triggering an internal error that results in a 500 response. (markt)

> WebSocket

> > | Correct a regression that prevented a default Tomcat 7 install from starting on Java 6. (markt)

> Other

> > | Enable the unit tests to execute in parallel. (markt)

Tomcat 7.0.95 (violetagg) | not released

> Catalina

> > | 63556: Mark request as forwarded in RemoteIpValve and RemoteIpFilter (michaelo)
> > | Fix a potential resource leak when executing CGI scripts from a WAR file. Identified by Coverity scan. (markt)
> > | Fix a potential concurrency issue in the StringCache identified by Coverity scan. (markt)
> > | Fix a potential concurrency issue in the main Sendfile thread of the APR connector. Identified by Coverity scan. (markt)
> > | Fix a potential resource leak on some exception paths in the `DataSourceRealm`. Identified by Coverity scan. (markt)
> > | Fix a potential resource leak on an exception path when parsing JSP files. Identified by Coverity scan. (markt)
> > | Fix a potential resource leak when a JNDI lookup returns an object of an in compatible class. Identified by Coverity scan. (markt)
> > | Refactor `ManagerServlet` to avoid loading classes when filtering JNDI resources for resources of a specified type. (markt)
> > | Avoid a `NullPointerException` when a `Context` is defined in `server.xml` with a `docBase` but not the optional `path`. (markt)
> > | 43548: Add an XML schema for the tomcat-users.xml file. (markt)
> > | 63324: Refactor the `CrawlerSessionManagerValve` so that the object placed in the session is compatible with session serialization with mem-cached. Patch provided by Martin Lemanski. (markt)
> > | Ensure that the default servlet reads the entire global XSLT file if one is defined. Identified by Coverity Scan. (markt)
> > | Avoid potential `NullPointerException` when generating an HTTP `Allow` header. Identified by Coverity Scan. (markt)
> > | Remove any fragment included in the target path used to obtain a `RequestDispatcher`. The requested target path is logged as a warning since this is an application error. (markt)
> > | 63531: Refactor authenticators so that the session last accessed time is not updated if the cache attribute is set to `false` and `FORM` authentication is not being used. (markt)
> > | Modify the Default and WebDAV Servlets so that a 405 status code is returned for `PUT` and `DELETE` requests when disabled via the `readonly` initialisation parameter.
> > | Align the contents of the `Allow` header with the response code for the Default and WebDAV Servlets. For any given resource a method that returns a 405 status code will not be listed in the `Allow` header and a method listed in the `Allow` header will not return a 405 status code. (markt)
> > | Correct two failing tests from the Litmus test suite for WebDAV when copying/moving a file over a collection. (markt)
> > | Update the recommended minimum Tomcat Native version to 1.2.23. (markt)
> > | If an unhandled exception occurs on a asynchronous thread started via `AsyncContext.start(Runnable)`, process it using the standard error page mechanism. (markt)

> Coyote

> > | Refactor Hostname validation to improve performance. Patch provided by Uwe Hees. (markt)
> > | Fix to avoid the possibility of long poll times for individual pollers when using multiple pollers with APR. (markt)
> > | Refactor the fix for 63205 so it only applies when using PKCS12 keystores as regressions have been reported with some other keystore types. (markt)

> Jasper

> > | Include file names in error messages if SMAP processor is unable to delete or rename a class file during SMAP generation. (markt)
> > | Improvements to varargs handling in the Java UEL implementation. (markt)

> Cluster

> > | 62841: Refactor the `DeltaRequest` serialization to reduce the window during which the `DeltaSession` is locked and to remove a potential cause of deadlocks during serialization. (markt)
> > | 63441: Further streamline the processing of session creation messages in the `DeltaManager` to reduce the possibility of a session update message being processed before the session has been created. (markt)

> WebSocket

> > | 63521: As required by the WebSocket specification, if a POJO that is deployed as a result of the SCI scan for annotated POJOs is subsequently deployed via the programmatic API ignore the programmatic deployment. (markt)

> Tribes

> > | Treat `NoRouteToHostException` the same way as `SocketTimeoutException` when checking the health of group members. This avoids a SEVERE log message every time the check is performed when the host associated with a group member is not powered on. (markt)

> Other

> > | 55969: Tighten up the security of the Apache Tomcat installation created by the Windows installer. Change the default shutdown port used by the Windows installer from `8005` to `-1` (disabled). Limit access to the chosen installation directory to local administrators, Local System and Local Service. (markt)
> > | 59871: Add a property (`timeFormat`) to JULI's `OneLineFormatter` to enable the format of the time stamp used in log messages to be configured. (markt)
> > | 63335: Ensure that stack traces written by the `OneLineFormatter` are fully indented. The entire stack trace is now indented by an additional TAB character. (markt)
> > | When using the `OneLineFormatter`, don't print a blank line in the log after printing a stack trace. (markt)
> > | Use the `test` command to check for terminal availability rather than the `tty` command since the `tty` based test fails on non-English locales. Patch provided by Radosław Józwik. (markt)
> > | Update JUnit to version 4.12. (markt)
> > | Update optional WSDL dependency to 1.6.3. (markt)
> > | Update Checkstyle to version 8.22. (markt)
> > | 63310: Update to Commons Daemon 1.2.0. This provides improved support for Java 11. This also changes the user configured by the Windows installer for the Windows service from `Local System` to the lower privileged `Local Service`. (markt)

Tomcat 7.0.94 (markt) | released 2019-04-12

> Catalina

> > | 63206: Add a new attribute to `Context` - `createUploadTargets` which, if `true` enables Tomcat to create the temporary upload location used by a Servlet if the location specified by the Servlet does not already exist. The default value is `false`. (markt)
> > | 63213: Ensure the correct escaping of group names when searching for nested groups when the JNDIRealm is configured with `roleNested` set to `true`. (markt)
> > | 63235: Refactor Charset cache to reduce start time. (markt)
> > | 63236: Use `String.intern()` as suggested by Phillip Webb to reduce memory wasted due to String duplication. This changes saves ~245k when starting a clean installation. With additional thanks to YourKit Java profiler for helping to track down the wasted memory and the root causes. (markt)
> > | 63246: Fix a potential `NullPointerException` when calling `AsyncContext.dispatch()`. (markt)
> > | 63196: Provide a default (`X-Forwarded-Proto`) for the `protocolHeader` attribute of the `RemoteIpFilter` and `RemoteIpValve`. (markt)
> > | 63249: Use a consistent log level (`WARN`) when logging the failure to register or deregister a JMX Bean. (markt)
> > | 63249: Use a consistent log level (`ERROR`) when logging the `LifecycleException` associated with the failure to start or stop a component. (markt)
> > | When the SSI directive `fsize` is used with an invalid target, return a file size of `-` rather than `1k`. (markt)
> > | 63251: Implement a work-around for a known JRE bug (JDK-8194653) that may cause a dead-lock when Tomcat starts. (markt)
> > | Ensure that the JarScanner correctly tests whether JARs found on the class path should be skipped when running on Java 9 or later. (markt)
> > | 63275: When using a `RequestDispatcher` ensure that `HttpServletRequest.getContextPath()` returns an encoded path in the dispatched request. (markt)
> > | 63286: Document the differences in behaviour between the `LogFormat` directive in httpd and the `pattern` attribute in the `AccessLogValve` for `%D` and `%T`. (markt)
> > | 63311: Add support for https URLs to the local resolver within Tomcat used to resolve standard XML DTDs and schemas when Tomcat is configured to validate XML configuration files such as web.xml. (markt)
> > | Encode the output of the SSI `printenv` command. This is the fix for CVE-2019-0221. (markt)
> > | Use constants for SSI encoding values. (markt)
> > | When the CGI Servlet is configured with `enableCmdLineArguments` set to true, limit the encoded form of the individual command line arguments to those values allowed by RFC 3875. This restriction may be relaxed by the use of the new initialisation parameter `cmdLineArgumentsEncoded`. (markt)
> > | When the CGI Servlet is configured with `enableCmdLineArguments` set to true, limit the decoded form of the individual command line arguments to known safe values when running on Windows. This restriction may be relaxed by the use of the new initialisation parameter `cmdLineArgumentsDecoded`. This is the fix for CVE-2019-0232. (markt)
> > | Change the default for the `enableCmdLineArguments` parameter of the CGI servlet from `true` to `false` as additional hardening against CVE-2019-0232. (markt)

> Coyote

> > | 63194: Fix failing unit test so TLS1.3 client authentication tests work correctly when using Java 11 onwards and the APR/Native connector. (markt)
> > | 63205: Add a work-around for a known JRE KeyStore loading bug. (markt)

> Jasper

> > | Add support for specifying Java 11 (with the value `11`) as the compiler source and/or compiler target for JSP compilation. (markt)
> > | Add support for specifying Java 12 (with the value `12`) and Java 13 (with the value `13`) as the compiler source and/or compiler target for JSP compilation. If used with an ECJ version that does not support these values, a warning will be logged and the latest supported version will used. Based on a patch by Thomas Collignon. (markt)

> Web applications

> > | 63184: Expand the SSI documentation to provide more information on the supported directives and their attributes. Patch provided by nightwatchcyber. (markt)

> jdbc-pool

> > | 63320: Ensure that `StatementCache` caches statements that include arrays in arguments. (kfujino)

> Other

> > | Copy Apache Commons DBCP 1.4 and Apache Commons Pool 1.5.7 source code into the Tomcat 7.0.x tree to enable additional fixes to be pulled in. (markt)
> > | Update the copy of Apache Commons DBCP 1.4.x and Apache Commons pool 1.5.x to the latest source code as of 2019-03-15 to pick up multiple bug fixes including 58338. (markt)
> > | Update the copy of Apache Commons Pool to 1.6.x to pick up the generics changes. (markt)
> > | Add JDBC 4.1 support to the default database connection pool provided by Tomcat. (markt)
> > | Switch from Checkstyle to the JRE6 backport and update to version 8.17. This allows Tomcat 7 to use the newer configuration format (required by Gump that uses the latest Checkstyle snapshot) while still building with Java 6. (markt)

Tomcat 7.0.93 (violetagg) | released 2019-02-21

> Catalina

> > | 54741: Add a new method, `Tomcat.addWebapp(String,URL)`, that allows a web application to be deployed from a URL when using Tomcat in embedded mode. (markt)
> > | 62897: Provide a property (`clearReferencesThreadLocals`) on the standard `Context` implementation that enables the check for memory leaks via `ThreadLocal`s to be disabled because this check depends on the use of an API that has been deprecated in later versions of Java. (markt)
> > | 62978: Update the RemoteIpValve to handle multiple values in the `x-forwarded-proto` header. Patch provided by Tom Groot. (markt)
> > | Update the RemoteIpFilter to handle multiple values in the `x-forwarded-proto` header. Based on a patch provided by Tom Groot. (markt)
> > | 62986: Refactor the code that performs class scanning during web application start to make integration simpler for downstream users. Based on a patch provided by rmannibucau. (markt)
> > | Implement the requirements of section 8.2.2 2c of the Servlet specification and prevent a web application from deploying if it has fragments with duplicate names and is configured to use relative ordering of fragments. (markt)
> > | Update the recommended minimum Tomcat Native version to 1.2.19. (markt)
> > | Ensure that the `ServletOutputStream` implementation is consistent with the requirements of asynchronous I/O and that all of the write methods use a single write rather than multiple writes. (markt)
> > | Correct the Javadoc for `Context.getDocBase()` and `Context.setDocBase()` and remove text that indicates that a URL may be used for the `docBase` as this has not been the case for quite some time. (markt)
> > | Ensure that Tomcat is fully terminated when running as a service. (markt)
> > | 63003: Extend the `unloadDelay` attribute on a `Context` to include in-flight asynchronous requests. (markt)
> > | 63026: Add a new attribute, `forceDnHexEscape`, to the `JNDIRealm` that forces escaping in the String representation of a distinguished name to use the `\nn` form. This may avoid issues with realms using Active Directory which appears to be more tolerant of optional escaping when the `\nn` form is used. (markt)
> > | Update the recommended minimum Tomcat Native version to 1.2.21. (markt)
> > | Simplify the value of `jarsToSkip` property in `catalina.properties` file for tomcat-i18n jar files. Use prefix pattern instead of listing each language. (kkolinko)

> WebSocket

> > | 57974: Ensure implementation of `Session.getOpenSessions()` returns correct value for both client-side and server-side calls. (markt)
> > | 63019: Use payload remaining bytes rather than limit when writing. Submitted by Benoit Courtilly. (remm)
> > | When running under a `SecurityManager`, ensure that the `ServiceLoader` look-up for the default `javax.websocket.server.ServerEndpointConfig.Configurator` implementation completes correctly rather than silently using the hard-coded fall-back. (markt)
> > | Ensure that the network connection is closed if the client receives an I/O error trying to communicate with the server. (markt)
> > | Ignore synthetic methods when scanning POJO methods. (markt)
> > | Implement the requirements of section 5.2.1 of the WebSocket 1.1 specification and ensure that if the deployment of one Endpoint fails, no Endpoints are deployed for that web application. (markt)
> > | Implement the requirements of section 4.3 of the WebSocket 1.1 specification and ensure that the deployment of an Endpoint fails if `@PathParam` is used with an invalid parameter type. (markt)
> > | Ensure a `DeploymentException` rather than an `IllegalArgumentException` is thrown if a method annotated with `@OnMessage` does not conform to the requirements set out in the Javadoc. (markt)
> > | Improve algorithm that determines if two `@OnMessage` annotations have been added for the same message type. Prior to this change some matches were missed. (markt)
> > | Remove the `STREAMS_DROP_EMPTY_MESSAGES` system property that was introduced to work-around four failing TCK tests. An alternative solution has been implemented. Sending messages via `getSendStream()` and `getSendWriter()` will now only result in messages on the wire if data is written to the `OutputStream` or `Writer`. Writing zero length data will result in an empty message. Note that sending a message via an `Encoder` may result in the message being send via `getSendStream()` or `getSendWriter()`. (markt)

> Web applications

> > | 63103: Remove the unused source.jsp file and associated tag from the examples web application as it is no longer used. (markt)
> > | 63143: Ensure that the Manager web application respects the language preferences of the user as configured in the browser when the language of the default system locale is not English. (markt)
> > | Use client's preferred language for the Server Status page of the Manager web application. Review and fix several cases when the client's language preference was not respected in Manager and Host Manager web applications. (kkolinko)
> > | Fix messages used by Manager and Host Manager web applications. Disambiguate message keys used when adding or removing a host. Improve display of summary values on the status page: separate terms and values with a whitespace. Improve wording of messages for expire sessions command. (kkolinko)
> > | Do not add CSRF nonce parameter and suppress Referer header for external links in Manager and Host Manager web applications. (kkolinko)

> Other

> > | Prevent an error when running in a Cygwin shell and the `JAVA_ENDORSED_DIRS` system property is empty. Patch provided by Zemian Deng. (markt)
> > | Update the packaged version of the Tomcat Native Library to 1.2.19 to pick up the latest Windows binaries built with APR 1.6.5 and OpenSSL 1.1.1a. (markt)
> > | Correct AsyncFileHandler to FileHandler in logging.properties. (huxing)
> > | Update the packaged version of the Tomcat Native Library to 1.2.21 to pick up the memory leak fixes when using NIO/NIO2 with OpenSSL. (markt)
> > | Enable compilation and test execution with Java 11. Note that the deprecated class `org.apache.catalina.util.Base64` will be excluded from the build in this case as it depends on JRE classes that have been removed in Java 11 onwards. (markt)
> > | Update the NSIS Installer used to build the Windows installer to version 3.04. (markt)
> > | Expand the coverage and quality of the Russian translations provided with Apache Tomcat. (kkolinko)

Tomcat 7.0.92 (violetagg) | released 2018-11-15

> Catalina

> > | Add documentation about the files `context.xml.default` and `web.xml.default` that can be used to customize `conf/context.xml` and `conf/web.xml` on a per host basis. (fschumacher)
> > | Ensure that a canonical path is always used for the docBase of a Context to ensure consistent behaviour. (markt)
> > | 62788: Add explicit logging configuration to write log files using UTF-8 to align with Tomcat's use of UTF-8 by default elsewhere. (markt)
> > | 62797: Pass throwable to keep client aborts with status 200 rather than 500. Patch submitted by zikfat. (remm)
> > | 62809: Correct a regression in the implementation of DIGEST authentication support for the Deployer Ant tasks (bug 45832) that prevented the `DeployTask` from working when authentication was required. (markt)
> > | Update the recommended minimum Tomcat Native version to 1.2.18. (markt)
> > | Ignore an attribute named `source` on `Context` elements provided by `StandardContext`. This is to suppress warnings generated by the Eclipse / Tomcat integration provided by Eclipse. Based on a patch by mdfst13. (markt)
> > | 62830: Added `JniLifeCycleListener` and static methods `Library.loadLibrary(libraryName)` and `Library.load(filename)` to load a native library by a shared class loader so that more than one Webapp can use it. (isapir)
> > | Correct a typo in the Spanish resource files. Patch provided by Diego Agulló. (markt)
> > | 62868: Order the `Enumeration<URL>` provided by `WebappClassLoaderBase.getResources(String)` according to the setting of the delegate flag. (markt)

> Coyote

> > | Add TLSv1.3 to the default protocols and to the `all` alias for JSSE based TLS connectors when running on a JVM that supports TLS version 1.3. One such JVM is OpenJDK version 11. (rjung)
> > | 62739: Do not reject requests with an empty HTTP Host header. Such requests are unusual but not invalid. Patch provided by Michael Orr. (markt)
> > | 62748: Add TLS 1.3 support for the APR/Native connector. (schultz/markt)
> > | 62791: Remove an unnecessary check in the NIO TLS implementation that prevented from secure WebSocket connections from being established. (markt)

> Jasper

> > | 62674: Correct a regression in the stand-alone JSP compiler utility, `JspC`, caused by the fix for 53492, that caused the JSP compiler to hang. (markt)
> > | 62721: Correct generation of web.xml header when using JspC. (markt)
> > | Fix a regression in the TLD whitespace parsing fix that broke parsing when whitespace was present between the method name and the parameters. (markt)
> > | 62757: Correct a regression in the fix for 62603 that caused `NullPointerException`s when compiling tag files on first access when development mode was disabled and background compilation was enabled. Based on a patch by Jordi Llach. (markt)
> > | 62808: Fix a regression in the TLD whitespace parsing fix that broke parsing when new lines were present in the method signature. (markt)

> WebSocket

> > | 62731: Make the URI returned by `HandshakeRequest.getRequestURI()` and `Session.getRequestURI()` absolute so that the scheme, host and port are accessible. (markt)

> Web applications

> > | 62761: Correct the advanced CORS example in the Filter documentation to use a valid configuration. (markt)
> > | 62786: Add a note to the Context documentation to explain that, by default, settings for a Context element defined in server.xml will be overwritten by settings specified in a default context file such as `conf/context.xml`. (markt)
> > | Create a little visual separation between the Undeploy button and the other buttons in the Manager application. Patch provided by Łukasz Jąder. (markt)

> Other

> > | Update the packaged version of the Tomcat Native Library to 1.2.18 to pick up the latest Windows binaries built with APR 1.6.5 and OpenSSL 1.1.1. (markt)

Tomcat 7.0.91 (violetagg) | released 2018-09-19

> Catalina

> > | 61692: Add the ability to control which HTTP methods are handled by the CGI Servlet via a new initialization parameter `cgiMethods`. (markt)
> > | Ensure that the HTTP Vary header is set correctly when using the CORS filter and improve the cacheability of requests that pass through the COPRS filter. (markt)
> > | 62527: Revert restriction of JNDI to the `java:` namespace. (remm)
> > | Introduce a new class - `MultiThrowable` - to report exceptions when multiple actions are taken where each action may throw an exception but all actions are taken before any errors are reported. Use this new class when reporting multiple container (e.g. web application) failures during start. (markt)
> > | Correctly decode URL paths (`+` should not be decoded to a space in the path) in the `RequestDispatcher` and the web application class loader. (markt)
> > | 62559: Add `jaxb-*.jar` to the list of JARs ignored by `StandardJarScanner`. (markt)
> > | 62560: Add `oraclepki.jar` to the list of JARs ignored by `StandardJarScanner`. (markt)
> > | 62607: Return a non-zero exit code from `catalina.[bat|sh] run` if Tomcat fails to start. (markt)
> > | Remove `ServletException` from declaration of `Tomcat.addWebapp(String,String)` since it is never thrown. Patch provided by Tzafrir. (markt)
> > | Use short circuit logic to prevent potential NPE in CorsFilter. (fschumacher)
> > | Simplify construction of appName from container name in JAASRealm. (fschumacher)
> > | Improve the handling of path parameters when working with RequestDispatcher objects. (markt)
> > | 62664: Process requests with content type `multipart/form-data` to servlets with a `@MultipartConfig` annotation regardless of HTTP method. (markt)
> > | 62669: When using the SSIFilter and a resource does not specify a content type, do not force the content type to `application/x-octet-stream`. (markt)
> > | When generating a redirect to a directory in the Default Servlet, avoid generating a protocol relative redirect. (markt)

> Coyote

> > | Refactor code that adds an additional header name to the `Vary` HTTP response header to use a common utility method that addresses several additional edge cases. (markt)
> > | 62526: Correctly handle PKCS12 format key stores when the key store password is configured to be the empty string. Note that Java 6 does not support PKCS12 key stores configured to use a store password of the empty string. (markt)
> > | 62670: Adjust the memory leak protection for the `DriverManager` so that JDBC drivers located in `$CATALINA_HOME/lib` and `$CATALINA_BASE/lib` are loaded via the service loader mechanism when the protection is enabled. (markt)
> > | 62685: Correct an error in host name validation parsing that did not allow a fully qualified domain name to terminate with a period. Patch provided by AG. (markt)

> Jasper

> > | 53011: When pre-compiling with JspC, report all compilation errors rather than stopping after the first error. A new option `-failFast` can be used to restore the previous behaviour of stopping after the first error. Based on a patch provided by Marc Pompl. (markt)
> > | 53492: Make the Java file generation process multi-threaded. By default, one thread will be used per core. Based on a patch by Dan Fabulich. (markt)
> > | 62603: Fix a potential race condition when development mode is disabled and background compilation checks are enabled. It was possible that some updates would not take effect and/or `ClassNotFoundException`s would occur. (markt)
> > | Correct the JSP version in the X-PoweredBy HTTP header generated when the xpoweredBy option is enabled. (markt)
> > | 62662: Fix the corruption of web.xml output during JSP compilation caused by the fix for 53492. Patch provided by Bernhard Frauendienst. (markt)
> > | Correct parsing of XML whitespace in TLD function signatures that incorrectly only looked for the space character. (markt)

> WebSocket

> > | 62596: Remove the limit on the size of the initial HTTP upgrade request used to establish the web socket connection. (markt)

> Web applications

> > | 62558: Add Russian translations for the Manager and Host Manager web applications. Based on a patch by Ivan Krasnov. (markt)
> > | 62561: Add advanced class loader configuration information regarding the use of the Server and Shared class loaders to the documentation web application. (markt)
> > | Expand the information in the documentation web application regarding the use of `CATALINA_HOME` and `CATALINA_BASE`. Patch provided by Marek Czernek. (markt)
> > | 62652: Make it clearer that the version of DBCP that is packaged in Tomcat 7.0.x is DBCP 1. (markt)
> > | 62666: Expand internationalisation support in the Manager application to include the server status page and provide Russian translations in addition to English. Patch provided by Artem Chebykin. (markt)
> > | 62676: Expand the CORS filter documentation to make it clear that explicit configuration is required to enable support for cross-origin requests. (markt)

> Tribes

> > | Ensures that the specified `rxBufSize` is correctly set to receiver buffer size. (kfujino)

> Other

> > | Fixed spelling. Patch provided by Jimmy Casey via GitHub. (violetagg)
> > | Correct various spelling errors throughout the source code and documentation. Patch provided by Kazuhiro Sera. (markt)

Tomcat 7.0.90 (violetagg) | released 2018-07-06

> Catalina

> > | 62498: Correct a regression in the fix for CVE-2017-12617 that caused request failures for some requests when using the `VirtualDirContext`. (markt)
> > | Delete reference to removed class that prevented Tomcat from starting when running under a security manager. (markt)

Tomcat 7.0.89 (violetagg) | not released

> Catalina

> > | JNDI resources that are defined with injection targets but no value are now treated as if the resource is not defined. (markt)
> > | Ensure that JNDI names used for `<lookup-name>` entries in web.xml and for `lookup` elements of `@Resource` annotations specify a name with an explicit `java:` namespace. (markt)
> > | 51953: Add the `RemoteCIDRFilter` and `RemoteCIDRValve` that can be used to allow/deny requests based on IPv4 and/or IPv6 client address where the IP ranges are defined using CIDR notation. Based on a patch by Francis Galiegue. (markt)
> > | 62343: Make CORS filter defaults more secure. This is the fix for CVE-2018-8014. (markt)
> > | Make all loggers associated with Tomcat provided Filters non-static to ensure that log messages are not lost when a web application is reloaded. (markt)
> > | Correct the manifest for the annotations-api.jar. The JAR implements the Common Annotations API 1.1 and the manifest should reflect that. (markt)
> > | Switch to non-static loggers where there is a possibility of a logger becoming associated with a web application class loader causing log messages to be lost if the web application is stopped. (markt)
> > | 62389: Add the IPv6 loopback address to the default `internalProxies` regular expression. Patch by Craig Andrews. (markt)
> > | In the `RemoteIpValve` and `RemoteIpFilter`, correctly handle the case when the request passes through one or more `trustedProxies` but no `internalProxies`. Based on a patch by zhanhb. (markt)
> > | Correct the logic in `MBeanFactory.removeConnector()` to ensure that the correct Connector is removed when there are multiple Connectors using different addresses but the same port. (markt)
> > | Make `JAASRealm` mis-configuration more obvious by requiring the authenticated Subject to include at least one Principal of a type specified by `userClassNames`. (markt)
> > | 62476: Use GMT timezone for the value of `Expires` header as required by HTTP specification (RFC 7231, 7234). (kkolinko)

> Coyote

> > | Log an error message if the AJP connector detects that the reverse proxy is sending AJP messages that are too large for the configured `packetSize`. (markt)
> > | 62371: Improve logging of Host validation failures. (markt)
> > | Correctly handle a digest authorization header when the user name contains an escaped character. (markt)
> > | Correctly handle a digest authorization header when one of the hex field values ends the header with in an invalid character. (markt)

> Jasper

> > | Update web.xml, web-fragment.xml and web.xml extracts generated by JspC to use the Servlet 3.0 version of the relevant schemas. (markt)
> > | Improve IPv6 validation by ensuring that IPv4-Mapped IPv6 addresses do not contain leading zeros in the IPv4 part. Based on a patch by Katya Stoycheva. (markt)
> > | 62080: Ensure that all reads of the current thread's context class loader made by the UEL API and implementation are performed via a `PrivilegedAction` to ensure that a `SecurityException` is not triggered when running under a `SecurityManager`. (mark)

> WebSocket

> > | When decoding of path parameter failed, make sure to throw `DecodeException` instead of throwing `ArrayIndexOutOfBoundsException`. (kfujino)
> > | Enable host name verification when using TLS with the WebSocket client. (markt)

> Web applications

> > 62395: Clarify the meaning of the connector attribute `minSpareThreads` in the documentation web application. (markt)

> jdbc-pool

> > | When `logValidationErrors` is set to true, the connection validation error is logged as `SEVERE` instead of `WARNING`. (kfujino)

> Other

> > | 62391: Remove references to `javaw.exe` as this file is not required by Tomcat and the references prevent the use of the Server JRE. (markt)
> > | Update the packaged version of the Tomcat Native Library to 1.2.17 to pick up the latest Windows binaries built with APR 1.6.3 and OpenSSL 1.0.2o. (markt)
> > | Implement checksum checks when downloading dependencies that are used to build Tomcat. (kkolinko)

Tomcat 7.0.88 (violetagg) | released 2018-05-11

> Catalina

> > | Treat the `<mapped-name>` element of a `<env-entry>` in web.xml in the same way as the `mappedName` element of the equivalent `@Resource` annotation. Both now attempt to set the `mappedName` property of the resource. (markt)
> > | Correct the processing of resources with `<injection-target>`s defined in web.xml. First look for a match using JavaBean property names and then, only if a match is not found, look for a match using fields. (markt)
> > | When restoring a saved request with a request body after FORM authentication, ensure that calls to the `HttpServletRequest` methods `getRequestURI()`, `getQueryString()` and `getProtocol()` are not corrupted by the processing of the saved request body. (markt)
> > | Fix startup failure when running under SecurityManager, a regression from the fix for bug 62273. (kkolinko)
> > | 62353: Correct a regression introduced in Tomcat 7.0.86. Restore the ability for Tomcat 7 to run on Java 6 where Common Annotations 1.0 is available. Document the requirement to use the Java endorsed mechanism to use Common Annotations 1.1. (markt)
> > | Refactor the `org.apache.naming` package to reduce duplicate code. Duplicate code identified by the Simian tool. (markt)
> > | 50019: Add support for `<lookup-name>`. Based on a patch by Gurkan Erdogdu. (markt)
> > | 60490: Various formatting and layout improvements for the `ErrorReportValve`. Patch provided by Michael Osipov. (markt)
> > | Relax Host validation by removing the requirement that the final component of a FQDN must be alphabetic. (markt)

> Jasper

> > | 50234: Add the capability to generate a web-fragment.xml file to JspC. (markt)
> > | 62350: Refactor `org.apache.jasper.runtime.BodyContentImpl` so a `SecurityException` is not thrown when running under a SecurityManger and additional permissions are not required in the `catalina.policy` file. This is a follow-up to the fix for 43925. (kkolinko/markt)

> Cluster

> > | Remove duplicate calls when creating a replicated session to reduce the time taken to create the session and thereby reduce the chances of a subsequent session update message being ignored because the session does not yet exist. (markt)

> Tribes

> > | Ensure that the correct default value is returned when retrieve unset properties in `McastService`. (kfujino)

> Other

> > | Add a `.gitattributes` file to make sure that Git handles test data files for bug 52121 as binary. (kkolinko)

Tomcat 7.0.87 (violetagg) | not released

> Catalina

> > | 62316: Correct a regression in some refactoring that broke the default factory for JDBC datasources. (markt)
> > | Fix a rare edge case that is unlikely to occur in real usage. This edge case meant that writing long streams of UTF-8 characters to the HTTP response that consisted almost entirely of surrogate pairs could result in one surrogate pair being dropped. (markt)
> > | Register MBean when DataSource Resource `type="javax.sql.XADataSource"`. Patch provided by Masafumi Miura. (csutherl)
> > | Update the internal fork of Apache Commons BCEL to r1829827 to add early access Java 11 support to the annotation scanning code. (markt)
> > | 62297: Enable the `CrawlerSessionManagerValve` to correctly handle bots that crawl multiple hosts and/or web applications when the Valve is configured on a Host or an Engine. (fschumacher)
> > | Collapse multiple leading `/` characters to a single `/` in the return value of `HttpServletRequest#getContextPath()` to avoid issues if the value is used with `HttpServletResponse#sendRedirect()`. This behaviour is enabled by default and configurable via the new Context attribute `allowMultipleLeadingForwardSlashInPath`. (markt)
> > | Improve handing of overflow in the UTF-8 decoder with supplementary characters. (markt)

> Coyote

> > | Enable strict validation of the provided host name and port for all connectors. Requests with invalid host names and/or ports will be rejected with a 400 response. (markt)
> > | Implement the requirements of RFC 7230 (and RFC 2616) that HTTP/1.1 requests must include a `Host` header and any request that does not must be rejected with a 400 response. (markt)
> > | Implement the requirements of RFC 7230 that any HTTP/1.1 request that specifies a host in the request line, must specify the same host in the `Host` header and that any such request that does not, must be rejected with a 400 response. This check is optional and disabled by default. It may be enabled with the `allowHostHeaderMismatch` attribute of the Connector. (markt)
> > | Implement the requirements of RFC 7230 that any HTTP/1.1 request that contains multiple `Host` headers is rejected with a 400 response. (markt)
> > | 62273: Implement configuration options to work-around specification non-compliant user agents (including all the major browsers) that do not correctly %nn encode URI paths and query strings as required by RFC 7230 and RFC 3986. (markt)

> Jasper

> > | Enable ECJ version 4.7 and later to be used as a drop in replacement for the ECJ version that ships with Apache Tomcat. (markt)
> > | Enable Java 10 to be specified as a JSP source and/or target if a newer ECJ version is used. (markt)
> > | 62287: Do not rely on hash codes to test instances of `ValueExpressionImpl` for equality. Patch provided by Mark Struberg. (markt)

> WebSocket

> > | 62301: Correct a regression in the fix for 61491 that didn't correctly handle a final empty message part in all circumstances when using `PerMessageDeflate`. (markt)

> Other

> > | Avoid warning when running under Cygwin when the `JAVA_ENDORSED_DIRS` environment variable is not set. Patch provided by Zemian Deng. (markt)

Tomcat 7.0.86 (violetagg) | released 2018-04-13

> Catalina

> > | 51195: Avoid a false positive report of a web application memory leak by clearing `ObjectStreamClass$Caches` of classes loaded by the web application when the web application is stopped. (markt)
> > | 52688: Add support for the `maxDays` attribute to the `AccessLogValve` and `ExtendedAccessLogValve`. This allows the maximum number of days for which rotated access logs should be retained before deletion to be defined. (markt)
> > | Prevent Tomcat from applying gzip compression to content that is already compressed with brotli compression. Based on a patch provided by burka. (markt)
> > | 62090: Null container names are not allowed. (remm)
> > | 62104: Fix programmatic login regression as the NonLoginAuthenticator has to be set for it to work (if no login method is specified). (remm)
> > | 62117: Improve error message in `catalina.sh` when calling `kill -0 <pid>` fails. Based on a suggestion from Mark Morschhaeuser. (markt)
> > | 62118: Correctly create a JNDI `ServiceRef` using the specified interface rather than the concrete type. Based on a suggestion by Ángel Álvarez Páscua. (markt)
> > | Fix for `RequestDumperFilter` log attribute. Patch provided by Kirill Romanov via Github. (violetagg)
> > | 62123: Avoid `ConcurrentModificationException` when attempting to clean up application triggered RMI memory leaks on web application stop. (markt)
> > | 62168: When using the `PersistentManager` honor a value of `-1` for `minIdleSwap` and do not swap out sessions to keep the number of active sessions under `maxActive`. Patch provided by Holger Sunke. (markt)
> > | 62172: Improve Javadoc for `org.apache.catalina.startup.Constants` and ensure that the constants are correctly used. (markt)
> > | 62175: Avoid infinite recursion, when trying to validate a session while loading it with `PersistentManager`. (fschumacher)
> > | Ensure that `NamingContextListener` instances are only notified once of property changes on the associated naming resources. (markt)
> > | 62224: Disable the `forkJoinCommonPoolProtection` of the `JreMemoryLeakPreventionListener` when running on Java 9 and above since the underlying JRE bug has been fixed. (markt)
> > | 62263: Avoid a `NullPointerException` when the `RemoteIpValve` processes a request for which no Context can be found. (markt)

> Coyote

> > | Correct off-by-one error in thread pool that allowed thread pools to increase in size to one more than the configured limit. Patch provided by usc. (markt)

> Web applications

> > | Work-around a known, non-specification compliant behaviour in some versions of IE that can allow XSS when the Manager application generates a plain text response. Based on a suggestion from Muthukumar Marikani. (markt)
> > | Add document for `FragmentationInterceptor`. (kfujino)
> > | Document how the roles for an authenticated user are determined when the `CombinedRealm` is used. (markt)

> jdbc-pool

> > | Ensure that `SQLWarning` has been cleared when connection returns to the pool. (kfujino)
> > | Ensure that parameters have been cleared when `PreparedStatement` and/or `CallableStatement` are cached. (kfujino)
> > | Enable PoolCleaner to be started even if `validationQuery` is not set. (kfujino)

> Other

> > | Update the build script so MD5 hashes are no longer generated for releases as per the change in the ASF distribution policy. (markt)
> > | 62164: Switch the build script to use TLS for downloads from SourceForge and Maven Central to avoid failures due to HTTP to HTTPS redirects. (markt)

Tomcat 7.0.85 (violetagg) | released 2018-02-13

> Catalina

> > | Prevent a stack trace being written to standard out when running on Java 10 due to changes in the `LogManager` implementation. (markt)
> > | Avoid duplicate load attempts if one has been made already. (remm)
> > | Avoid NPE in ThreadLocalLeakPreventionListener if there is no Engine. (remm)
> > | 58143: Fix calling classloading transformers broken in 7.0.70 by the fix for 59619. This was observed when using Spring weaving. (rjung)
> > | 62000: When a JNDI reference cannot be resolved, ensure that the root cause exception is reported rather than swallowed. (markt)
> > | 62036: When caching an authenticated user Principal in the session when the web application is configured with the `NonLoginAuthenticator`, cache the internal Principal object rather than the user facing Principal object as Tomcat requires the internal object to correctly process later authorization checks. (markt)
> > | 62067: Correctly apply security constraints mapped to the context root using a URL pattern of `""`. (markt)
> > | When using Tomcat embedded, only perform Authenticator configuration once during web application start. (markt)
> > | Process all `ServletSecurity` annotations at web application start rather than at servlet load time to ensure constraints are applied consistently. (markt)
> > | Minor optimization when calling class transformers. (rjung)

> Web applications

> > | 48672: Add documentation for the Host Manager web application. Patch provided by Marek Czernek. (markt)

> Other

> > | Update the NSIS Installer used to build the Windows installer to version 3.03. (kkolinko)

Tomcat 7.0.84 (violetagg) | released 2018-01-24

> Catalina

> > | 47214: Use a loop to preload anonymous inner classes when running under a `SecurityManager`, to be safe for future changes in the code or using a different compiler. (kkolinko)
> > | 57619: Implement a small optimisation to how JAR URLs are processed to reduce the storage of duplicate String objects in memory. Patch provided by Dmitri Blinov. (markt)
> > | 61810: Support configure the interval to keep all jars open if no jar is accessed, a non-positive interval indicates keeping jars always open. (huxing)
> > | 61886: Pre-load additional classes to prevent `SecurityException`s if the first request received when running under a `SecurityManager` is an asynchronous Servlet. (markt)
> > | 61916: Extend the `AddDefaultCharsetFilter` to add a character set when the content type is set via `setHeader()` or `addHeader()` as well as when it is set via `setContentType()`. (markt)
> > | 61999: maxSavePostSize set to 0 should disable saving POST data during authentication. (remm)

> Coyote

> > | 61886: Log errors on non-container threads at `DEBUG` rather than `INFO`. The exception will be made available to the application via the asynchronous error handling mechanism. (markt)
> > | 61993: Improve handling for `ByteChunk` and `CharChunk` instances that grow close to the maximum size allowed by the JRE. (markt)

> Jasper

> > | 43925: Add a new system property (`org.apache.jasper.runtime.BodyContentImpl.BUFFER_SIZE`) to control the size of the buffer used by Jasper when buffering tag bodies. (markt)

> Web applications

> > | 61223: Add the mbeans-descriptors.dtd file to the custom MBean documentation so users have a reference to use when constructing mbeans-descriptors.xml files for custom components. (markt)
> > | Partial fix for 61886. Ensure that multiple threads do not attempt to complete the `AsyncContext` if an I/O error occurs in the stock ticker example Servlet. (markt)
> > | 61886: Prevent `ConcurrentModificationException` when running the asynchronous stock ticker in the examples web application. (markt)
> > | 61886: Prevent `NullPointerException` and other errors if the stock ticker example is running when the examples web application is stopped. (markt)
> > | 61910: Clarify the meaning of the `allowLinking` option in the documentation web application. (markt)
> > | Add OCSP configuration information to the SSL How-To. Patch provided by Marek Czernek. (markt)
> > | 62006: Document the new `JvmOptions9` command line parameter for `tomcat7.exe`. (markt)

> jdbc-pool

> > | 61312: Prevent `NullPointerException` when using the statement cache of connection that has been closed. (kfujino)

> Other

> > | Update the internal fork of Commons FileUpload to 6c00d57 (2017-11-23) to pick up some code clean-up. (markt)
> > | Update the internal fork of Commons Codec to r1817136 to pick up some code clean-up. (markt)
> > | The native source bundles (for Commons Daemon and Tomcat Native) are no longer copied to the bin directory for the deploy target. They are now only copied to the bin directory for the release target. (markt)

Tomcat 7.0.83 (violetagg) | not released

> Catalina

> > | When running under Java 9 or later, and the `urlCacheProtection` option of the `JreMemoryLeakPreventionListener` is enabled, use the API added in Java 9 to only disable the caching for JAR URL connections. (markt)
> > | 61581: Fix possible `SecurityException` when using the APR/native connector with a `SecurityManager`. (markt)
> > | 61597: Extend the `StandardJarScanner` to scan JARs on the module path when running on Java 9 and class path scanning is enabled. (markt)
> > | Fix the JMX descriptor for `Wrapper.findInitParameter()`. (rjung)
> > | 61601: Add support for multi-release JARs in JAR scanning and web application class loading. (markt)
> > | Revert the change from 7.0.80 that called `ServletResponse.setLocale()` if the `Content-Language` HTTP header was set directly. (markt)
> > | Provide the `SessionInitializerFilter` that can be used to ensure that an HTTP session exists when initiating a WebSocket connection. Patch provided by isapir. (markt)
> > | Avoid a possible `NullPointerException` when timing out `AsyncContext` instances during shut down. (markt)

> Coyote

> > | 57870: When running on Java 7 or later, take advantage of the new `syncFlush` parameter when constructing a `GZIPOutputStream` rather than using the custom `FlushableGZIPOutputStream` implementation as a work-around. (markt)
> > | 61736: Improve performance of NIO connector when clients leave large time gaps between network packets. Patch provided by Zilong Song. (markt)

> Jasper

> > | Enable Jasper to compile JSPs for Java 9. In addition to configuring the JSP servlet with for Java 9 via the `compilerSourceVM` and `compilerTargetVM`, it is necessary to replace `ecj-4.4.2.jar` with a more recent version that supports Java 9. (markt)
> > | 61816: Invalid expressions in attribute values or template text should trigger a translation (compile time) error, not a run time error. (markt)

> WebSocket

> > | 61604: Add support for authentication in the websocket client. Patch submitted by J Fernandez. (remm)

> Web applications

> > | 61603: Add XML filtering for the status servlet output where needed. (remm)
> > | Correct the description of how the CGI servlet maps a request to a script in the CGI How-To. (markt)

> Tribes

> > | Fix incorrect behavior that attempts to resend channel messages more than the actual setting value of `maxRetryAttempts`. (kfujino)
> > | Ensure that the remaining Sender can send channel messages by avoiding unintended `ChannelException` caused by comparing the number of failed members and the number of remaining Senders. (kfujino)
> > | Ensure that remaining SelectionKeys that were not handled by throwing a `ChannelException` during SelectionKey processing are handled. (kfujino)

> Other

> > | Improve the fix for 61439 and exclude the JPA, JAX-WS and EJB annotations completely from the Tomcat distributions. (markt)
> > | Improve handling of endorsed directories. The endorsed directory mechanism will only be used if the `JAVA_ENDORSED_DIRS` system property is explicitly set or if `$CATALINA_HOME/endorsed` exists. When running on Java 9, any such attempted use of the endorsed directory mechanism will trigger an error and Tomcat will fail to start. (rjung)
> > | Refactoring in preparation for Java 9. Refactor to avoid using some methods that will be deprecated in Java 9 onwards. (markt)
> > | 51496: When using the Windows installer, check if the requested service name already exists and, if it does, prompt the user to select an alternative service name. Patch provided by Ralph Plawetzki. (markt)
> > | Add necessary Java 9 configuration options to the startup scripts to prevent warnings being generated on web application stop. (markt)
> > | 61590: Enable `service.bat` to recognise when `JAVA_HOME` is configured for a Java 9 JDK. (markt)
> > | 61598: Update the Windows installer to search the new (as of Java 9) registry locations when looking for a JRE. (markt)
> > | Add generation of a SHA-512 hash for release artifacts to the build script. (markt)
> > | 61658: Update MIME mappings for fonts to use `font/*` as per RFC8081. (markt)
> > | Update the packaged version of the Tomcat Native Library to 1.2.16 to pick up the latest Windows binaries built with APR 1.6.3 and OpenSSL 1.0.2m. (markt)
> > | Update the NSIS Installer used to build the Windows installer to version 3.02.1. (kkolinko)
> > | Update the Windows installer to use "The Apache Software Foundation" as the Publisher when Tomcat is displayed in the list of installed applications in Microsoft Windows. (kkolinko)
> > | 61803: Remove outdated SSL information from the Security documentation. (remm)

Tomcat 7.0.82 (violetagg) | released 2017-10-03

> Catalina

> > | 61210: When running under a SecurityManager, do not print a warning about not being able to read a logging configuration file when that file does not exist. (markt)
> > | 61280: Add RFC 7617 support to the `BasicAuthenticator`. Note that the default configuration does not change the existing behaviour. (markt)
> > | 61452: Fix a copy paste error that caused an `UnsupportedEncodingException` when using WebDAV. (markt)
> > | Correct regression in 7.0.80 that broke the use of relative paths with the `extraResourcePaths` attribute of a `VirtualDirContext`. (markt)
> > | 61489: When using the CGI servlet, make the generation of command line arguments from the query string (as per section 4.4 of RFC 3875) optional. The feature is enabled by default for consistency with previous releases. Based on a patch by jm009. (markt)
> > | Correct a regression in 7.0.80 and 7.0.81 that wrapped the `DirContext` that represented the web application in a `ProxyDirContext` twice rather than just once. (markt)
> > | 61542: Fix CVE-2017-12617 and prevent JSPs from being uploaded via a specially crafted request when HTTP PUT was enabled. (markt)
> > | Use the correct path when loading the JVM `logging.properties` file for Java 9. (rjung)
> > | 61554: Exclude test files in unusual encodings and markdown files intended for display in GitHub from RAT analysis. Patch provided by Chris Thistlethwaite. (markt)

> Coyote

> > | 48655: Enable Tomcat to shutdown cleanly when using sendfile, the APR/native connector and a multi-part download is in progress. (markt)
> > | 58244: Handle the case when OpenSSL resumes a TLS session using a ticket and the full client certificate chain is not available. In this case the client certificate without the chain will be presented to the application. (markt)
> > | Fix random `SocketTimeoutException`s when reading the request `InputStream`. Based on a patch by Peter Major. (markt)
> > | 60900: Avoid a `NullPointerException` in the APR Poller if a connection is closed at the same time as new data arrives on that connection. (markt)
> > | Add an option to reject requests that contain HTTP headers with invalid (non-token) header names with a 400 response. (markt)

> WebSocket

> > | 61491: When using the `permessage-deflate` extension, correctly handle the sending of empty messages after non-empty messages to avoid the `IllegalArgumentException`. (markt)

> Tribes

> > | To avoid unexpected session timeout notification from backup session, update the access time when receiving the map member notification message. (kfujino)
> > | Add member info to the log message when the failure detection check fails in `TcpFailureDetector`. (kfujino)
> > | Avoid Ping timeout until the added map member by receiving `MSG_START` message is completely started. (kfujino)
> > | When sending a channel message, make sure that the Sender has connected. (kfujino)
> > | Correct the backup node selection logic that node 0 is returned twice consecutively. (kfujino)
> > | Fix race condition of `responseMap` in `RpcChannel`. (kfujino)

> jdbc-pool

> > | 61391: Ensure that failed queries are logged if the `SlowQueryReport` interceptor is configured to do so and the connection has been abandoned. Patch provided by Craig Webb. (markt)
> > | 61425: Ensure that transaction of idle connection has terminated when the `testWhileIdle` is set to `true` and `defaultAutoCommit` is set to `false`. Patch provided by WangZheng. (kfujino)
> > | 61545: Correctly handle invocations of methods defined in the `PooledConnection` interface when using pooled XA connections. Patch provided by Nils Winkler. (markt)

> Other

> > | 61439: Remove the Java Annotation API classes from tomcat-embed-core.jar and package them in a separate JAR in the embedded distribution to provide end users with greater flexibility to handle potential conflicts with the JRE and/or other JARs. (markt)
> > | 61441: Improve the detection of `JAVA_HOME` by the `daemon.sh` script when running on a platform where Java has been installed from an RPM. (rjung)
> > | Update the packaged version of the Tomcat Native Library to 1.2.14 to pick up the latest Windows binaries built with APR 1.6.2 and OpenSSL 1.0.2l. (markt)
> > | Update fix for 59904 so that values less than zero are accepted instead of throwing a NegativeArraySizeException. (remm)
> > | 61563: Correct typos in Spanish translation. Patch provided by Gonzalo Vásquez. (csutherl)

Tomcat 7.0.81 (violetagg) | released 2017-08-16

> Catalina

> > | Correct regression in 7.0.80 that broke WebDAV. (markt)

Tomcat 7.0.80 (violetagg) | not released

> Catalina

> > | 56785: Avoid `NullPointerException` if directory exists on the class path that is not readable by the Tomcat user. (markt)
> > | Additional permission for deleting files is granted to JULI as it is required by FileHandler when running under a Security Manager. The thread that cleans the log files is marked as daemon thread. (violetagg)
> > | 61229: Correct a regression in 7.0.78 that broke WebDAV handling for resources with names that included a `&` character. (markt)
> > | If the `Content-Language` HTTP header is set directly, attempt to determine the Locale from the header value and call `ServletResponse.setLocale()` with the derived Locale. (markt)
> > | 61232: When log rotation is disabled only one separator will be used when generating the log file name. For example if the prefix is `catalina.` and the suffix is `.log` then the log file name will be `catalina.log` instead of `catalina..log`. Patch provided by Katya Stoycheva. (violetagg)
> > | 61253: Add warn message when Digester.updateAttributes throws an exception instead of ignoring it. (csutherl)
> > | 61313: Make the read timeout configurable in the `JNDIRealm` and ensure that a read timeout will result in an attempt to fail over to the alternateURL. Based on patches by Peter Maloney and Felix Schumacher. (markt)

> Coyote

> > | 61086: Ensure to explicitly signal an empty request body for HTTP 205 responses. Additional fix to r1795278. Based on a patch provided by Alexandr Saperov. (violetagg)
> > | 61322: Correct two regressions caused by the fix for 60319 when using BIO with an external Executor. Firstly, use the `maxThreads` setting from the Executor as the default for `maxConnections` if none is specified. Secondly, use `maxThreads` from the Executor when calculating the point at which to disable keep-alive. (markt)
> > | Add additional logging to record problems that occur while waiting for the NIO pollers to stop during the Connector stop process. (markt)
> > | Prevent exceptions being thrown during normal shutdown of NIO connections. This enables TLS connections to close cleanly. (markt)

> Jasper

> > | 53031: Add support for the `fork` option when compiling JSPs with the Jasper Ant task and javac. (markt)

> WebSocket

> > | 57767: Add support to the WebSocket client for following redirects when attempting to establish a WebSocket connection. Patch provided by J Fernandez. (markt)

> Other

> > | 52791: Add the ability to set the defaults used by the Windows installer from a configuration file. Patch provided by Sandra Madden. (markt)

Tomcat 7.0.79 (violetagg) | released 2017-07-01

> Catalina

> > | 61101: CORS filter should set Vary header in response. Submitted by Rick Riemer. (remm)
> > | 61105: Add a new JULI FileHandler configuration for specifying the maximum number of days to keep the log files. (violetagg)
> > | Improve the `SSLValve` so it is able to handle client certificate headers from Nginx. Based on a patch by Lucas Ventura Carro. (markt)
> > | 61154: Allow the Manager and Host Manager web applications to start by default when running under a security manager. This was accomplished by adding a custom permission, `org.apache.catalina.security.DeployXmlPermission`, that permits an application to use a `META-INF/context.xml` file and then granting that permission to the Manager and Host Manager. (markt)
> > | 61173: Polish the javadoc for `o.a.catalina.startup.Tomcat`. Patch provided by peterhansson_se. (violetagg)
> > | A new configuration property `crawlerIps` is added to the `o.a.catalina.valves.CrawlerSessionManagerValve`. Using this property one can specify a regular expression that will be used to identify crawlers based on their IP address. Based on a patch provided by Tetradeus. (violetagg)
> > | 61180: Log a warning message rather than an information message if it takes more than 100ms to initialised a `SecureRandom` instance for a web application to use to generate session identifiers. Patch provided by Piotr Chlebda. (markt)
> > | 61185: When an asynchronous request is dispatched via `AsyncContext.dispatch()` ensure that `getRequestURI()` for the dispatched request matches that of the original request. (markt)
> > | 61201: Ensure that the `SCRIPT_NAME` environment variable for CGI executables is populated in a consistent way regardless of how the CGI servlet is mapped to a request. (markt)
> > | 61215: Correctly define `addConnectorPort` and `invalidAuthenticationWhenDeny` in the `mbean-descriptors.xml` file for the `org.apache.catalina.valves` package so that the attributes are accessible via JMX. (markt)

> Coyote

> > | 61086: Explicitly signal an empty request body for HTTP 205 responses. (markt)
> > | Revert a change introduced in the fix for bug 60718 that changed the status code recorded in the access log when the client dropped the connection from 200 to 500. (markt)
> > | Make asynchronous error handling more robust. In particular ensure that `onError()` is called for any registered `AsyncListener`s after an I/O error on a non-container thread. (markt)

> Jasper

> > | 44787: Improve error message when JSP compiler configuration options are not valid. (markt)

> WebSocket

> > | Correct the log message when a `MessageHandler` for `PongMessage` does not implement `MessageHandler.Whole`. (rjung)
> > | Improve thread-safety of `Future`s used to report the result of sending WebSocket messages. (markt)
> > | 61183: Correct a regression in the previous fix for 58624 that could trigger a deadlock depending on the locking strategy employed by the client code. (markt)

> Web applications

> > | Better document the meaning of the trimSpaces option for Jasper. (markt)
> > | 61150: Configure the Manager and Host-Manager web applications to permit serialization and deserialization of CRSFPreventionFilter related session objects to avoid warning messages and/or stack traces on web application stop and/or start when running under a security manager. (markt)

> Tribes

> > | Add JMX support for Tribes components. (kfujino)

> Other

> > | 45832: Add HTTP DIGEST authentication support to the Catalina Ant tasks used to communicate with the Manager application. (markt)
> > | 45879: Add the `RELEASE-NOTES` file to the root of the installation created by the Tomcat installer for Windows to make it easier for users to identify the installed Tomcat version. (markt)
> > | 61076: Document the `altDDName` attribute for the `Context` element. (markt)
> > | 61145: Add missing `@Documented` annotation to annotations in the annotations API. Patch provided by Katya Todorova. (markt)
> > | 61146: Add missing `lookup()` method to `@EJB` annotation in the annotations API. Patch provided by Katya Todorova. (markt)
> > | Correct typo in Context Container Configuration Reference. Patch provided by Katya Todorova. (violetagg)

Tomcat 7.0.78 (violetagg) | released 2017-05-16

> General

> > | Allow to exclude JUnit test classes using the build property `test.exclude` and document the property in BUILDING.txt. (rjung)

> Catalina

> > | Review those places where Tomcat re-encodes a URI or URI component and ensure that the correct encoding (path differs from query string) is applied and that the encoding is applied consistently. (markt)
> > | Use a more reliable mechanism for the `DefaultServlet` when determining if the current request is for custom error page or not. (markt)
> > | Ensure that when the Default or WebDAV servlets process an error dispatch that the error resource is processed via the `doGet()` method irrespective of the method used for the original request that triggered the error. (markt)
> > | If a static custom error page is specified that does not exist or cannot be read, ensure that the intended error status is returned rather than a 404. (markt)
> > | When the WebDAV servlet is configured and an error dispatch is made to a custom error page located below `WEB-INF`, ensure that the target error page is displayed rather than a 404 response. (markt)
> > | 61047: Add MIME mapping for woff2 fonts in the default web.xml. Patch provided by Justin Williamson. (violetagg)
> > | Correct the logic that selects the encoding to use to decode the query string in the `SSIServletExternalResolver` so that the `useBodyEncodingForURI` attribute of the `Connector` is correctly taken into account. (markt)
> > | 61072: Respect the documentation statements that allow using the platform default secure random for session id generation. (remm)
> > | Correct the javadoc for `o.a.c.connector.CoyoteAdapter#parseSessionCookiesId`. Patch provided by John Andrew (XUZHOUWANG) via Github. (violetagg)

> Jasper

> > | 60925: Improve the handling of access to properties defined by interfaces when a `BeanELResolver` is used under a `SecurityManager`. (markt)

> WebSocket

> > | 61003: Ensure the flags for reading/writing in `o.a.t.websocket.AsyncChannelWrapperSecure` are correctly reset even if some exceptions occurred during processing. (markt/violetagg)

> Web applications

> > | Document the property `test.excludePerformance` in BUILDING.txt. (rjung)
> > | Add documents for `maxIdleTime` attribute to Channel Receiver docs. (kfujino)

> jdbc-pool

> > | Refactor the creating a constructor for a proxy class to reduce duplicate code. (kfujino)
> > | In `StatementFacade`, the method call on the statements that have been closed throw `SQLException` rather than `NullPointerException`. (kfujino)

> Other

> > | Correct comments about Java 8 in `Jre8Compat`. Patch provided by fibbers via Github. (violetagg)
> > | 60932: Correctly escape single quotes when used in i18n messages. Based on a patch by Michael Osipov. (markt)

Tomcat 7.0.77 (violetagg) | released 2017-04-02

> Catalina

> > | 54618: Add support to the `HttpHeaderSecurityFilter` for the HSTS preload parameter. (markt)
> > | 60911: Ensure NPE will not be thrown when looking for SSL session ID. Based on a patch by Didier Gutacker. (violetagg)

> Coyote

> > | When using the NIO2 connector, ensure a WebSocket close frame is processed before the end of stream is processed to ensure that the end of stream is processed correctly. (markt)
> > | 60852: Correctly spell compressible when used in configuration attributes and internal code. Based on a patch by Michael Osipov. (markt)
> > | Improve sendfile handling when requests are pipelined. (markt)

> Jasper

> > | Improve the error handling for simple tags to ensure that the tag is released and destroyed once used. (remm, violetagg)
> > | 60844: Correctly handle the error when fewer parameter values than required by the method are used to invoke an EL method expression. Patch provided by Daniel Gray. (markt)

> jdbc-pool

> > | 60764: Implement `equals()` and `hashCode()` in the `StatementFacade` in order to enable these methods to be called on the closed statements if any statement proxy is set. This behavior can be changed with `useStatementFacade` attribute. (kfujino)

Tomcat 7.0.76 (markt) | released 2017-03-16

> Catalina

> > | Make it easier for sub-classes of `Tomcat` to modify the default web.xml settings by over-riding `getDefaultWebXmlListener()`. Patch provided by Aaron Anderson. (markt)
> > | Reduce the contention in the default `InstanceManager` implementation when multiple threads are managing objects and need to reference the annotation cache. (markt)
> > | 60674: Remove `final` marker from `CorsFilter` to enable sub-classing. (markt)
> > | 60683: Security manager failure causing NPEs when doing IO on some JVMs. (csutherl)
> > | 60688: Update the internal fork of Apache Commons BCEL to r1782855 to add early access Java 9 support to the annotation scanning code. (markt)
> > | 60718: Improve error handling for asynchronous processing and correct a number of cases where the `requestDestroyed()` event was not being fired and an entry wasn't being made in the access logs. (markt)
> > | 60808: Ensure that the `Map` returned by `ServletRequest.getParameterMap()` is fully immutable. Based on a patch provided by woosan. (markt)
> > | 60824: Correctly cache the `Subject` in the session - if there is a session - when running under a `SecurityManager`. Patch provided by Jan Engehausen. (markt)
> > | Ensure request and response facades are used when firing application listeners. (markt/remm)
> > | When HTTP TRACE requests are disabled on the Connector, ensure that the HTTP OPTIONS response from the WebDAV servlet does not include TRACE in the returned Allow header. (markt)

> Coyote

> > | Ensure that executor thread pools used with connectors pre-start the configured minimum number of idle threads. (markt)
> > | 60594: Allow some invalid characters that were recently restricted to be processed in requests by using the system property `tomcat.util.http.parser.HttpParser.requestTargetAllow`. (csutherl)

> Jasper

> > | Refactor code generated for JSPs to reduce the size of the code required for tags. (markt)

> Cluster

> > | Make the `accessTimeout` configurable in `ClusterSingleSignOn`. The `accessTimeout` is used as a timeout period for PING in replication map. (kfujino)
> > | 60806: To avoid `ClassNotFoundException`, make sure that the web application class loader is passed to `ReplicatedContext`. (kfujino)

> WebSocket

> > | 60617: Correctly create a `CONNECT` request when establishing a WebSocket connection via a proxy. Patch provided by Svetlin Zarev. (markt)

> Tribes

> > | Ensure that `NoRpcChannelReply` messages are not received on `RpcCallback`. (kfujino)
> > | 60722: Take account of the dispatchersUseEncodedPaths setting on the current Context when generating paths for dispatches triggered by `AsyncContext.dispatch()`. (markt)

> Other

> > | 60620: Fix configuration of Eclipse projects, broken by introduction of `SafeForkJoinWorkerThreadFactory` helper class. This class cannot be built with Java 6. (kkolinko)
> > | Update the packaged version of the Tomcat Native Library to 1.2.12 to pick up the latest Windows binaries built with OpenSSL 1.0.2k. (violetagg)
> > | 60784: Update all unit tests that test the HTTP status line to check for the required space after the status code. Patch provided by Michael Osipov. (markt)
> > | Update the NSIS Installer used to build the Windows installer to version 3.01. (markt)
> > | Refactor the build script and the NSIS installer script so that either NSIS 2.x or NSIS 3.x can be used to build the installer. This is primarily to re-enable building the installer on the Linux based CI system where the combination of NSIS 3.x and wine leads to failed installer builds. (markt)

Tomcat 7.0.75 (violetagg) | released 2017-01-24

> Cluster

> > | Make the `accessTimeout` configurable in `BackupManager`. The `accessTimeout` is used as a timeout period for PING in replication map. (kfujino)

> Web applications

> > | Ensure the ASF logo image is correctly displayed in docs and host-manager applications. (violetagg)

Tomcat 7.0.74 (violetagg) | not released

> Catalina

> > | 53602: Add HTTP status code 451 (RFC 7725) to the list of HTTP status codes recognised by Tomcat. (markt)
> > | Correctly handle the `configClass` attribute of a Host when embedding Tomcat. (markt)
> > | 60379: Dispose of the GSS credential once it is no longer required. Patch provided by Michael Osipov. (markt)
> > | 60380: Ensure that a call to `HttpServletRequest#logout()` triggers a call to `TomcatPrincipal#logout()`. Based on a patch by Michael Osipov. (markt)
> > | 60387: Correct the javadoc for `o.a.catalina.AccessLog.setRequestAttributesEnabled`. The default value is different for the different implementations. (violetagg)
> > | 60393: Use consistent parameter naming in implementations of `Realm#authenticate(GSSContext, boolean)`. (markt)
> > | 60395: Log when an `Authenticator` passes an incomplete `GSSContext` to a Realm since it indicates a bug in the `Authenticator`. Patch provided by Michael Osipov. (markt)
> > | Update the warnings that reference required options for running on Java 9 to use the latest syntax for those options. (markt)
> > | 60513: Fix thread safety issue with RMI cleanup code. (remm)
> > | 60620: Extend the `JreMemoryLeakPreventionListener` to provide protection against `ForkJoinPool.commonPool()` related memory leaks. (markt)

> Coyote

> > | Ensure that the endpoint is able to unlock the acceptor thread during shutdown if the endpoint is configured to listen to any local address of a specific type such as `0.0.0.0` or `::`. (markt)
> > | Ensure sendfile is enabled by default for APR. (markt)
> > | Prevent read time out when the file is deleted while serving the response. The issue was observed only with APR Connector and sendfile enabled. (violetagg)
> > | Improve the logic that selects an address to use to unlock the Acceptor to take account of platforms what do not listen on all local addresses when configured with an address of `0.0.0.0` or `::`. (markt)
> > | 60409: When unable to complete sendfile request, ensure the Processor will be added to the cache only once. (markt/violetagg)

> Jasper

> > | 44294: Add support for varargs in UEL expressions. (markt)
> > | 60356: Fix pre-compilation of JSPs that depend on nested tag files packaged in a JAR. (markt)
> > | 60431: Improve handling of varargs in UEL expressions. Based on a patch by Ben Wolfe. (markt)
> > | 60497: Restore previous tag reuse behavior following the use of try/finally. (remm)
> > | Improve the error handling for simple tags to ensure that the tag is released and destroyed once used. (remm)
> > | 60497: Follow up fix using a better variable name for the tag reuse flag. (remm)
> > | Revert use of try/finally for simple tags. (remm)

> Web applications

> > | Correct a typo in Host Configuration Reference. Issue reported via comments.apache.org. (violetagg)
> > | In the documentation web application, be explicit that clustering requires a secure network for all of the cluster network traffic. (markt)
> > | Update the ASF logos to the new versions.

> Tribes

> > | Reduce the warning logs for a message received from a different domain in order to avoid excessive log outputs. (kfujino)
> > | Add log message that PING message has received beyond the timeout period. (kfujino)
> > | When a PING message that beyond the time-out period has been received, make sure that valid member is added to the map membership. (kfujino)

> WebSocket

> > | 60437: Avoid possible handshake overflows in the websocket client. (remm)

> jdbc-pool

> > | 58816: Implement the statistics of jdbc-pool. The stats infos are `borrowedCount`, `returnedCount`, `createdCount`, `releasedCount`, `reconnectedCount`, `releasedIdleCount` and `removeAbandonedCount`. (kfujino)
> > | 60194: If `validationQuery` is not specified, connection validation is done by calling the `isValid()` method. (kfujino)
> > | 60398: Fix testcase of `TestSlowQueryReport`. (kfujino)
> > | Enable reset the statistics without restarting the pool. (kfujino)

> Other

> > | 60366: Change `catalina.bat` to use directly `LOGGING_MANAGER` and `LOGGING_CONFIG` variables in order to configure logging, instead of modifying `JAVA_OPTS`. Patch provided by Petter Isberg. (violetagg)
> > | New property is added `test.verbose` in order to control whether the output of the tests is displayed on the console or not. Patch provided by Emmanuel Bourg. (violetagg)
> > | Update the ASF logos used in the Apache Tomcat installer for Windows to use the new versions.
> > | Spelling corrections provided by Josh Soref. (violetagg)

Tomcat 7.0.73 (violetagg) | released 2016-11-14

> Catalina

> > | 60117: Ensure that the name of `LogLevel` is localized when using `OneLineFormatter`. Patch provided by Tatsuya Bessho. (kfujino)
> > | 60151: Improve the exception error messages when a `ResourceLink` fails to specify the type, specifies an unknown type or specifies the wrong type. (markt)
> > | 60167: Ignore empty lines in `/etc/passwd` files when using the `PasswdUserDatabase`. (markt)
> > | Improve the access checks for linked global resources to handle the case where the current class loader is a child of the web application class loader. (markt)
> > | 60199: Log a warning if deserialization issues prevent a session attribute from being loaded. (markt)
> > | Correctly test for control characters when reading the provided shutdown password. (markt)
> > | When configuring the JMX remote listener, specify the allowed types for the credentials. (markt)

> Coyote

> > | 60123: Avoid potential threading issues that could cause excessively large vales to be returned for the processing time of a current request. (markt)
> > | 60174: Log instances of `HeadersTooLargeException` during request processing. (markt)
> > | Correct the HTTP header parser so that DEL is not treated as a valid token character. (markt)
> > | 60319: When using an Executor, disconnect it from the Connector attributes `maxThreads`, `minSpareThreads` and `threadPriority` to enable the configuration settings to be consistently reported. These Connector attributes will be reported as `-1` when an Executor is in use. The values used by the executor may be set and obtained via the Executor. (markt)
> > | If an I/O error occurs during async processing on a non-container thread, ensure that the `onError()` event is triggered. (markt)
> > | Improve detection of I/O errors during async processing on non-container threads and trigger async error handling when they are detected. (markt)
> > | Add additional checks for valid characters to the HTTP request line parsing so invalid request lines are rejected sooner. (markt)

> Web applications

> > | Add an example of using the `classesToInitialize` attribute of the `JreMemoryLeakPreventionListener` to the documentation web application. Based on a patch by Cris Berneburg. (markt)
> > | 60192: Correct a typo in the status output of the Manager application. Patch provided by Radhakrishna Pemmasani. (markt)
> > | Correct a typo in HTTP Connector How-To. Issue reported via comments.apache.org. (violetagg)
> > | Fix default value of `validationInterval` attribute in jdbc-pool. (kfujino)
> > | Correct a typo in CGI How-To. Issue reported via comments.apache.org. (violetagg)
> > | 60344: Add a note to BUILDING.txt regarding using the source bundle with the correct line endings. (markt)

> Tribes

> > | When the proxy node sends a backup retrieve message, ensure that using the `channelSendOptions` that has been set rather than the default `channelSendOptions`. (kfujino)

> jdbc-pool

> > | 60099: Ensure that use all method arguments as a cache key when using `StatementCache`. (kfujino)
> > | 60139: Correct Javadocs for `PoolConfiguration.getValidationInterval` and `setValidationInterval`. Reported by Phillip Webb. (kfujino)

> Other

> > | Add documentation to the bin/catalina.bat script to remind users that environment variables don't affect the configuration of Tomcat when run as a Windows Service. Based upon a documentation patch by James H.H. Lampert. (schultz)

Tomcat 7.0.72 (violetagg) | released 2016-09-19

> Catalina

> > | Ensure `Digester.useContextClassLoader` is considered in case the class loader is used. (violetagg)

> Jasper

> > | 60101: Remove preloading of the class that was deleted. (violetagg)

> jdbc-pool

> > | Notify jmx when returning the connection that has been marked suspect. (kfujino)
> > | Ensure that the `POOL_EMPTY` notification has been added to the jmx notification types. (kfujino)

> Other

> > | Update the packaged version of the Tomcat Native Library to 1.2.10 to pick up the latest Windows binaries built with OpenSSL 1.0.2j. (markt)
> > | 61599: Update to Commons Daemon 1.1.0 for improved Java 9 support. (markt)

Tomcat 7.0.71 (violetagg) | not released

> Catalina

> > | 57705: Add debug logging for requests denied by the remote host and remote address valves and filters. Based on a patch by Graham Leggett. (markt)
> > | Change the default of the `sessionCookiePathUsesTrailingSlash` attribute of the `Context` element to `false` since the problems caused when a Servlet is mapped to `/*` are more significant than the security risk of not enabling this option by default. (markt)
> > | 59708: Modify the LockOutRealm logic. Valid authentication attempts during the lock out period will no longer reset the lock out timer to zero. (markt)
> > | Improve error handling around user code prior to calling `InstanceManager.destroy()` to ensure that the method is executed. (markt)
> > | Ensure that reading the `singleThreadModel` attribute of a `StandardWrapper` via JMX does not trigger initialisation of the associated servlet. With some frameworks this can trigger an unexpected initialisation thread and if initilisation is not thread-safe the initialisation can then fail. (markt)
> > | By default, treat paths used to obtain a request dispatcher as encoded. This behaviour can be changed per web application via the `dispatchersUseEncodedPaths` attribute of the Context. (markt)
> > | 59839: Apply `roleSearchAsUser` to all nested searches in JNDIRealm. (fschumacher)
> > | Provide a mechanism that enables the container to check if a component (typically a web application) has been granted a given permission when running under a SecurityManager without the current execution stack having to have passed through the component. Use this new mechanism to extend SecurityManager protection to the system property replacement feature of the digester. (markt)
> > | When retrieving an object via a `ResourceLink`, ensure that the object obtained is of the expected type. (markt)
> > | 59866: When scanning `WEB-INF/classes` for annotations, don't scan the contents of `WEB-INF/classes/META-INF` (if present) since classes will never be loaded from that location. (markt)
> > | 59912: Fix an edge case in input stream handling where an `IOException` could be thrown when reading a POST body. (markt)
> > | 59966: Do not start the web application if the error page configuration in web.xml is invalid. (markt)
> > | Switch the CGI servlet to the standard logging mechanism and remove support for the debug attribute. (markt)
> > | Add a new initialisation parameter, `envHttpHeaders`, to the CGI Servlet to mitigate httpoxy (CVE-2016-5388) by default and to provide a mechanism that can be used to mitigate any future, similar issues. (markt)
> > | When adding and removing `ResourceLink`s dynamically, ensure that the global resource is only visible via the `ResourceLinkFactory` when it is meant to be. (markt)
> > | 60008: When processing CORs requests, treat any origin with a URI scheme of `file` as a valid origin. (markt)
> > | Improve handling of exceptions during a Lifecycle events triggered by a state transition. The exception is now caught and the component is now placed into the `FAILED` state. (markt)
> > | Fix a file descriptor leak when reading the global web.xml. (markt)
> > | 60041: Better error message if a JAR is deleted while a web application is running. Note: Deleting a JAR while the application is running is not supported and errors are expected. Based on a patch by gehui. (markt)

> Coyote

> > | Improve error handling around user code prior to calling `InstanceManager.destroy()` to ensure that the method is executed. (markt)
> > | 59904: Add a limit (default 200) for the number of cookies allowed per request. Based on a patch by gehui. (markt)
> > | Make timing attacks against the Realm implementations harder. (schultz)
> > | Refactor the code that implements the requirement that a call to `complete()` or `dispatch()` made from a non-container thread before the container initiated thread that called `startAsync()` completes must be delayed until the container initiated thread has completed. Rather than implementing this by blocking the non-container thread, extend the internal state machine to track this. This removes the possibility that blocking the non-container thread could trigger a deadlock. (markt)

> Jasper

> > | Improve error handling around user code prior to calling `InstanceManager.destroy()` to ensure that the method is executed. (markt)
> > | Improve the error handling for custom tags to ensure that the tag is returned to the pool or released and destroyed once used. (markt)
> > | Fixed StringIndexOutOfBoundsException. Based on a patch provided by wuwen via Github. (violetagg)

> WebSocket

> > | Improve error handling around user code prior to calling `InstanceManager.destroy()` to ensure that the method is executed. (markt)
> > | 59868: Clarify the documentation for the Manager web application to make clearer that the host name and IP address in the server section are the primary host name and IP address. (markt)
> > | 59908: Ensure that a reason phrase is included in the close message if a session is closed due to a timeout. (markt)

> Web Applications

> > | Do not log an additional case of `IOException`s in the error handler for the Drawboard WebSocket example when the root cause is the client disconnecting since the logs add no value. (markt)
> > | 59642: Mention the `localDataSource` in the `DataSourceRealm` section of the Realm How-To. (markt)
> > | Follow-up to the fix for 59399. Ensure that the new attribute `transportGuaranteeRedirectStatus` is documented for all Realms. Also document the `NullRealm` and when it is automatically created for an Engine. (markt)
> > | MBeans Descriptors How-To is moved to `mbeans-descriptors-howto.html`. Patch provided by Radoslav Husar. (violetagg)
> > | 60034: Correct a typo in the Manager How-To page of the documentation web application. (markt)

> Tribes

> > | Add log message when the ping has timed-out. (kfujino)
> > | If the ping message has been received at the `AbstractReplicatedMap#leftOver` method, ensure that notify the member is alive than ignore it. (kfujino)

> jdbc-pool

> > | Fix the duplicated connection release when connection verification failed. (kfujino)
> > | Ensure that do not remove the abandoned connection that has been already released. (kfujino)
> > | In order to avoid the unintended skip of `PoolCleaner`, remove the check code of the execution interval in the task that has been scheduled. (kfujino)
> > | 59849: Ensure that the connection verification is executed by `initSQL` (if required) if the borrowing `PooledConnection` has not been initialized. (kfujino)
> > | 59850: Ensure that the `ResultSet` is closed when enabling the `StatementCache` interceptor. (kfujino)
> > | 59923: Reduce the default value of `validationInterval` in order to avoid the potential issue that continues to return an invalid connection after database restart. (kfujino)
> > | Ensure that the `ResultSet` is returned as Proxy object when enabling the `StatementDecoratorInterceptor`. (kfujino)
> > | 60043: Ensure that the `suspectTimeout` works without removing connection when the `removeAbandoned` is disabled. (kfujino)
> > | Add log message of when returning the connection that has been marked suspect. (kfujino)
> > | Correct Javadoc for `ConnectionPool.suspect()`. Based on a patch by Yahya Cahyadi. (markt)

> Other

> > | Use the mirror network rather than the ASF master site to download the current ASF dependencies. (markt)
> > | Update the packaged version of the Tomcat Native Library to 1.2.8 to pick up the latest fixes and make 1.2.8 the minimum recommended version. (markt)
> > | Fixed typos in mbeans-descriptors.xml files. (violetagg)
> > | Update the internal fork of Commons BCEL to r1757132 to align with the BCEL 6 release. (markt)
> > | Update the internal fork of Commons Codec to r1757174. Code formatting changes only. (markt)
> > | Update the internal fork of Commons FileUpload to afdedc9. This pulls in a fix to improve the performance with large multipart boundaries. (markt)
> > | Update the download location for Objenesis. (violetagg)

Tomcat 7.0.70 (violetagg) | released 2016-06-20

> Catalina

> > | 59219: Ensure `AsyncListener.onError()` is called if an `Exception` is thrown during async processing. (markt)
> > | 59220: Ensure that `AsyncListener.onComplete()` is called if the async request times out and the response is already committed. (markt)
> > | 59261: `ServletRequest.getAsyncContext()` now throws an `IllegalStateException` as required by the Servlet specification if the request is not in asynchronous mode when called. (markt)
> > | 59310: Do not add a `Content-Length: 0` header for custom responses to `HEAD` requests that do not set a `Content-Length` value. (markt)
> > | When normalizing paths, improve the handling when paths end with `/.` or `/..` and ensure that input and output are consistent with respect to whether or not they end with `/`. (markt)
> > | 59317: Ensure that `HttpServletRequest.getRequestURI()` returns an encoded URI rather than a decoded URI after a dispatch. (markt)
> > | Ensure that the value for the header `X-Frame-Options` is constructed correctly according to the specification when `ALLOW-FROM` option is used. (violetagg)
> > | 59399: Add a new option to the Realm implementations that ship with Tomcat that allows the HTTP status code used for HTTP -> HTTPS redirects to be controlled per Realm. (markt)
> > | 59449: In `ContainerBase`, ensure that the process to remove a child container is the reverse of the process to add one. Patch provided by Huxing Zhang. (markt)
> > | RMI Target related memory leaks are avoidable which makes them an application bug that needs to be fixed rather than a JRE bug to work around. Therefore, start logging RMI Target related memory leaks on web application stop. Add an option that controls if the check for these leaks is made. Log a warning if running on Java 9 with this check enabled but without the command line option it requires. (markt)
> > | Fix a potential concurrency issue with the web application class loader and concurrent reads and writes of the resource cache. (markt)
> > | 59619: Within the web application class loader, always use path as the key for the resource cache to improve the hit ratio. This also fixes a problem exposed by the fix for 56777 that enabled file based configuration resources to be loaded from the class path. (markt)
> > | Fix error message when failed to register MBean. (kfujino)

> Coyote

> > | 58970: Fix a connection counting bug in the NIO connector that meant some dropped connections were not removed from the current connection count. (markt)
> > | 59289: Do not recycle upgrade processors in unexpected close situations. (remm)
> > | Ensure that requests with HTTP method names that are not tokens (as required by RFC 7231) are rejected with a 400 response. (markt)
> > | When an asynchronous request is processed by the AJP connector, ensure that request processing has fully completed before starting the next request. (markt)
> > | If an async dispatch results in the completion of request processing, ensure that any remaining request body is swallowed before starting the processing of the next request else the remaining body may be read as the start of the next request leading to a 400 response. (markt)

> Jasper

> > | Fix a memory leak in the expression language implementation that caused the class loader of the first web application to use expressions to be pinned in memory. (markt)
> > | 59654: Enforce the requirements of section 7.3.1 of the JSP specification regarding the permitted locations for TLD files. Patch provided by Huxing Zhang. (markt)

> WebSocket

> > | Ensure that a client disconnection triggers the error handling for the associated WebSocket end point. (markt)

> Web Applications

> > | Correct a typo in SSL/TLS Configuration How-To. Issue reported via comments.apache.org. (violetagg)
> > | 58891: Update the SSL how-to. Based on a suggestion by Alexander Kjäll. (markt)

> Tribes

> > | Fix potential NPE that depends on the setting order of attributes of static member when using the static cluster. (kfujino)
> > | Add get/set method for the channel that is related to `ChannelInterceptorBase`. (kfujino)
> > | As with the multicast cluster environment, in the static cluster environment, the local member inherits properties from the cluster receiver. (kfujino)
> > | Add get/set method for the channel that is related to each Channel services. (kfujino)
> > | Add name to channel in order to identify channels. In tomcat cluster environment, it is set the cluster name + "-Channel" as default value. (kfujino)
> > | Add the channel name to the thread which is invoked by channel services in order to identify the associated channel. (kfujino)
> > | Ensure that clear the channel instance from channel services when stopping channel. (kfujino)
> > | Implement map state in the replication map. (kfujino)
> > | Ensure that the ping is not executed during the start/stop of the replication map. (kfujino)
> > | In ping processing in the replication map, send not the `INIT` message but the newly introduced `PING` message. (kfujino)

> jdbc-pool

> > | Fix a memory leak with the pool cleaner thread that retained a reference to the web application class loader for the first web application to use a connection pool. (markt)

> Other

> > | Update the packaged version of the Tomcat Native Library to 1.2.7 to pick up the Windows binaries that are based on OpenSSL 1.0.2h and APR 1.5.2. (violetagg/markt)
> > | Remove native code (Windows Service Wrapper, APR/native connector) support for Windows Itanium. (markt)
> > | Update the internal fork of Commons File Upload to r1743698 (1.3.1 plus additional fixes). (markt)
> > | 58626: Add support for a new environment variable (`USE_NOHUP`) that causes `nohup` to be used when starting Tomcat. It is disabled by default except on HP-UX where it is enabled by default since it is required when starting Tomcat at boot on HP-UX. (markt)

Tomcat 7.0.69 (violetagg) | released 2016-04-15

> Catalina

> > | Fix the type of `InstanceManager` attribute of mbean definition of `StandardContext`. (kfujino)
> > | 58351: Make the server build date and server version number accessible via JMX. Patch provided by Huxing Zhang. (markt)
> > | 59001: Correctly handle the case when Tomcat is installed on a path where one of the segments ends in an exclamation mark. (markt)
> > | Expand the fix for 59001 to cover the special sequences used in Tomcat's custom jar:war: URLs. (markt)
> > | 59043: Avoid warning while expiring sessions associated with a single sign on if `HttpServletRequest.logout()` is used. (markt)
> > | 59054: Ensure that using the `CrawlerSessionManagerValve` in a distributed environment does not trigger an error when the Valve registers itself in the session. (markt)
> > | Log a warning message if a user tries to configure the default session timeout via the deprecated (and ignored) `Manager.setMaxInactiveInterval()` method. (markt)
> > | Correct a regression introduced in 7.0.68 where the deprecated `Manager.getMaxInactiveInterval()` method returned the current default session timeout in minutes rather than seconds. (markt)
> > | When a Host is configured with an appBase that does not exist, create the appBase before trying to expand an external WAR file into it. (markt)
> > | 59115: When using the Servlet 3.0 file upload, the submitted file name may be provided as a token or a quoted-string. If a quoted-string, unquote the string before returning it to the user. (markt)
> > | 59123: Close `NamingEnumeration` objects used by the `JNDIRealm` once they are no longer required. (fschumacher/markt)
> > | 59138: Correct a false positive warning for ThreadLocal related memory leaks when the key class but not the value class has been loaded by the web application class loader. (markt)
> > | 59145: Don't log an invalid warning when a user logs out of a session associated with SSO. (markt)
> > | 59151: Fix a regression in the fix for 56917 that added additional (and arguably unnecessary) validation to the provided redirect location. (markt)
> > | 59206: Ensure NPE will not be thrown by `o.a.tomcat.util.file.ConfigFileLoader` when `catalina.base` is not specified. (violetagg)
> > | 59213: Async dispatches should be based off a wrapped request. (remm)
> > | 59217: Remove duplication in the recycling of the path in `o.a.tomcat.util.http.ServerCookie`. Patch is provided by Kyohei Nakamura. (violetagg)
> > | Ensure that `javax.servlet.ServletRequest` and `javax.servlet.ServletResponse` provided during `javax.servlet.AsyncListener` registration are made available via `javax.servlet.AsyncEvent.getSuppliedRequest` and `javax.servlet.AsyncEvent.getSuppliedResponse` (violetagg)
> > | Clarify the log message that specifying both urlPatterns and value attributes in WebServlet and WebFilter annotations is not allowed. (violetagg)
> > | Ensure the exceptions caused by Valves will be available in the log files so that they can be evaluated when `o.a.catalina.valves.ErrorReportValve.showReport` is disabled. Patch is provided by Svetlin Zarev. (violetagg)
> > | 59247: Preload ResourceEntry as a workaround for security manager issues on some JVMs. (kkolinko/remm)
> > | 59269: Correct the implementation of `PersistentManagerBase` so that `minIdleSwap` functions as designed and sessions are swapped out to keep the active session count below `maxActiveSessions`. (markt)

> Coyote

> > | 58646: Correct a problem with sendfile that resulted in a Processor being added to the cache twice leading to broken responses. (markt)
> > | 59015: Fix potential cause of endless APR Poller loop during shutdown if the Poller experiences an error during the shutdown process. (markt)
> > | Limit the default TLS ciphers for JSSE (BIO, NIO) and OpenSSL (APR) to those currently considered secure. (markt)
> > | Add a new environment variable `JSSE_OPTS` that is intended to be used to pass JVM wide configuration to the JSSE implementation. The default value is `-Djdk.tls.ephemeralDHKeySize=2048` which protects against weak Diffie-Hellman keys. (markt)

> WebSocket

> > | 59014: Ensure that a WebSocket close message can be sent after a close message has been received. (markt)
> > | Correctly handle compression of partial messages when the final message fragment has a zero length payload. (markt)
> > | Extend the WebSocket programmatic echo endpoint provided in the examples to handle binary messages and also partial messages. This aligns the code with Tomcat 8 and makes it easier to run the Autobahn testsuite against the WebSocket implementation. (markt)
> > | 59119: Correct read logic for WebSocket client when using secure connections. (markt)
> > | 59134: Correct client connect logic for secure connections made through a proxy. (markt)
> > | 59189: Explicitly release the native memory held by the `Inflater` and `Deflater` when using PerMessageDeflate and the WebSocket session ends. Based on a patch by Henrik Olsson. (markt)

> Web Applications

> > | Correct the description of the `ServletRequest.getServerPort()` in Proxy How-To. Issue reported via comments.apache.org. (violetagg)
> > | Fix a potential indefinite wait in the Comet Chat servlet in the examples web application. (markt)
> > | 59229: Fix error in HTTP docs and make clear that the HTTP NIO connector uses non-blocking I/O to read the HTTP request headers. (markt)
> > | Update in the documentation the link to the maven repository where Tomcat snapshot artifacts are deployed. (markt/violetagg)
> > | Clarify in the documentation that calls to `ServletContext.log(String, Throwable)` or `GenericServlet.log(String, Throwable)` are logged at the SEVERE level. (violetagg)

> Tribes

> > | If promoting a proxy node to a primary node when getting a session, notify the change of the new primary node to the original backup node. (kfujino)
> > | Avoid NPE when a proxy node failed to retrieve a backup entry. (kfujino)
> > | Add log of when received an unexpected messages. (kfujino)
> > | Add the flag indicating that member is a localMember. (kfujino)

> Other

> > | 58283: Change the default download location for libraries during the build process from `/usr/share/java` to `${user.home}/tomcat-build-libs`. Patch provided by Ahmed Hosni. (markt)
> > | 59031: When using the Windows uninstaller, do not remove the contents of any directories that have been symlinked into the Tomcat directory structure. (markt)
> > | Modify the default `tomcat-users.xml` file to make it harder for users to configure the entries intended for use with the examples web application for the Manager application. (markt)
> > | 59211: Add hamcrest to Eclipse classpath. Patch is provided by Huxing Zhang. (violetagg)
> > | 59280: Update the NSIS Installer used to build the Windows Installers to version 2.51. (kkolinko)

Tomcat 7.0.68 (violetagg) | released 2016-02-16

> General

> > | Allow to configure multiple JUnit test class patterns with the build property `test.name` and document the property in BUILDING.txt. (rjung)

> Catalina

> > | Correct implementation of `validateClientProvidedNewSessionId` so client provided session IDs may be rejected if validation is enabled. (markt)
> > | 56785: Avoid `NullPointerException` if directory exists on the class path that is not readable by the Tomcat user. (kkolinko)
> > | 57906: Suppress WebappClassLoader log messages when running with a security manager on Java 6, caused by `java.beans.Introspector.findExplicitBeanInfo()` calls during evaluation of EL expressions. (kkolinko)
> > | 58692: Make `StandardJarScanner` more robust. Log a warning if a class path entry cannot be scanned rather than triggering the failure of the web application. (markt)
> > | 58701: Reset the `instanceInitialized` field in `StandardWrapper` when unloading a Servlet so that a new instance may be correctly initialized. (markt)
> > | 58702: Ensure an access log entry is generated if the client aborts the connection. (markt)
> > | Fixed various issues reported by Findbugs. (violetagg)
> > | 58735: Add support for the `X-XSS-Protection` header to the `HttpHeaderSecurityFilter`. Patch provided by Jacopo Cappellato. (markt)
> > | 58751: Correctly handle the case where an `AsyncListener` dispatches to a Servlet on an asynchronous timeout and the Servlet uses `sendError()` to trigger an error page. Includes a test case based on code provided by Andy Wilkinson.(markt)
> > | 58765: Change default for `mapperContextRootRedirectEnabled` to `true` since this is required for correct session management because of the default for `sessionCookiePathUsesTrailingSlash`. (markt)
> > | Add the `StatusManagerServlet` to the list of Servlets that can only be loaded by privileged applications. (markt)
> > | Simplify code and fix messages in `org.apache.catalina.core.DefaultInstanceManager` class. (kkolinko)
> > | Ensure that the proper file encoding if specified will be used when a readme file is served by DefaultServlet. (violetagg)
> > | Fix declaration of `localPort` attribute of Connector MBean: it is read-only. (kkolinko)
> > | 58766: Make skipping non-class files during annotation scanning faster by checking the file name first. Improve debug logging. (kkolinko)
> > | 58768: Log a warning if a redirect fails because of an invalid location. (markt)
> > | 58836: Correctly merge query string parameters when processing a forwarded request where the target includes a query string that contains a parameter with no value. (markt/kkolinko)
> > | Make sure that shared Digester is reset in an unlikely error case in `HostConfig.deployWAR()`. (kkolinko)
> > | Fix a potential JDBC resource leak in DataSourceRealm. (schultz)
> > | 58900: Correctly undeploy symlinked resources and prevent an infinite cycle of deploy / undeploy. (markt)
> > | Protect initialization of `ResourceLinkFactory` when running with a SecurityManager. (kkolinko)
> > | Extend the feature available in the cluster session manager implementations that enables session attribute replication to be filtered based on attribute name to all session manager implementations. Note that configuration attribute name has changed from `sessionAttributeFilter` to `sessionAttributeNameFilter`. Apply the filter on load as well as unload to ensure that configuration changes made while the web application is stopped are applied to any persisted data. (markt)
> > | Extend the session attribute filtering options to include filtering based on the implementation class of the value and optional `WARN` level logging if an attribute is filtered. These options are available for all of the Manager implementations that ship with Tomcat. When a `SecurityManager` is used filtering will be enabled by default. (markt)
> > | 58905: Ensure that `Tomcat.silence()` silences the correct logger and respects the current setting. (markt)
> > | 58946: Ensure that the request parameter map remains immutable when processing via a RequestDispatcher. (markt)

> Coyote

> > | New configuration option `ajpFlush` for the AJP connectors to disable the sending of AJP flush packets. (rjung)

> Jasper

> > | Fix handling of missing messages in `org.apache.el.util.MessageFactory`. (violetagg)
> > | Ignore `engineOptionsClass` and `scratchdir` when running under a security manager. (markt)

> Cluster

> > | In order to avoid that the heartbeat thread and the background thread to run `Channel.heartbeat` simultaneously, if `heartbeatBackgroundEnabled` of `SimpleTcpCluster` set to `true`, ensure that the heartbeat thread does not start. (kfujino)

> WebSocket

> > | 57489: Ensure `onClose()` is called when a WebSocket connection is closed even if the sending of the close message fails. Includes test cases by Barry Coughlan. (markt)
> > | Fix a timing issue on session close that could result in an exception being thrown for an incomplete message even through the message was completed. (markt)

> Web Applications

> > | Correct some typos in the JNDI resources How-To. (markt)
> > | Don't create sessions unnecessarily in the Manager application. (markt)
> > | Don't create sessions unnecessarily in the Host Manager application. (markt)
> > | 58723: Clarify documentation and error messages for the text interface of the manager to make clear that version must be used with path when referencing contexts deployed using parallel deployment. (markt)
> > | Correct an error in the documentation of the expected behaviour for automatic deployment. If a WAR is updated and an expanded directory is present, the directory will always be deleted and recreated by expanding the WAR if `unpackWARs` is `true`. (markt)
> > | 58935: Remove incorrect references in the documentation to using `jar:file:` URLs with the Manager application. (markt)

> Tribes

> > | Add support for the startup notification of local members in the static cluster. (kfujino)
> > | Ignore the unnecessary member remove operation from different domain. (kfujino)
> > | Add support for the shutdown notification of local members in the static cluster. (kfujino)
> > | Ensure that asynchronous session replication thread is a daemon thread. (kfujino)

> Other

> > | Update the NSIS Installer used to build the Windows Installers to version 2.50. (markt/kkolinko)

Tomcat 7.0.67 (violetagg) | released 2015-12-10

> Catalina

> > | 56917: As per RFC7231 (HTTP/1.1), allow HTTP/1.1 and later redirects to use relative URIs. This is controlled by a new attribute `useRelativeRedirects` on the Context and defaults to `true`. (markt)
> > | 58660: Correct a regression in 7.0.66 caused by the change that moved the redirection for context roots from the Mapper to the Default Servlet. (markt)
> > | Fixed potential NPE in `HostConfig` while deploying an application. Issue reported by coverity scan. (violetagg)
> > | 58655: Fix an `IllegalStateException` when calling `HttpServletResponse.sendRedirect()` with the `RemoteIpFilter`. This was caused by trying to correctly generate the absolute URI for the redirect. With the fix for 56917, redirects may now be relative making the `sendRedirect()` implementation for the `RemoteIpFilter` much simpler. This also addresses issues where the redirect may not have behaved as expected when redirecting from http to https to from https to http. (markt)

> WebSocket

> > | 58658: Correct a regression in 7.0.66 that prevented Tomcat from starting on Java 6 unless the WebSocket JARs (that require Java 7) were removed. (markt)

> Web Applications

> > | Add a description of the default value of `heartbeatSleeptime` attribute and `optionCheck` attribute in the cluster channel docs. (kfujino)

> Tribes

> > | Fix potential NPE in `AbstractReplicatedMap.breakdown()`. (kfujino)

Tomcat 7.0.66 (violetagg) | not released

> General

> > | 58596: Clarify the description in RUNNING.txt of how environment variables are used. (markt)

> Catalina

> > | 34319: Only load those keys in `StoreBase.processExpire` from JDBCStore, that are old enough, to be expired. Based on a patch by Tom Anderson. (fschumacher)
> > | 56777: Allow file based configuration resources (user database, certificate revocation lists, keystores and trust stores) to be configured using URLs as well as files. Back-port provided by Huxing Zhang. (markt/violetagg)
> > | 57741: Enable the CGI servlet to use the standard error page mechanism. Note that if the CGI servlet's debug init parameter is set to 10 or higher then the standard error page mechanism will be bypassed and a debug response generated by the CGI servlet will be returned instead. (markt)
> > | 58486: Protect against two further possible memory leaks associated with XML parsing. (markt)
> > | 58497: Make `AbstractHttp11Processor` easy to extend. (markt)
> > | 58508: Escape role names when generating associated MBeans in case the role name contains characters not permitted in an MBean name. (markt)
> > | 58522: Fixed concurrency issue when iterating web application's resources. (violetagg)
> > | 58534: Removed repeated conditional tests in `o.a.tomcat.websocket.pojo.PojoMethodMapping` and `o.a.tomcat.util.net.AprEndpoint` Patch provided by Anthony Whitford. (violetagg)
> > | 58535: Use `Collections.reverseOrder` when a reverse ordering is needed. (violetagg)
> > | 58537: Some of the inner classes in `o.a.catalina.valves.ExtendedAccessLogValve` are made static. Patch provided by Anthony Whitford. (violetagg)
> > | 58540: Removed unused code from `o.a.catalina.connector.Request`. Patch provided by Anthony Whitford. (violetagg)
> > | 58541, 58544: It is more efficient to call `Integer.toString(int)` instead of `Integer.valueOf(int).toString()` when only a string representation of a primitive is needed. Based on a patch provided by Anthony Whitford. (violetagg)
> > | 58541, 58547: It is more efficient to call `valueOf(...)` instead of Number constructor. Based on a patch provided by Anthony Whitford. (violetagg)
> > | 58545: In some use cases it is more efficient to use `Map.entrySet()` instead of `Map.keySet()` Based on a patch provided by Anthony Whitford. (violetagg)
> > | Add a new RestCsrfPreventionFilter that provides basic CSRF protection for REST APIs. (violetagg)
> > | 58581: If a custom error page fails, fall back to the standard error page rather than throwing an NPE. Based on a patch by Huxing Zhang. (markt)
> > | 58582: Combined realm should perform background processing on its sub-realms. Based upon a patch provided by Aidan. (kkolinko)
> > | Handle the unlikely case where different versions of a web application are deployed with different session settings. (markt)
> > | Add a new Context option, enabled by default, that enables an additional check that a client provided session ID is in use in at least one other web application before allowing it to be used as the ID for a new session in the current web application. (markt)
> > | Add support for DIGEST authentication to the JNDIRealm. Based on a patch by Alexis Hassler. (markt)
> > | 58603: Ensure that `HttpServletRequest.getRequestURL()` returns the correct value when using the `RemoteIpFilter`. (markt)
> > | Ensure that in an embedded Tomcat the logging configuration is not lost during garbage collection. (violetagg)
> > | Move the functionality that provides redirects for context roots and directories where a trailing `/` is added from the Mapper to the `DefaultServlet`. This enables such requests to be processed by any configured Valves and Filters before the redirect is made. This behaviour is configurable via the `mapperContextRootRedirectEnabled` and `mapperDirectoryRedirectEnabled` attributes of the Context which may be used to restore the previous behaviour. (markt)
> > | 58635: Enable break points to be set within agent code when running Tomcat with a Java agent. Based on a patch by Huxing Zhang. (markt)
> > | Add path parameter handling to `HttpServletRequest.getContextPath()`. This is a follow-up to the fix for 57215. (markt)

> Jasper

> > | 57136#c25: Implement a setting that controls what quoting rule is used when parsing EL expressions in attributes on a JSP page (chapter JSP.1.6 of specification). The setting name is `quoteAttributeEL` and it is configured as initialisation parameter of JSP Servlet (per web application configuration is possible) and as a command line option for JspC. The default value was changed to `true`, which restores behaviour implemented in Tomcat 7.0.64. It means that attribute quoting is applied on top of EL quoting. This provides better compatibility with older versions of Tomcat and other implementations. (kkolinko)

> Cluster

> > | Optimize the session lock range in DeltaManager.requestCompleted. (kfujino)
> > | Enable an explicit configuration of local member in the static cluster membership. (kfujino)
> > | Fix potential integer overflow in `DeltaSession`. Reported by coverity scan. (fschumacher)

> Tribes

> > | Distinguish the handling of the shutdown payload and member verification clearly. When handling shutdown payload, verification completion message is not required. (kfujino)
> > | When starting the `StaticMembershipInterceptor`, `StaticMembershipInterceptor` checks the required Interceptors. If the required Interceptor does not exist, it issues warning logs. (kfujino)
> > | Ensure that the static member is registered to the add suspect list even if the static member that is registered to the remove suspect list has disappeared. (kfujino)
> > | Correct the warning log of when the member that is not registered in the membership is detected. (kfujino)
> > | When using a static cluster, add the members that have been cached in the membership service to the map members list in order to ensure that the map member is a static member. (kfujino)

> WebSocket

> > | Use instance manager for server endpoint instances. (remm)
> > | 55006: The WebSocket client now honors the `java.net.java.net.ProxySelector` configuration (using the HTTP type) when establishing WebSocket connections to servers. Based on a patch by Niki Dokovski. (markt)
> > | 58624: Correct a thread safety issue that meant that blocking message writes could block indefinitely if the WebSocket connection was closed while a message write was in progress. (markt)

> Web applications

> > | Make it clear in the documentation for the CGI servlet that the debug page is not considered secure and should not be used in production. (markt)
> > | The `domain` attribute of `StaticMember` is not required but optional. (kfujino)
> > | 58631: Correct the continuation character use in the Windows Service How-To page of the documentation web application. (markt)

> jdbc-pool

> > | 58489: Correct QueryStatsComparator to hold up the general contract for Comparator. (fschumacher)
> > | When creating a `QueryStats` object, ensure that `maxQueries` is checked. If `maxQueries` is a value less than or equal to 0, `QueryStats` are never created. (kfujino)
> > | Fix potential integer overflow in `ConnectionPool` and `PooledConnection`. Reported by coverity scan. (fschumacher)

Tomcat 7.0.65 (violetagg) | released 2015-10-19

> Catalina

> > | 57681: Add a web application class loader implementation that supports the parallel loading of web application classes. Use of this feature requires a Java 7 or later JRE. Based on a patch by Huxing Zhang. (markt)
> > | 58187: Correct a regression in the fix for 57765 that meant that deployment of web applications deployed via the Manager application was delayed until the next execution of the automatic deployment background process. (markt)
> > | 58284: Correctly implement session serialization so non-serializable attributes are skipped with a warning. Patch provided by Andrew Shore. (markt)
> > | 58313: Fix concurrent access of encoders map when clearing encoders prior to switch to async. (markt)
> > | 58320: Fix concurrent access of request attributes which is possible during asynchronous processing. (markt)
> > | In preparation for implementing enhancement 57681, replace the use of the `StandardClassLoader` with `URLClassLoader`. This removes the server class loader from JMX. (markt)
> > | 58352: Always trigger a thread dump if Tomcat fails to stop gracefully from `catalina.sh` even if using `-force`. Patch provided by Alexandre Garnier. (markt)
> > | 58416: Correctly detect when a forced stop fails to stop Tomcat because the Tomcat process is waiting on some system call or is uninterruptible. (markt)
> > | 58436: Fix some rare data races in JULI's `ClassLoaderLogManager` during shutdown. (markt)

> Coyote

> > | Correct some edge cases in `RequestUtil.normalize()`. (markt)
> > | 58275: The IBM JREs accept cipher suite names starting with `TLS_` or `SSL_` but when listing the supported cipher suites only the `SSL_` version is reported. This can break Tomcat's check that at least one requested cipher suite is supported. Tomcat now includes a work-around so either form of the cipher suite name can be used when running on an IBM JRE. (markt)
> > | 58357: For reasons not currently understood when the APR/native connector is used with OpenSSL reads can return an error code when there is no apparent error. This was work-around for HTTP upgrade connections by treating this as `EAGAIN`. The same fix has now been applied to the standard HTTP connector. (markt)
> > | 57799: Remove useless sendfile check for NIO SSL. (remm)

> Jasper

> > | 57136: Correct a regression in the previous fix for this issue. `\${` should only be an escape for `${` within an EL expression. Within a JSP page `\$` should be an escape for `$`. The EL specification applies when parsing the expression delimited by `${` and `}`. Parsing of the delimiting `${` and `}` is the responsibility of the JSP specification. (markt)
> > | 58296: Fix a memory leak in the JSP unloading feature that meant that using a value other than `-1` for `maxLoadedJsps` triggered a memory leak once the limit was reached. (markt)
> > | 58340: Improve error reporting for tag files packaged in JARs. (markt)
> > | 58444: Ensure that JSPs work with any custom base class that meets the requirements defined in the JSP specification without requiring that base class to implement Tomcat specific code. (markt)

> Cluster

> > | Fix a default clusterListeners in `SimpleTcpCluster`. The optimal default value is different for each session manager. `ClusterSessionListener` is never used in `BackupManager`. (kfujino)
> > | Correct log messages in case of using `BackupManager`. (kfujino)

> WebSocket

> > | 58342: Fix a copy and paste error that meant MessageHandler removal could fail for binary and pong MessageHandlers. Patch provided by DJ. (markt)
> > | 58414: Correctly handle sending zero length messages when using per message deflate. (markt)

> Web applications

> > | Correct documentation for cluster-howto. (kfujino)

> Extras

> > | Ensure JULI adapters does not include the LogFactoryImpl class. Patch provided by Benjamin Gandon. (markt)

> Tribes

> > | Add support for configurations of `ChannelListener` and `MembershipListener` in server.xml. (kfujino)
> > | Correct log messages in case of using `ReplicatedMap`. (kfujino)

> jdbc-pool

> > | Make sure the pool has been properly configured when attributes that related to the pool size are changed via JMX. (kfujino)

Tomcat 7.0.64 (violetagg) | released 2015-08-25

> Catalina

> > | 55317: Facilitate weaving by allowing ClassFileTransformer to be added to WebappClassLoader. Patch by Nick Williams. (markt)
> > | 58031: Make the (first) reason parameter parsing failed available as a request attribute and then use it to provide a better status code via the FailedRequstFilter (if configured). (markt)
> > | 58086: Ensure that WAR URLs are handled properly when using Apache Ant for web application deployment. (violetagg)
> > | 58094: Fix cosmetic error log when using non standard non cacheable resources, like with the empty resources used in some tests. (remm)
> > | 58096: Classes loaded from `/WEB-INF/classes/` should use that directory as their code base. (markt)
> > | Fix possible resource leaks by closing streams properly. Issues reported by Coverity Scan. (violetagg)
> > | 58116: Fix a regression in the fix for 57281 that broke Comet support when running under a security manager. Based on a patch provided by Johno Crawford. (markt)
> > | 58179: Fix a thread safety issues that could mean concurrent threads setting the same attribute on a `ServletContext` could both see `null` as the old value. (markt)
> > | 58192: Correct a regression in the previous fix for 58023. Ensure that classes are associated with their manifest even if the class file is first read (and cached) without the manifest. (markt)
> > | Fix thread safety issue in the `AsyncContext` implementation that meant a sequence of `start();dispatch();` calls using non-container threads could result in a previous dispatch interfering with a subsequent start. (markt)

> Coyote

> > | 57943: Prevent the same socket being added to the cache twice. Patch based on analysis by Ian Luo / Sun Qi. (markt)
> > | Add `text/javascript,application/javascript` to the default list of compressable MIME types. (violetagg)
> > | 58103: When pipelining requests, and the previous request was an async request, ensure that the socket is removed from the waiting requests so that the async timeout thread doesn't process it during the next request. (markt)
> > | Fix a concurrency issue that meant that a change in socket timeout (e.g. when switching to asynchronous I/O) did not always take effect immediately. (markt)
> > | In the AJP and HTTP NIO connectors, ensure that the socket timeout is correctly set before adding the socket back to the poller for read. (markt)
> > | 58157: Ensure that the handling of async timeouts does not result in an unnecessary dispatch to a container thread that could result in the current socket being added to the Poller multiple times with multiple attempts to process the same event for the same socket. (markt)
> > | Correct a couple of edge cases in `RequestUtil.normalize()`. (markt)

> Jasper

> > | 58110: Like scriptlet sections, declaration sections of JSP pages have a one-to-one mapping of lines to the generated .java file. Use this information to provide more accurate error messages if a compilation error occurs in a declaration section. (markt)
> > | 58119: When tags are compiled they must be placed in the org/apache/jsp/tag/web directory. Correct a regression in the fix for 52725. (violetagg)
> > | 58178: Expressions in a tag file should use the tag file's `PageContext` rather than that of the containing page. (markt)

> WebSocket

> > | 58166: Allow applications to send close codes in the range 3000-4999 inclusive. (markt)
> > | 58232: Avoid possible NPE when adding endpoints programmatically to the `javax.websocket.server.ServerContainer`. Based on a patch provided by bastian.(violetagg)

> Web applications

> > | Correct the incorrect document of `QueryTimeoutInterceptor`. The setting value is not in milliseconds but in seconds. (kfujino)
> > | 58112: Update the documentation for using the Catalina tasks in an Apache Ant build file. (markt)
> > | Improve the Javadoc for some of the APR socket read functions that have inconsistent behaviour for return values. (markt)
> > | 58255: Document the Semaphore valve. Patch provided by Kyohei Nakamura. (markt)

> jdbc-pool

> > | Fix potential NPE in `QueryTimeoutInterceptor`. (kfujino)
> > | Add support for stopping the pool cleaner via JMX. (kfujino)
> > | The `fairness` attribute and `ignoreExceptionOnPreLoad` attribute do not allow a change via JMX. (kfujino)
> > | If the `timeBetweenEvictionRunsMillis` attribute is changed via jmx, it should restart the pool cleaner because this attribute affects the execution interval of the pool cleaner. (kfujino)
> > | Eliminate the dependence on `maxActive` of busy queues and idle queue in order to enable the expansion of the pool size via JMX. (kfujino)

> Other

> > | Update sample Eclipse IDE configuration to exclude test/webapp* and similar paths from compiler sourcepath. (kkolinko)

Tomcat 7.0.63 (violetagg) | released 2015-07-06

> Catalina

> > | 57938: Correctly handle empty form fields when a form is submitted as `multipart/form-data`, the `maxPostSize` attribute of the Connector has been set to a negative value and the Context has been configured with a value of `true` for `allowCasualMultipartParsing`. The meaning of the value zero for the `maxPostSize` has also been changed to mean a limit of zero rather than no limit to align it with `maxSavePostSize` and to be more intuitive. (markt)
> > | 54618: Add a new `HttpHeaderSecurityFilter` that adds the `Strict-Transport-Security`, `X-Frame-Options` and `X-Content-Type-Options` HTTP headers to the response. (markt)
> > | Add a workaround for issues with SPNEGO authentication when running on Java 8 update 40 and later. The workaround should be safe for earlier Java versions but it can be disabled with the `applyJava8u40Fix` attribute of the SPNEGO authenticator if necessary. (markt)
> > | 57154: Add support for web applications (Context elements) that do not have a docBase. This is primarily for use when embedding but it also fixes a rare issue when running the unit test. Patch provided by Huxing Zhang. (markt)
> > | 57959: Fixed deadlock in `org.apache.juli.FileHandler` when log is rotated. (violetagg)
> > | 57977: Correctly bind and unbind the web application class loader during execution of the PersistentValve. (markt)
> > | 58023: Fix potentially excessive memory usage due to unnecessary caching of JAR manifests in the web application class loader. (markt)
> > | 57700: Ensure that Container event `ADD_CHILD_EVENT` will be sent in all cases. (violetagg)
> > | Add configuration fields for header names in SSLValve. (remm)

> Coyote

> > | 57265: Further fix to address a potential threading issue for NIO when sendfile is used in conjunction with TLS. (markt)
> > | 57931: Ensure that TLS connections with the NIO HTTP connector that experience issues during the handshake (e.g. missing or invalid client certificate) are closed cleanly and that the client receives the correct error code rather than simply closing the connection. (markt)
> > | 57943: Added a work-around to catch `ConcurrentModificationException`s during Poller timeout processing that were causing the Poller thread to stop. The root cause of these exceptions is currently unknown. (markt)
> > | Fix possible very long (1000 seconds) timeout with APR/native connector. (markt)
> > | Support "-" separator in the SSLProtocol configuration of the APR/native connector for protocol exclusion. (rjung)

> Cluster

> > | Make sure that stream is closed after using it in `DeltaSession.applyDiff()`. (kfujino)

> WebSocket

> > | 57676: List conflicting WebSocket endpoint classes when there is a path conflict. Based upon a patch proposed by yangkun. (schultz)
> > | Extend support for the `permessage-deflate` extension to the client implementation.
> > | 57969: Provide path parameters to POJO via per session `javax.websocket.server.ServerEndpointConfig` as they vary between different requests. (violetagg)
> > | 57974: Session.getOpenSessions should return all sessions associated with a given endpoint instance, rather than all sessions from the endpoint class. (remm)

> Web applications

> > | 57282: Update request processing sequence diagrams. Updated diagrams provided by Stephen Chen. (markt)
> > | 57971: Correct the documentation for the cluster configuration setting `recoverySleepTime`. (markt)
> > | 57758: Add document of `testOnConnect` attribute in jdbc-pool doc. (kfujino)
> > | Add description of `validatorClassName` attribute to testXXXX attributes in jdbc-pool docs. (kfujino)

> Tribes

> > | Ensure that the state transfer flag is updated to true only when the map states have been transferred correctly from existing map members. (kfujino)
> > | Do not set the nodes that failed to replication to the backup nodes. Ensure that the nodes that the data has been successfully replicated are set to the backup node. (kfujino)
> > | When failed to replication, rather than all member is handled as a failed member, exclude the failure members from backup members. (kfujino)

> jdbc-pool

> > | Refactoring of the `removeOldest` method in `SlowQueryReport` to behave as expected. (kfujino)
> > | 57783: Fix `NullPointerException` in `SlowQueryReport`. To avoid this NPE, Refactor `SlowQueryReport#removeOldest` and handle the abandoned connection properly. (kfujino)

> Other

> > | Update package renamed Apache Commons BCEL to r1682271 to pick up some some code clean up. (markt)
> > | Update package renamed Apache Commons File upload to r1682322 to pick up the post 1.3.1 fixes. (markt)
> > | Update package renamed Apache Commons Codec to r1682326. No functional changes. Javadoc only. (markt)

Tomcat 7.0.62 (violetagg) | released 2015-05-14

> Catalina

> > | Allow logging of the remote port in the access log using the format pattern `%{remote}p`. (rjung)
> > | 57765: When checking last modified times as part of the automatic deployment process, account for the fact that `File.lastModified()` has a resolution of one second to ensure that if a file has been modified within the last second, the latest version of the file is always used. Note that a side-effect of this change is that files with modification times in the future are treated as if they are unmodified. (markt)
> > | Align redeploy resource modification checking with reload modification checking so that now, in both cases, a change in modification time rather than an increase in modification time is used to determine if the resource has changed. (markt)
> > | Cleanup `o.a.tomcat.util.digester.Digester` from debug messages that do not give any valuable information. Patch provided by Polina Genova. (violetagg)
> > | 57772: When reloading a web application and a directory representing an expanded WAR needs to be deleted, delete the directory after the web application has been stopped rather than before to avoid potential ClassNotFoundExceptions. (markt)
> > | 57801: Improve the error message in the start script in case the PID read from the PID file is already owned by a process. (rjung)
> > | 57824: Correct a regression in the fix for 57252 that broke request listeners for non-async requests that triggered an error that was handled by the ErrorReportingValve. (markt/violetagg)
> > | 57841: Improve error logging during web application start. (markt)
> > | 57856: Ensure that any scheme/port changes implemented by the `RemoteIpFilter` also affect `HttpServletResponse.sendRedirect()`. (markt)
> > | 57896: Support defensive copying of "cookie" header so that unescaping double quotes in a cookie value does not corrupt original value of "cookie" header. This is an opt-in feature, enabled by `org.apache.tomcat.util.http.ServerCookie.PRESERVE_COOKIE_HEADER` or `org.apache.catalina.STRICT_SERVLET_COMPLIANCE` system property. (kkolinko)

> Coyote

> > | 57779: When an I/O error occurs on a non-container thread only dispatch to a container thread to handle the error if using Servlet 3+ asynchronous processing. This avoids potential deadlocks if an application is performing I/O on a non-container thread without using the Servlet 3+ asynchronous API. (markt)
> > | 57833: When using JKS based keystores for NIO, ensure that the key alias is always converted to lower case since that is what JKS key stores expect. Based on a patch by Santosh Giri Govind M. (markt)
> > | 57837: Add `text/css` to the default list of compressable MIME types. (markt)

> Jasper

> > | 57845: Ensure that, if the same JSP is accessed directly and via a `<jsp-file>` declaration in web.xml, updates to the JSP are visible (subject to the normal rules on re-compilation) regardless of how the JSP is accessed. (markt)
> > | 57855: Explicitly handle the case where a `MethodExpression` is invoked with null or the wrong number of parameters. Rather than failing with an `ArrayIndexOutOfBoundsException` or a `NullPointerException` throw an `IllegalArgumentException` with a useful error message. (markt)

> Cluster

> > | Add new attribute that send all actions for session across Tomcat cluster nodes. (kfujino)
> > | Remove unused `pathname` attribute in mbean definition of `BackupManager`. (kfujino)
> > | 57338: Improve the ability of the ClusterSingleSignOn valve to handle nodes being added and removed from the Cluster at run time. (markt)
> > | Avoid unnecessary call of `DeltaRequest.addSessionListener()` in non-primary nodes. (kfujino)

> WebSocket

> > | 57762: Ensure that the WebSocket client correctly detects when the connection to the server is dropped. (markt)
> > | 57776: Revert the 8.0.21 fix for the `permessage-deflate` implementation and incorrect op-codes since the fix was unnecessary (the bug only affected trunk) and the fix broke rather than fixed `permessage-deflate` if an uncompressed message was converted into more than one compressed message. (markt)
> > | Fix log name typo in `WsRemoteEndpointImplServer` class, caused by a copy-paste. (markt/kkolinko)
> > | 57788: Avoid NPE when looking up a class hierarchy without finding anything. (remm)
> > | Make WebSocket client more robust when handling errors during the close of a WebSocket session. (markt)

> Web applications

> > | 57759: Add information to the keyAlias documentation to make it clear that the order keys are read from the keystore is implementation dependent. (markt)
> > | 57864: Update the documentation web application to make it clearer that hex values are not valid for cluster send options. Based on a patch by Kyohei Nakamura. (markt)

> Tribes

> > | Fix a concurrency issue when a backup message that has all session data and a backup message that has diff data are processing at the same time. This fix ensures that `MapOwner` is set to `ReplicatedMapEntry`. (kfujino)
> > | Clarify the handling of Copy message and Copy nodes. (kfujino)
> > | Copy node does not need to send the entry data. It is enough to send only the node information of the entry. (kfujino)
> > | `ReplicatedMap` should send the Copy message when replicating. (kfujino)
> > | Fix behavior of `ReplicatedMap` when member has disappeared. If map entry is primary, rebuild the backup members. If primary node of map entry has disappeared, backup node is promoted to primary. (kfujino)
> > | When a map member has been added to `ReplicatedMap`, make sure to add it to backup nodes list of all other members. (kfujino)

Tomcat 7.0.61 (violetagg) | released 2015-04-07

> Catalina

> > | 55988: Correct the check used for Java 8 JSSE server-preferred TLS cipher suite ordering. Ensure that SSL parameters are provided to `SSLServerSocket` and `SSLEngine`. Patch provided by Ognjen Blagojevic. (violetagg)

> WebSocket

> > | 57761: Ensure that the opening HTTP request is correctly formatted when the WebSocket client connects to a server root. (remm)

Tomcat 7.0.60 (violetagg) | not released

> Catalina

> > | Clarify threaded usage of variables by removing volatile marker in NonceInfo. Issue reported by Coverity Scan. (fschumacher)
> > | 49785: Enable StartTLS connections for JNDIRealm. (fschumacher)
> > | 55988: Add support for Java 8 JSSE server-preferred TLS cipher suite ordering. This feature requires Java 8 and is controlled by `useServerCipherSuitesOrder` attribute on an HTTP connector. Based upon patches provided by Ognjen Blagojevic. (schultz)
> > | 56438: Add logging that reports when a JAR is scanned for TLDs but nothing is found so that Tomcat may be configured to skip this JAR in future. Based on a patch by VIN. (markt)
> > | 56848: Use `Locale.forLanguageTag` to process Locale headers when running on a Java 7 or later JRE. (markt)
> > | 57021: Improve logging in AprLifecycleListener and jni.Library when Tomcat-Native DLL fails to load. Based on a patch by Pravallika Peddi. (markt/kkolinko)
> > | 57180: Further fixes to support the use of arbitrary HTTP methods with the CORS filter. (markt)
> > | Warn about problematic setting of appBase. (fschumacher)
> > | 57534: CORS Filter should only look at media type component of Content-Type request header. (markt)
> > | Ensure that user name checking in the optional SecurityListener is case-insensitive (as documented) and than the case-insensitive comparison is performed using the system default Locale. (markt)
> > | When docBase refers internal war and unpackWARs is set to false, avoid registration of the invalid redeploy resource that has been added ".war" extension in duplicate. (kfujino)
> > | If WAR exists, it is not necessary to trigger a reload when adding a Directory. (kfujino)
> > | 56608: When deploying an external WAR, add watched resources in the expanded directory based on whether the expanded directory is expected to exist rather than if it does exist.
> > | When triggering a reload due to a modified watched resource, ensure that multiple changed watched resources only trigger one reload rather than a series of reloads.
> > | 57601: Ensure that HEAD requests return the correct content length (i.e. the same as for a GET) when the requested resource includes a resource served by the Default servlet. (jboynes/markt)
> > | 57602: Ensure that HEAD requests return the correct content length (i.e. the same as for a GET) when the requested resource includes a resource served by a servlet that extends `HttpServlet`. (markt)
> > | 57621: When an async request completes, ensure that any remaining request body data is swallowed. (markt)
> > | 57637: Do not create unnecessary sessions when using PersistentValve. (jboynes/fschumacher)
> > | 57645: Correct a regression in the fix for 57190 that incorrectly required the path passed to `ServletContext.getContext(String)` to be an exact match to a path to an existing context. (markt)
> > | Make sure that `unpackWAR` attribute of `Context` is handled correctly in `HostConfig`. (kfujino)
> > | When deploying a WAR file that contains a context.xml file and `unpackWARs` is `false` ignore any context.xml file that may exist in an expanded directory associated with the WAR. (markt)
> > | 57675: Correctly quote strings when using the extended access log. (markt)
> > | 57704: Fix potential NPEs during web application start/stop when `org.apache.tomcat.InstanceManager` is not initialized. (violetagg)
> > | Add support for `LAST_ACCESS_AT_START` system property to `SingleSignOn`. (kfujino)
> > | 57723: Ensure that the Context name and path remain consistent when adding a web application to an embedded Tomcat instance via `Tomcat.addWebapp(Host,String,String,String)`. (markt)
> > | 57724: Handle the case in the CORS filter where a user agent includes an origin header for a non-CORS request. (markt)
> > | Refactor Authenticator implementations to reduce code duplication. (markt)
> > | When searching for SCIs `o.a.catalina.Context.getParentClassLoader` will be used instead of `java.lang.ClassLoader.getParent`. Thus one can provide the correct parent class loader when running embedded Tomcat in other environments such as OSGi. (violetagg)

> Coyote

> > | 57509: Improve length check when writing HTTP/1.1 response headers: reserve space for 4 extra bytes. (kkolinko)
> > | 57540: Make TLS/SSL protocol available in a new request attribute (`org.apache.tomcat.util.net.secure_protocol_version`). (Note that AJP connectors will require `mod_jk` 1.2.41 or later, or an as-yet-unknown version of mod_proxy_ajp, or configure the proxy to send the AJP_SSL_PROTOCOL request attribute to Tomcat. Please see the bug comments for details.) Based upon a patch provided by Ralf Hauser. (schultz)
> > | 57544: Fix potential infinite loop when preparing a kept alive HTTP connection for the next request. (markt)
> > | 57546: Ensure that a dropped network connection does not leave references to the UpgradeProcessor associated with the connection in memory. (markt)
> > | 57570: Make the processing of trailer headers with chunked input optional and disabled by default. (markt)
> > | When applying the `maxSwallowSize` limit to a connection read that many bytes first before closing the connection to give the client a chance to read the response. (markt)
> > | Prevent an async timeout being processed multiple times for the same socket when running on slow and/or heavily loaded systems. (markt)
> > | 57581: Change statistics byte counter in coyote Request object to be long to allow values above 2Gb. (kkolinko)
> > | Fix a concurrency issue in the APR Poller that meant it was possible under low load for a socket queued to be added to the Poller not to be added for 10 seconds. (markt)
> > | 57638: Avoid an IllegalArgumentException when an AJP request body chunk larger than the socket read buffer is being read. This typically requires a larger than default AJP packetSize. (markt)
> > | 57674: Avoid a BufferOverflowException when an AJP response body chunk larger than the socket write buffer is being written. This typically requires a larger than default AJP packetSize. (markt)
> > | Refactor Connector authentication (only used by AJP) into a separate method. (markt)
> > | 57708: Implement a new feature for AJP connectors - Tomcat Authorization. If the new tomcatAuthorization attribute is set to `true` (it is disabled by default) Tomcat will take an authenticated user name from the AJP protocol and use the appropriate Realm for the request to authorize (i.e. add roles) to that user. (markt)
> > | Fix an issue that meant that any pipe-lined data read by Tomcat before an asynchronous request completed was lost during the completion of the asynchronous request. This mean that the pipe-lined request(s) would be lost and/or corrupted. (markt)
> > | Update the minimum recommended version of the Tomcat Native library (if used) to 1.1.33. (markt)

> Jasper

> > | 57136: Ensure only `\${` and `\#{` are treated as escapes for `${` and `#{` rather than `\$` and `\#` being treated as escapes for `$` and `#` when processing literal expressions in expression language. (markt)
> > | 57148: When coercing an object to a given type and a `PropertyEditor` has been registered for the type correctly coerce the empty string to `null` if the `PropertyEditor` throws an exception. (kkolinko/markt)

> Cluster

> > | Remove unnecessary method that always returns true. The domain filtering works on `DomainFilterInterceptor`. (kfujino)

> WebSocket

> > | Correct a bug in the `permessage-deflate` implementation that meant that the incorrect op-codes were used if an uncompressed message was converted into more than one compressed message. (markt)

> Web applications

> > | Fix possible resource leaks by closing streams properly. Issues reported by Coverity Scan. (fschumacher)
> > | 56058: Add links to the AccessLogValve documentation for configuring reverse proxies and/or Tomcat to ensure that the desired information is used entered in the access log when Tomcat is running behind a reverse proxy. (markt)
> > | 57503: Make clear that the JULI integration for log4j only works with log4j 1.2.x. (markt)
> > | Remove incorrect note from context configuration page in the documentation web application that stated WAR files located outside the appBase were never unpacked. (markt)
> > | 57644: Update examples to use Apache Standard Taglib 1.2.5. (jboynes)
> > | 57683: Ensure that if a client aborts their connection to the stock ticker example (the only way a client can disconnect), the example continues to work for existing and new clients. (markt)
> > | Correct the documentation for deployOnStartup to make clear that if a WAR file is updated while Tomcat is stopped and unpackWARs is true, Tomcat will not detect the changed WAR file when it starts and will not replace the unpacked WAR file with the contents of the updated WAR. (markt)

> Extras

> > | 57377: Remove the restriction that prevented the use of SSL when specifying a bind address with the JMXRemoteLifecycleListener. Also enable SSL to be configured for the registry as well as the server. (markt)

> Tribes

> > | Make sure that refuse the messages from a different domain in `DomainFilterInterceptor`. (kfujino)

> Other

> > | Enhance bean factory used for JNDI resources. New attribute `forceString` allows to support non-standard string argument property setters. (rjung)
> > | Fix `TestAbstractAjpProcessor` unit test failures on Windows. (kkolinko)
> > | Guard the digester from MbeansDescriptorsDigesterSource with its own lock object. (fschumacher)
> > | 57558: Add missing JAR in Ant task definition required by the validate task. (markt/kkolinko)
> > | List names of Testsuites that have failed or skipped tests when running tests with Ant. (kkolinko)
> > | 57703: Update the `http-method` definition for web applications using a Servlet 2.5 descriptor as per Servlet 2.5 MR 6. (markt)
> > | Update to Tomcat Native Library version 1.1.33 to pick up the Windows binaries that are based on OpenSSL 1.0.1m and APR 1.5.1. (markt)

Tomcat 7.0.59 (violetagg) | released 2015-02-04

> Jasper

> > | 57504: Initialize TLD locations cache when creating the ServletContext. (jboynes)

> Tribes

> > | Fix a possible deadlock when receiver thread invokes `mapMemberAdded()` while ping thread invokes `memberAlive()`. (kfujino)

Tomcat 7.0.58 (violetagg) | not released

> Catalina

> > | 57173: Revert the fix for 56953 that broke annotation scanning in some cases. (markt)
> > | 57178: The CORS filter now treats `null` as a valid origin that matches `*`. Patch provided by Gregor Zurowski. (markt)
> > | 57180: Do not limit the CORS filter to only accepting requests that use an HTTP method defined in RFC 7231. (markt)
> > | 57190: Fix `ServletContext.getContext(String)` when parallel deployment is used so that the correct ServletContext is returned. (markt)
> > | 57208: Prevent NPE in JNDI Realm when no results are found in a directory context for a user with specified user name. Based on a patch provided by Jason McIntosh. (violetagg)
> > | 57209: Add a new attribute, userSearchAsUser to the JNDI Realm. (markt)
> > | 57215: Ensure that the result of calling `HttpServletRequest.getContextPath()` is neither decoded nor normalized as required by the Servlet specification. (markt)
> > | 57216: Improve handling of invalid context paths. A context path should either be an empty string or start with a `'/'` and do not end with a `'/'`. Invalid context path are automatically corrected and a warning is logged. The `null` and `"/"` values are now correctly changed to `""`. (markt/kkolinko)
> > | Correct message that is logged when load-on-startup servlet fails to load. It was logging a wrong name. (kkolinko)
> > | 57239: Correct several message typos. Includes patch by vladk. (kkolinko)
> > | Make the session id generator extensible by adding a `SessionIdGenerator` interface, an abstract base class and a standard implementation. (rjung)
> > | Back-port clarification from Servlet 3.1 specification that during async processing an `IllegalStateException` should be thrown if `getRequest()` or `getResponse()` is called after `complete()` or `dispatch()`. (markt)
> > | Fix a concurrency issue in async processing. Ensure that a non-container thread can not change the async state until the container thread has completed. (markt)
> > | 57252: Provide application configured error pages with a chance to handle an async error before the built-in error reporting. (markt)
> > | 57281: Enable non-public Filter and Servlet classes to be configured programmatically via the Servlet 3.0 API and then used without error when running under a SecurityManager. (markt)
> > | 57308: Remove unnecessary calls to `System.getProperty()` where more suitable API calls are available. (markt)
> > | Add unit tests for RemoteAddrValve and RemoteHostValve. (rjung)
> > | Allow to configure RemoteAddrValve and RemoteHostValve to adopt behavior depending on the connector port. Implemented by optionally adding the connector port to the string compared with the patterns `allow` and `deny`. Configured using `addConnectorPort` attribute on valve. (rjung)
> > | Optionally trigger authentication instead of denial in RemoteAddrValve and RemoteHostValve. This only works in combination with `preemptiveAuthentication` on the application context. Configured using `invalidAuthenticationWhenDeny` attribute on valve. (rjung)
> > | Prevent file descriptors leak and ensure that files are closed after retrieving the last modification time. (violetagg)
> > | 57326: Enable `AsyncListener` implementations to re-register themselves during `AsyncListener.onStartAsync`. (markt)
> > | 57331: Allow ExpiresFilter to use "year" as synonym for "years" in its configuration. (kkolinko)
> > | Improve SnoopServlet in unit tests. (rjung)
> > | Add RequestDescriptor class to unit tests. Adjust TestRewriteValve to use RequestDescriptor. (rjung)
> > | Add more AJP unit tests. (rjung)
> > | 57363: Log to stderr if LogManager is unable to read configuration files rather than swallowing the exception silently. (markt)
> > | 57420: Make UEncoder a local variable in DirContextURLConnection to make it threadsafe. Based on ideas from kkolinko and violetagg. (fschumacher)
> > | 57425: Don't add attributes with null value or name to the replicated context. (fschumacher)
> > | 57431: Enable usage of custom class for context creation when using embedded tomcat. (fschumacher)
> > | 57446: Ensure that `ServletContextListener`s that have limited access to `ServletContext` methods are called with the same `ServletContext` instance for both `contextInitialized()` and `contextDestroyed()`. (markt)
> > | 57461: When an instance of `org.apache.catalina.startup.VersionLoggerListener` logs the result of `System.getProperty("java.home")` don't report it in a manner that makes it look like the `JAVA_HOME` environment variable. (markt)
> > | While closing streams for given resources ensure that if an exception happens it will be handled properly. Issue is reported by Coverity Scan. (violetagg)
> > | Change Response to use UEncoder instances with shared safeChars. (fschumacher)
> > | Allow `VersionLoggerListener` to log all system properties. This feature is off by default. (kkolinko)

> Coyote

> > | 57234: Make SSL protocol filtering to remove insecure protocols case insensitive. (markt)
> > | 57265: Fix some potential concurrency issues with sendFile and the NIO connector. (markt)
> > | 57324: If the client uses `Expect: 100-continue` and Tomcat responds with a non-2xx response code, Tomcat also closes the connection. If Tomcat knows the connection is going to be closed when committing the response, Tomcat will now also send the `Connection: close` response header. (markt)
> > | 57340: When using Comet, ensure that Socket and SocketWrapper are only returned to their respective caches once on socket close (it is possible for multiple threads to call close concurrently). (markt)
> > | 57446: Ensure that `ServletContextListener`s that have limited access to `ServletContext` methods are called with the same `ServletContext` instance for both `contextInitialized()` and `contextDestroyed()`. (markt)

> Jasper

> > | CVE-2014-7810: Do not use a privileged code block when evaluating EL expressions when running under a security manager, which allowed to bypass code restrictions. (markt)
> > | Fix an issue with BeanELResolver when running under a security manager. Some classes may not be accessible but may have accessible interfaces. (markt)
> > | 57316: Fix JspC when directory name contains a character sequence that appears to be URL encoded. (markt)

> Cluster

> > | In order to enable define in `Cluster` element, `ClusterSingleSignOn` implements `ClusterValve`. (kfujino)
> > | Fix mbean descriptor of `ClusterSingleSignOn`. (kfujino)
> > | 57473: Add sanity check to FarmWebDeployer's WarWatcher to detect suspected incorrect permissions on the watch directory. (schultz)

> WebSocket

> > | Correct multiple issues with the flushing of batched messages that could lead to duplicate and/or corrupt messages. (markt)
> > | Correctly implement headers case insensitivity. (markt/remm)
> > | Allow optional use of user extensions. (remm)
> > | Allow using partial binary message handlers. (remm)
> > | Limit ping/pong message size. (remm)
> > | Allow configuration of the time interval for the periodic event. (remm)
> > | More accurate annotations processing. (remm)
> > | Allow optional default for origin header in the client. (remm)
> > | 57490: Make it possible to use Tomcat's WebSocket client within a web application when running under a SecurityManager. Based on a patch by Mikael Sterner. (markt)
> > | Add some debug logging to the WebSocket session to track session creation and session closure. (markt)

> Web applications

> > | Update documentation for CGI servlet. Recommend to copy the servlet declaration into web application instead of enabling it globally. Correct documentation for cgiPathPrefix. (kkolinko)
> > | Improve HTML version of build instructions and align with BUILDING.txt. Document creating second Eclipse project to compile WebSocket classes with Java 7 (`ide-eclipse-websocket` target added in 7.0.56). (kkolinko)
> > | Improve Tomcat Manager documentation. Rearrange, add section on HTML GUI, document /expire command and Server Status page. (kkolinko)
> > | Fix ambiguity of section links on Valves configuration reference page. (kkolinko)
> > | 57238: Update information on SSL/TLS on Security and SSL documentation pages. Based on patch by Glen Peterson. (kkolinko)
> > | 57261: Add vminfo and threaddump commands to Manager application. Implement `VminfoTask` and `ThreaddumpTask` Ant tasks. (kkolinko)
> > | 57323: Correct display of outdated sessions in sessions count listing in Manager application. (kkolinko)
> > | Add document of `ClusterSingleSignOn`. (kfujino)
> > | Clarify documentation for `useBodyEncodingForURI` attribute of a connector. (kkolinko)

> Other

> > | When downloading required libraries at build time, use random name for temporary file and automatically create destination directory (`base.path`). (kkolinko)
> > | Update optional Checkstyle library to 6.1.1. (kkolinko)
> > | Simplify `setproxy` task in `build.xml`. Taskdef there is not needed since Ant 1.8.2. (kkolinko)
> > | Improve Java 7 support in `build.xml`. Check whether the specified ${java.7.home} is valid. By default use Java that runs Ant (${java.home}) instead of the one found on $PATH to run JUnit tests. (kkolinko)
> > | 57344: Provide sha1 checksum files for Tomcat downloads. Correct filename patterns for apache-tomcat-*-embed.tar.gz archive to exclude an *.asc file. (kkolinko)

Tomcat 7.0.57 (violetagg) | released 2014-11-11

> Catalina

> > | 47919: Extend the information logged when Tomcat starts to optionally log the values of command line arguments (enabled by default) and environment variables (disabled by default). Note that the values added to CATALINA_OPTS and JAVA_OPTS environment variables will be logged, as they are used to build up the command line. (markt)
> > | 56401: Log version information when Tomcat starts. (markt/kkolinko)
> > | 57022: Ensure SPNEGO authentication continues to work with the JNDI Realm using delegated credentials with recent Oracle JREs. (markt)
> > | Correct a couple of NPEs in the JNDI Realm that could be triggered with when not specifying a roleBase and enabling roleSearchAsUser. (markt)
> > | Remove the unnecessary registration of context.xml as a redeploy resource. The context.xml having an external docBase has already been registered as a redeploy resources at first. (kfujino)
> > | Improve the previous fix for 56401. Avoid logging version information in the constructor since it then gets logged at undesirable times such as when using `StoreConfig`. (markt)
> > | 57105: When parsing web.xml do not limit the buffer element of the jsp-property-group element to integer values as the allowed values are `<number>kb` or `none`. (markt)
> > | Update the minimum required version of the Tomcat Native library (if used) to 1.1.32. (markt)
> > | 57144: Improve ClientAbortException to provide non-null message. (kkolinko)
> > | AsyncContext should remain usable until fireOnComplete is called. (remm)
> > | AsyncContext createListener should wrap any instantiation exception using a ServletException. (remm)

> Coyote

> > | 53952: Add support for TLSv1.1 and TLSv1.2 for APR connector. Based upon a patch by Marcel Šebek. This feature requires Tomcat Native library 1.1.32 or later. (schultz/jfclere)
> > | Disable SSLv3 by default for JSSE based HTTPS connectors (BIO and NIO). The change also ensures that SSLv2 is disabled for these connectors although SSLv2 should already be disabled by default by the JRE. (markt)
> > | Disable SSLv3 by default for the APR/native HTTPS connector. (markt)
> > | Do not increase remaining counter at end of stream in IdentityInputFilter. (kkolinko)
> > | Async state MUST_COMPLETE should still be started. (remm)

> Jasper

> > | 57099: Ensure that semi-colons are not permitted in JSP import page directives. (markt)

> Cluster

> > | Avoid possible integer overflows reported by Coverity Scan. (fschumacher)

> WebSocket

> > | 57054: Correctly handle the case in the WebSocket client when the HTTP response to the upgrade request can not be read in a single pass; either because the buffer is too small or the server sent the response in multiple packets. (markt)
> > | Fix client subprotocol handling. (remm)
> > | Add null checks for arguments in remote endpoint. (remm/kkolinko)
> > | 57091: Work around the behaviour of the Oracle JRE when creating new threads in an applet environment that breaks the WebSocket client implementation. Patch provided by Niklas Hallqvist. (markt)
> > | 57118: Ensure that an `EncodeException` is thrown by `RemoteEndpoint.Basic.sendObject(Object)` rather than an `IOException` when no suitable `Encoder` is configured for the given Object. (markt)

> Web applications

> > | Correct documentation for `ServerCookie.ALLOW_NAME_ONLY` system property. (kkolinko)
> > | 57049: Clarified that `jvmRoute` can be set in `<Engine>`'s `jvmRoute` or in a system property. (schultz)
> > | Correct version of Java WebSocket mentioned in documentation (s/1.0/1.1/). (markt/kkolinko)
> > | In examples web application move Async and Comet examples from JSP to Servlet examples page. (kkolinko)
> > | Suppress timestamp comments and enable charset header in Javadoc. (kkolinko)

> jdbc-pool

> > | 57079: Use Tomcat version number for jdbc-pool module when building and shipping the module as part of Tomcat. (markt/kkolinko)
> > | Fix broken overview page in javadoc generated via "javadoc" task in jdbc-pool build.xml file. (kkolinko)

> Other

> > | 56079: The Apache Tomcat Windows service and the Apache Tomcat Windows service monitor application are now digitally signed. (markt)
> > | Fix timestamps in Tomcat build and jdbc-pool to use 24-hour format instead of 12-hour one and use UTC timezone. (markt/kkolinko)
> > | Improve Tomcat build script to ensure that only one ecj-nn.jar file is present in Tomcat `lib` directory when Eclipse JDT Compiler is updated to a new version. (kkolinko)
> > | 56596: Update to Tomcat Native Library version 1.1.32 to pick up the Windows binaries that are based on OpenSSL 1.0.1j and APR 1.5.1. (markt)
> > | In Tomcat tests: log name of the current test method at start time. (kkolinko)

Tomcat 7.0.56 (violetagg) | released 2014-10-06

> Catalina

> > | When scanning class files (e.g. for annotations) and reading the number of parameters in a `MethodParameters` structure only read a single byte (rather than two bytes) as per the JVM specification. Patch provided by Francesco Komauli. (markt)
> > | Allow the JNDI Realm to start even if the directory is not available. The directory not being available is not fatal once the Realm is started and it need not be fatal when the Realm starts. Based on a patch by Cédric Couralet. (markt)
> > | 56736: Avoid an incorrect `IllegalStateException` if the async timeout fires after a non-container thread has called `AsyncContext.dispatch()` but before a container thread starts processing the dispatch. (markt)
> > | 56739: If an application handles an error on an application thread during asynchronous processing by calling `HttpServletResponse.sendError()`, then ensure that the application is given an opportunity to report that error via an appropriate application defined error page if one is configured. (markt)
> > | 56771: When lookup for a resource in all the alternate or backup `javax.naming.directory.DirContext`, `javax.naming.NameNotFoundException` will be thrown at the end of the search if the resource is not available in these alternate or backup `javax.naming.directory.DirContext`. Based on a patch by Sheldon Shao. (violetagg)
> > | 56796: Remove unnecessary sleep when stopping a web application. (markt)
> > | 56801: Improve performance of `org.apache.tomcat.util.file.Matcher` which is to filter JARs for scanning during web application start. Based on a patch by Sheldon Shao. (kkolinko)
> > | 56825: Enable pre-emptive authentication to work with the SSL authenticator. Based on a patch by jlmonteiro. (markt)
> > | 56857: Fix thread safety issue when calling ServletContext methods while running under a security manager. (markt)
> > | 56882: Add testcase for processing of forwards and includes when Context have been reloaded. (kkolinko)
> > | 56900: Fix some potential resource leaks when reading property files reported by Coverity Scan. Based on patches provided by Felix Schumacher. (markt)
> > | 56902: Fix a potential resource leak in the Default Servlet reported by Coverity Scan. Based on a patch provided by Felix Schumacher. (markt)
> > | 56903: Correct the return value for `StandardContext.getResourceOnlyServlets()` so that multiple names are separated by commas. Identified by Coverity Scan and fixed based on a patch by Felix Schumacher. (markt)
> > | Fixed the multipart elements merge operation performed during web application deployment. Identified by Coverity Scan. (violetagg)
> > | Correct the information written by `ExtendedAccessLogValve` when a format token x-O(XXX) is used so that multiple values for a header XXX are separated by commas. Identified by Coverity Scan. (violetagg)
> > | Fix a potential resource leak when reading MANIFEST.MF file for extension dependencies reported by Coverity Scan. (violetagg)
> > | Correctly handle multiple `accept-language` headers rather than just using the first header to determine the user's preferred Locale. (markt)
> > | Fix some potential resource leaks when reading properties, files and other resources. Reported by Coverity Scan. (violetagg)
> > | When using parallel deployment and `undeployOldVersions` feature is enabled on a Host, correctly undeploy context of old version. Make sure that Tomcat does not undeploy older Context if current context is not running. (kfujino)
> > | When deploying war, add XML file in the config base to the redeploy resources if war does not have META-INF/context.xml or `deployXML` is false. If XML file is created in the config base, redeploy will occur. (kfujino)
> > | Various changes to reduce unnecessary code in Tomcat's copy of Apache Commons BCEL to reduce the time taken for annotation scanning when web applications start. Includes contributions from kkolinko and hzhang9. (markt)
> > | 56938: Ensure web applications that have mixed case context paths and are deployed as directories are correctly removed on undeploy when running on a case sensitive file system. (markt)
> > | 57004: Add `stuckThreadCount` property to `StuckThreadDetectionValve`'s JMX bean. Patch provided by Jiří Pejchal. (schultz)
> > | 57011: Ensure that the request and response are correctly recycled when processing errors during async processing. (markt)
> > | 57016: When using the `PersistentValve` do not remove sessions from the store when persisting them. (markt)

> Coyote

> > | 56780: Enable Tomcat to start when using SSL with an IBM JRE in strict SP800-131a mode. (markt)
> > | 56910: Prevent the invalid value of `-1` being used for `maxConnections` with APR connectors. (markt)
> > | Ensure that `AjpNioProtocol` and `AjpAprProtocol` enable the `KeepAliveTimeout`. (kfujino)

> Jasper

> > | 43001: Enable the JspC Ant task to set the JspC option `mappedFile`. (kkolinko)
> > | 56797: When matching a method in an EL expression, do not treat bridge methods as duplicates of the method they bridge to. In this case always call the target of the bridge method. (markt)
> > | Correct a logic error in the `JasperElResolver`. There was no functional impact but the code was less efficient as a result of the error. Based on a patch by martinschaef. (markt)
> > | Ensure that the implementation of `javax.servlet.jsp.PageContext.include(String)` and `javax.servlet.jsp.PageContext.include(String, boolean)` will throw `IOException` when an I/O error occur during the operation. (violetagg)
> > | 56908: Fix some potential resource leaks when reading jar files. Reported by Coverity Scan. Based on patch provided by Felix Schumacher. (violetagg)
> > | 56991: Deprecate the use of a request attribute to pass a <jsp-file> declaration to Jasper and prevent an infinite loop if this technique is used in conjunction with an include. (markt)
> > | Fix a potential resource leak in JDTCompiler when checking whether a resource is a package. Reported by Coverity Scan. (fschumacher)

> WebSocket

> > | 56446: Clearer handling of exceptions when calling a method on a POJO based WebSocket endpoint. Based on a suggestion by Eugene Chung. (markt)
> > | 56746: Allow secure WebSocket client threads to use the current context class loader rather than explicitly setting it to the class loader that loaded the WebSocket implementation. This allows WebSocket client connections from within web applications to access, amongst other things, the JNDI resources associated with the web application. (markt)
> > | 56905: Make destruction on web application stop of thread group used for WebSocket connections more robust. (kkolinko/markt)
> > | 56907: Ensure that client IO threads are stopped if a secure WebSocket client connection fails. (markt)
> > | When a WebSocket client attempts to write to a closed connection, handle the resulting `IllegalStateException` in a manner consistent with the handling of an `IOException`. (markt)
> > | Add support for the `permessage-deflate` extension. This is currently limited to decompressing incoming messages on the server side. It is expected that support will be extended to outgoing messages and to the client side shortly. (markt)
> > | Extend support for the `permessage-deflate` extension to compression of outgoing messages on the server side. (markt)
> > | 56982: Return the actual negotiated extensions rather than an empty list for `Session.getNegotiatedExtensions()`. (markt)
> > | Update the WebSocket implementation to support the Java WebSocket specification version 1.1. (markt)

> Web applications

> > | Correct the label in the list of sessions by idle time for the bin that represents the idle time immediately below the maximum permitted idle time when using the expire command of the Manager application. (markt)
> > | Update the Windows authentication documentation after some additional testing to answer the remaining questions. (markt)
> > | Correct a couple of broken links in the Javadoc. (markt)

> Other

> > | 56788: Display the full version in the list of installed applications when installed via the Windows installer package. Patch provided by Alexandre Garnier. (markt)
> > | 56829: Add the ability for users to define their own values for `_RUNJAVA` and `_RUNJDB` environment variables. Be more strict with executable filename on Windows (s/java/java.exe/). Based on a patch by Neeme Praks. (markt/kkolinko)
> > | 56895: Correctly compose `JAVA_OPTS` in `catalina.bat` so that escape sequences are preserved. Patch by Lucas Theisen. (markt)
> > | 56988: Allow to use relative path in `base.path` setting when building Tomcat. (kkolinko)
> > | 56990: Ensure that the `ide-eclipse` build target downloads all the libraries required by the default Eclipse configuration files and configures Eclipse to use Java 6 for the project. Add build target `ide-eclipse-websocket` that creates a separate linked project that compiles websocket classes of Tomcat 7 with Java 7 compiler. (kkolinko)

Tomcat 7.0.55 (violetagg) | released 2014-07-27

> Catalina

> > | 44312: Log an error if there is a conflict between Host and Alias names. Improve host management methods in `Mapper` to avoid occasionally removing a wrong host. Check that host management operations are performed on the host and not on an alias. (kkolinko)
> > | 55282: Ensure that one and the same application listener is added only once when starting the web application. (violetagg)
> > | 56461: New `failCtxIfServletStartFails` attribute on Context and Host configuration to force the context startup to fail if a load-on-startup servlet fails its startup. (slaurent)
> > | 56526: Improved the `StuckThreadDetectionValve` to optionally interrupt stuck threads to attempt to unblock them. (slaurent)
> > | 56545: Pre-load an additional class, the loading of which may otherwise be triggered by a web application which in turn would trigger an exception when running under a security manager. (kkolinko)
> > | 56578: Correct regression in the fix for 56339 that prevented sessions from expiring when using clustering. (markt)
> > | 56588: Update deprecation of Context.addApplicationListener() methods according to changes in Tomcat 8. (kkolinko)
> > | 56600: In WebdavServlet: Do not waste time generating response for broken PROPFIND request. (kkolinko)
> > | Provide a better error message when asynchronous operations are not supported by a filter or servlet. Patch provided by Romain Manni-Bucau. (violetagg)
> > | 56606: User entries in `tomcat-users.xml` file are recommended to use "username" attribute rather than legacy "name" attribute. Fix inconsistencies in Windows installer, examples. Update digester rules and documentation for `MemoryRealm`. (markt/kkolinko)
> > | 56611: Refactor code to remove inefficient calls to `Method.isAnnotationPresent()`. Based on a patch by Jian Mou. (markt/kkolinko)
> > | 56653: Fix concurrency issue with lists of contexts in `Mapper` when stopping Contexts. (kkolinko)
> > | 56657: When using parallel deployment, if the same session id matches different versions of a web application, prefer the latest version. Ensure that remapping selects the version that we expect. (kkolinko)
> > | Assert that mapping result object is empty before performing mapping work in `Mapper`. (kkolinko)
> > | 56658: Avoid delay between registrations of mappings for context and for its servlets. (kkolinko)
> > | 56665: Correct the generation of the effective web.xml when elements contain an empty string as value. (violetagg)
> > | 56666: When clearing the SSO cookie use the same values for domain, path, httpOnly and secure as were used to set the SSO cookie. (markt)
> > | 56677: Ensure that `HttpServletRequest.getServletContext()` returns the correct value during a cross-context dispatch. (markt)
> > | 56684: Ensure that Tomcat does not shut down if the socket waiting for the shutdown command experiences a `SocketTimeoutException`. (markt)
> > | When the current PathInfo is modified as a result of dispatching a request, ensure that a call to `HttpServletRequest.getPathTranslated()` returns a value that is based on the modified PathInfo. (markt)
> > | 56698: When persisting idle sessions, only persist newly idle sessions. Patch provided by Felix Schumacher. (markt)
> > | 56710: Do not map requests to servlets when context is being reloaded. (kkolinko)
> > | 56712: Fix session idle time calculations in `PersistenceManager`. (kkolinko)
> > | 56717: Fix duplicate registration of `MapperListener` during repeated starts of embedded Tomcat. (kkolinko)
> > | 56724: Write an error message to Tomcat logs if container background thread is aborted unexpectedly. (kkolinko)

> Coyote

> > | 56518: When using NIO, do not attempt to write to the socket if the thread is marked interrupted as this will lead to a connection limit leak. This fix was based on analysis of the issue by hanyong. (markt)
> > | 56521: Re-use the asynchronous write buffer between writes to reduce allocation and GC overhead. Based on a patch by leonzhx. Also make the buffer size configurable and remove copying of data within buffer when the buffer is only partially written on a subsequent write. (markt)
> > | Correct a copy/paste error and return a 500 response rather than a 400 response when an internal server error occurs on early stages of request processing. (markt)
> > | 56582: Use switch(actionCode) in processors instead of a chain of "elseif"s. (kkolinko)
> > | Fix CVE-2014-0227: Various improvements to ChunkedInputFilter including clean-up, i18n for error messages and adding an error flag to allow subsequent attempts at reading after an error to fail fast. (markt)
> > | If request contains an unrecognized Expect header, respond with error 417 (Expectation Failed), according to RFC2616 chapter 14.20. (markt)
> > | When an error occurs after the response has been committed close the connection immediately rather than attempting to finish the response to make it easier for the client to differentiate between a complete response and one that failed part way though. (markt)
> > | 56620: Avoid bogus access log entries when pausing the NIO HTTP connector and ensure that access log entries generated by error conditions use the correct request start time. (markt)
> > | Fix CVE-2014-0230: Add a new limit, defaulting to 2MB, for the amount of data Tomcat will swallow for an aborted upload. The limit is configurable by `maxSwallowSize` attribute of an HTTP connector. (markt)
> > | Allow to configure `maxSwallowSize` attribute of an HTTP connector via JMX. (kkolinko)
> > | 56661: Fix `getLocalAddr()` for AJP connectors. The complete fix is only available with a recent AJP forwarder like the forthcoming mod_jk 1.2.41. (rjung)
> > | 59451: Correct Javadoc for `MessageBytes`. Patch provided by Kyohei Nakamura. (markt)

> Jasper

> > | 56334#c15: Fix a regression in EL parsing when quoted string follows a whitespace. (kkolinko/markt)
> > | 56543: Update to the Eclipse JDT Compiler 4.4. (violetagg)
> > | 56561: Avoid `NoSuchElementException` while handling attributes with empty string value. (violetagg)
> > | 56581: If an error on a JSP page occurs when response has already been committed, do not clear the buffer of JspWriter, but flush it. It will make more clear where the error occurred. (kkolinko)
> > | 56612: Correctly parse two consecutive escaped single quotes when used in UEL expression in a JSP. (markt)
> > | Move code that parses EL expressions within JSP template text from `Parser` to `JspReader` class for better performance. (kkolinko)

> WebSocket

> > | 56577: Improve the executor configuration used for the callbacks associated with asynchronous writes. (markt)

> Web applications

> > | Set the path for cookies created by the examples web application so they only returned to the examples application. This reduces the opportunity for using such cookies for malicious purposes should the advice to remove the examples web application from security sensitive systems be ignored. (markt/kkolinko)
> > | Attempt to obfuscate session cookie values associated with other web applications when viewing HTTP request headers with the Request Header example from the examples web application. This reduces the opportunity to use this example for malicious purposes should the advice to remove the examples web application from security sensitive systems be ignored. (markt)

> Other

> > | Update optional Checkstyle library to 5.7. (kkolinko)
> > | 56685: Add quotes necessary for `daemon.sh` to work correctly on Solaris. Based on a suggestion by lfuka. (markt)
> > | 56596: Update to Tomcat Native Library version 1.1.31 to pick up the Windows binaries that are based on OpenSSL 1.0.1h. (markt)

Tomcat 7.0.54 (violetagg) | released 2014-05-22

> Catalina

> > | Fix custom UTF-8 decoder so that a byte of value 0xC1 is always rejected immediately as it is never valid in a UTF-8 byte sequence. Update UTF-8 decoder tests to account for UTF-8 decoding improvements in Java 8. The custom UTF-8 decoder is still required due to bugs in the UTF-8 decoder provided by Java. Java 8's decoder is better than Java 7's but it is still buggy. (markt)
> > | 56027: Add more options for managing FIPS mode in the AprLifecycleListener. (schultz/kkolinko)
> > | 56321: When a WAR is modified, undeploy the web application before deleting any expanded directory as the undeploy process may refer to classes that need to be loaded from the expanded directory. If the expanded directory is deleted first, any attempt to load a new class during undeploy will fail. (markt)
> > | 56339: Avoid an infinite loop if an application calls `session.invalidate()` from the session destroyed event for that session. (markt)
> > | 56365: Simplify file name pattern matching code in `StandardJarScanner`. Ignore leading and trailing whitespace and empty strings when configuring patterns. Improve documentation. (kkolinko)
> > | 56369: Ensure that removing an MBean notification listener reverts all the operations performed when adding an MBean notification listener. (markt)
> > | 56382: Information about finished deployment and its execution time is added to the log files. Patch is provided by Danila Galimov. (violetagg)
> > | 56383: Properties for disabling server information and error report are added to the `org.apache.catalina.valves.ErrorReportValve`. Based on the patch provided by Nick Bunn. (violetagg/kkolinko)
> > | Fix CVE-2014-0119: Only create XML parsing objects if required and fix associated potential memory leak in the default Servlet. Extend XML factory, parser etc. memory leak protection to cover some additional locations where, theoretically, a memory leak could occur. Ensure that a TLD parser obtained from the cache has the correct value of `blockExternal`. (markt)
> > | Modify generic exception handling so that `StackOverflowError` is not treated as a fatal error and can handled and/or logged as required. (markt)
> > | 56409: Avoid `StackOverflowError` on non-Windows systems if a file named `\` is encountered when scanning for TLDs. (markt)
> > | 56430: Extend checks for suspicious URL patterns to include patterns of the form `*.a.b` which are not valid patterns for extension mappings. (markt)
> > | 56441: Raise the visibility of exceptions thrown when a problem is encountered calling a getter or setter on a component attribute. The logging level is raised from debug to warning. (markt)
> > | 56451: Make resources accessed via a context alias accessible via JNDI in the same way standard resources are available. (markt)
> > | 56463: Property for disabling server information is added to the `DefaultServlet`. Server information is presented in the response sent to the client when directory listings is enabled. (violetagg)
> > | Add the `org.apache.naming` package to the packages requiring code to have the `defineClassInPackage` permission when running under a security manager. (markt)
> > | Add the `org.apache.naming.resources` package to the packages requiring code to have the `accessClassInPackage` permission when running under a security manager. (markt)
> > | Make the naming context tokens for containers more robust. Require RuntimePermission when introducing a new token. (markt/kkolinko)
> > | 56472: Allow NamingContextListener to clean up on stop if its start failed. (kkolinko)
> > | 56492: Avoid eclipse debugger pausing on uncaught exceptions when tomcat renews its threads. (slaurent)
> > | Minor fixes to `ThreadLocalLeakPreventionListener`. Do not trigger threads renewal for failed contexts. Do not ignore `threadRenewalDelay` setting. Improve documentation. (kkolinko)
> > | Correct regression introduced in r797162 that broke authentication of users when using the `JAASMemoryLoginModule`. (markt)
> > | 56501: `HttpServletRequest.getContextPath()` should return the undecoded context path used by the user agent. (markt)
> > | 56523: When using SPNEGO authentication, log the exceptions associated with failed user logins at debug level rather than error level. (markt)
> > | 56536: Ensure that `HttpSessionBindingListener.valueUnbound()` uses the correct class loader when the `SingleSignOn` valve is used. (markt)

> Coyote

> > | 56399: Assert that both Coyote and Catalina request objects have been properly recycled. (kkolinko)
> > | 56416: Correct documentation for default value of socket linger for the AJP and HTTP connectors. (markt)

> Jasper

> > | 56334: Fix a regression in the handling of back-slash escaping introduced by the fix for 55735. (markt/kkolinko)
> > | 56425: Improve method matching for EL expressions. When looking for matching methods, an exact match between parameter types is preferred followed by an assignable match followed by a coercible match. (markt)
> > | Correct the handling of back-slash escaping in the EL parser and no longer require that `\$` or `\#` must be followed by `{` in order for the back-slash escaping to take effect. (markt)
> > | 56529: Avoid `NoSuchElementException` while handling attributes with empty string value in custom tags. Patch provided by Hariprasad Manchi. (violetagg)

> Cluster

> > | Remove cluster and replicationValve from cluster manager template. These instance are not necessary to template. (kfujino)
> > | Add support for cross context session replication to `org.apache.catalina.ha.session.BackupManager`. (kfujino)
> > | Remove the unnecessary cross context check. It does not matter whether the context that is referenced by other context is set to `crossContext`=true. The context that refers to the different context must be set to `crossContext`=true. (kfujino)
> > | Move to `org.apache.catalina.ha.session.ClusterManagerBase` common logics of `org.apache.catalina.ha.session.BackupManager` and `org.apache.catalina.ha.session.DeltaManager`. (kfujino)
> > | Simplify the code of `o.a.c.ha.tcp.SimpleTcpCluster`. In order to add or remove cluster valve to Container, use pipeline instead of `IntrospectionUtils`. (kfujino)
> > | There is no need to set cluster instance when `SimpleTcpCluster.unregisterClusterValve` is called. Set null than cluster instance for cleanup. (kfujino)
> > | Backport refactoring of `AbstractReplicatedMap` to implement `Map` rather than extend `ConcurrentHashMap` to enable Tomcat 7 to be built with Java 8. (markt)

> WebSocket

> > | 56343: Avoid a NPE if Tomcat's Java WebSocket 1.0 implementation is used with the Java WebSocket 1.0 API JAR from the reference implementation. (markt)
> > | Increase the default maximum size of the executor used by the WebSocket implementation for call backs associated with asynchronous writes from 10 to 200. (markt)
> > | Add a warning if the thread group created for WebSocket asynchronous write call backs can not be destroyed when the web application is stopped. (markt)
> > | Ensure that threads created to support WebSocket clients are stopped when no longer required. This will happen automatically for WebSocket client connections initiated by web applications but stand alone clients must call `WsWebSocketContainer.destroy()`. (markt)
> > | 56449: When creating a new session, add the message handlers to the session before calling `Endpoint.onOpen()` so the message handlers are in place should the `onOpen()` method trigger the sending of any messages. (markt)
> > | 56458: Report WebSocket sessions that are created over secure connections as secure rather than as not secure. (markt)
> > | Stop threads used for secure WebSocket client connections when they are no longer required and give them better names for easier debugging while they are running. (markt)

> Web applications

> > | Add Support for `copyXML` attribute of Host to Host Manager. (kfujino)
> > | Ensure that "name" request parameter is used as a application base of host if "webapps" request parameter is not set when adding host in HostManager Application. (kfujino)
> > | Correct documentation on Windows service options, aligning it with Apache Commons Daemon documentation. (kkolinko)
> > | 55215: Improve log4j configuration example. Clarify access logging documentation. Based on patches provided by Brian Burch. (kkolinko)
> > | 55383: Backport improved HTML markup for tables and code fragments from Tomcat 8 documentation. (kkolinko)
> > | 56418: Ensure that the Manager web application does not report success for a web application deployment that fails. (slaurent)
> > | Fix target and rel attributes on links in documentation. They were lost during XSLT transformation. (kkolinko)
> > | Improve valves documentation. Split valves into groups. (kkolinko)

> Other

> > | Align DisplayName of Tomcat installed by `service.bat` with one installed by the *.exe installer. Print a warning in case if neither server nor client jvm is found by `service.bat`. (kkolinko)
> > | 56363: Update to version 1.1.30 of Tomcat Native library. (schultz)
> > | Update package renamed Apache Commons BCEL to r1593495 to pick up some additional changes for Java 7 support and some code clean up. (markt)
> > | In tests: allow to configure directory where JUnit reports and access log are written to. (kkolinko)

Tomcat 7.0.53 (violetagg) | released 2014-03-30

> Catalina

> > | Make it easier for applications embedding and/or extending Tomcat to modify the `javaseClassLoader` attribute of the `WebappClassLoader`. (markt)
> > | Improve the robustness of web application undeployment based on some code analysis triggered by the report for 54315. (markt)
> > | 56219: Improve merging process for web.xml files to take account of the elements and attributes supported by the Servlet version of the merged file. (markt)
> > | 56190: The response should be closed (i.e. no further output is permitted) when a call to `AsyncContext.complete()` takes effect. (markt)
> > | 56236: Enable Tomcat to work with alternative Servlet and JSP API JARs that package the XML schemas in such as way as to require a dependency on the JSP API before enabling validation for web.xml. Tomcat has no such dependency. (markt)
> > | 56246: Fix NullPointerException in MemoryRealm when authenticating an unknown user. (markt)
> > | 56248: Allow the deployer to update an existing WAR file without undeploying the existing application if the update flag is set. This allows any existing custom context.xml for the application to be retained. To update an application and remove any existing context.xml simply undeploy the old version of the application before deploying the new version. (markt)
> > | Fix CVE-2014-0096: Redefine the `globalXsltFile` initialisation parameter of the DefaultServlet as relative to CATALINA_BASE/conf or CATALINA_HOME/conf. Prevent user supplied XSLTs used by the DefaultServlet from defining external entities. (markt)
> > | Add a work around for validating XML documents (often TLDs) that use just the file name to refer to the JavaEE schema on which they are based. (markt)
> > | 56293: Cache resources loaded by the class loader from `/META-INF/services/` for better performance for repeated look ups. (markt)

> Coyote

> > | 53119: Make sure the NIO AJP output buffer is cleared on any error to prevent any possible overflow if it is written to again before the connection is closed. This extends the original fix for the APR/native output buffer to the NIO connector. (kkolinko)
> > | 56172: Avoid possible request corruption when using the AJP NIO connector and a request is sent using more than one AJP message. Patch provided by Amund Elstad. (markt)
> > | 56213: Reduce garbage collection when the NIO connector is under heavy load. (markt)
> > | Fix CVE-2014-0075: Improve processing of chuck size from chunked headers. Avoid overflow and use a bit shift instead of a multiplication as it is marginally faster. (markt/kkolinko)
> > | Fix CVE-2014-0099: Fix possible overflow when parsing long values from a byte array. (markt)

> Jasper

> > | 54475: Add Java 8 support to SMAP generation for JSPs. Patch by Robbie Gibson. (markt)
> > | 55483: Improve handing of overloaded methods and constructors in expression language implementation. (markt)
> > | 56208: Restore the validateXml option to Jasper that was previously renamed validateTld. Both options are now supported. validateXml controls the validation of web.xml files when Jasper parses them and validateTld controls the validation of *.tld files when Jasper parses them. (markt)
> > | 56223: Throw an `IllegalStateException` if a call is made to `ServletContext.setInitParameter()` after the ServletContext has been initialized. (markt)
> > | 56265: Do not escape values of dynamic tag attributes containing EL expressions. (kkolinko)
> > | Make the default compiler source and target versions for JSPs Java 6 since Tomcat 7 requires Java 6 as a minimum. (markt)
> > | 56283: Update to the Eclipse JDT Compiler P20140317-1600 which adds support for Java 8 syntax to JSPs. Add support for value "1.8" for the `compilerSourceVM` and `compilerTargetVM` options. (markt)

> WebSocket

> > | Avoid a possible deadlock when one thread is shutting down a connection while another thread is trying to write to it. (markt)
> > | Call onError if an exception is thrown calling onClose when closing a session. (remm)

> Web applications

> > | In the documentation: add support for several documentation tags from Tomcat 8. Such as `<version-major/>`. (kkolinko)
> > | 56093: Add the SSL Valve to the documentation web application. (markt)
> > | 56217: Improve readability by using left alignment for the table cell containing the request information on the Manager application status page. (markt)
> > | Fixed `java.lang.NegativeArraySizeException` when using "Expire sessions" command in the manager web application on a context where the session timeout is disabled. (kfujino)
> > | Add support for `LAST_ACCESS_AT_START` system property to Manager web application. (kfujino)
> > | Add definition of `org.apache.catalina.ant.FindLeaksTask`. (kfujino)
> > | 56273: If the Manager web application does not perform an operation because the web application is already being serviced, report an error rather than reporting success. (markt)
> > | 56304: Add a note to the documentation about not using WebSocket with BIO HTTP in production. (markt)

> Other

> > | 56143: Improve `service.bat` so that it can be launched from a non-UAC console. This includes using a single call to `tomcat7.exe` to install the Windows service rather than three calls, and using command line arguments instead of environment variables to pass the settings. (markt/kkolinko)
> > | Fix regression in 7.0.52: when using `service.bat install` to install the service the values for --StdOutput, --StdError options were passed as blank instead of "auto". (kkolinko)
> > | Align options between `service.bat` and `exe` Windows installer. For `service.bat` the changes are in --Classpath, --DisplayName, --StartPath, --StopPath. For `exe` installer the changes are in --JvmMs, --JvmMx options, which are now 128 Mb and 256 Mb respectively instead of being empty. Explicitly specify --LogPath path when uninstalling Windows service, avoiding default value for that option. (kkolinko)
> > | Simplify Windows *.bat files: remove %OS% checks, as java 6 does not run on ancient non-NT operating systems. (kkolinko)
> > | 56137: Explicitly use the BIO connector in the SSL example in server.xml so it doesn't break if APR is enabled. (markt)
> > | 56139: Avoid a web application class loader leak in some unit tests when running on Windows. (markt)
> > | Correct build script to avoid building JARs with empty packages. (markt)
> > | Allow to limit JUnit test run to a number of selected test case methods. (kkolinko)
> > | 56189: Remove used file cpappend.bat from the distribution. (markt)

Tomcat 7.0.52 (violetagg) | released 2014-02-17

> Catalina

> > | Generate a valid root element for the effective web.xml for a web application for all supported versions of web.xml. (markt)

> Coyote

> > | Pull up `SocketWrapper` to `AbstractProcessor`. (markt)
> > | In some circumstances asynchronous requests could time out too soon. (markt)

Tomcat 7.0.51 (violetagg) | not released

> Catalina

> > | 55287: `ServletContainerInitializer` defined in the container may not be found. (markt/jboynes)
> > | 55855: Provide a per Context option (containerSciFilter) to exclude container SCIs. (markt)
> > | 55937: When deploying applications, treat a context path of `/ROOT` as equivalent to `/`. (markt)
> > | 55943: Improve the implementation of the class loader check that prevents web applications from trying to override J2SE implementation classes. As part of this fix, refactor the way a null parent class loader is handled which enables a number of null checks and object creation calls to be removed. Note that this change means that, by default, the web application class loader is now a higher priority for loading classes than the system class loader. (markt)
> > | 55958: Differentiate between `foo.war` the WAR file and `foo.war` the directory. (markt)
> > | 55960: Improve the single sign on (SSO) unit tests. Patch provided by Brian Burch. (markt)
> > | 55974: Retain order when reporting errors and warnings while parsing XML configuration files. (markt)
> > | 56013: Fix issue with SPNEGO authentication when using IBM JREs. IBM JREs only understand the option of infinite lifetime for Kerberos credentials. Based on a patch provided by Arunav Sanyal. (markt)
> > | 56016: When loading resources for XML schema validation, take account of the possibility that servlet-api.jar and jsp-api.jar may not be loaded by the same class loader. Patch by Juan Carlos Estibariz. (markt)
> > | 56025: When creating a WebSocket connection, always call `ServerEndpointConfig.Configurator.getNegotiatedSubprotocol()` and always create the EndPoint instance after calling `ServerEndpointConfig.Configurator.modifyHandshake()`. (markt)
> > | 56032: Ensure that the WebSocket connection is closed after an IO error or an interrupt while sending a WebSocket message. (markt)
> > | 56042: If a request in async mode has an error but has already been dispatched don't generate an error page in the ErrorReportValve so the dispatch target can handle it. (markt)
> > | Add missing `javax.annotation.sql.*` classes to annotations-api.jar. (markt)
> > | The type of logger attribute of Context MBean should be not `org.apache.commons.logging.Log` but `org.apache.juli.logging.Log`. (kfujino)
> > | 56082: Fix a concurrency bug in JULI's LogManager implementation. (markt)
> > | 56096: When the attribute `rmiBindAddress` of the JMX Remote Lifecycle Listener is specified it's value will be used when constructing the address of a JMX API connector server. Patch is provided by Jim Talbut. (violetagg)
> > | When environment entry with one and the same name is defined in the web deployment descriptor and with annotation then the one specified in the web deployment descriptor is with priority. (violetagg)
> > | Change default value of `xmlBlockExternal` attribute of Context. It is `true` now. (kkolinko)

> Coyote

> > | Avoid possible NPE if a content type is specified without a character set. (markt)
> > | 55956: Make the forwarded remote IP address available to the Connectors via a request attribute. (markt)
> > | 55976: Fix sendfile support for the HTTP NIO connector. (markt)
> > | 55996: Ensure Async requests timeout correctly when using the NIO HTTP connector. (markt)
> > | 56021: Make it possible to use the Windows-MY key store with the BIO and NIO connectors for SSL configuration. It requires a `keystoreFile="" keystoreType="Windows-My"` to be set on the connector. Based on a patch provided by Asanka. (markt)

> Jasper

> > | Correct a regression in the XML refactoring that meant that errors in TLD files were swallowed. (markt)
> > | 55671: Correct typo in the log message for a wrong value of genStringAsCharArray init-param of JspServlet. This parameter had a different name in Tomcat 6. (kkolinko)
> > | 55973: Fix processing of XML schemas when validation is enabled in Jasper. (kkolinko)
> > | 56010: Don't throw an `IllegalArgumentException` when `JspFactory.getPageContext` is used with `JspWriter.DEFAULT_BUFFER`. Based on a patch by Eugene Chung. (markt)
> > | 56012: When using the extends attribute of the page directive do not import the super class if it is in an unnamed package as imports from unnamed packages are now explicitly illegal. (markt)
> > | 56029: A regression in the fix for 55198 meant that when EL containing a ternary expression was used in an attribute a compilation error would occur for some expressions. (markt)
> > | Correct several errors in jspxml Schema and DTD. (kkolinko)
> > | Change default value of the `blockExternal` attribute of JspC task. The default value is `true`. Add support for `-no-blockExternal` switch when JspC is run as a standalone application. (kkolinko)

> Cluster

> > | Simplify the code of `o.a.c.ha.tcp.SimpleTcpCluster.createManager(String)`. Remove unnecessary class cast. (kfujino)

> WebSocket

> > | Do not return an empty string for the `Sec-WebSocket-Protocol` HTTP header when no sub-protocol has been requested or no sub-protocol could be agreed as RFC6455 requires that no `Sec-WebSocket-Protocol` header is returned in this case. (markt)

> Web applications

> > | Add index.xhtml to the welcome files list for the examples web application. (kkolinko)
> > | Clarify that the connectionTimeout may also be used as the read timeout when reading a request body (if any) in the documentation web application. (markt)
> > | Clarify the behaviour of the maxConnections attribute for a connector in the documentation web application. (markt)
> > | 55888: Update the documentation web application to make it clearer that a Container may define no more than one Realm. (markt)
> > | 55956: Where available, displayed the forwarded remote IP address available on the status page of the Manager web application. (markt)
> > | Correct links to the Tomcat mailing lists in the ROOT web application. (kkolinko)
> > | In Manager web application improve handling of file upload errors. Display a message instead of error 500 page. Simplify parts handling code, as it is known that Tomcat takes care of them when recycling a request. (kkolinko)

> Extras

> > | 55166, 56045: Copy the XML schemas used for validation that are packaged in jsp-api.jar to servlet-api.jar so that an embedded Tomcat instance can start without Jasper being available. This also enables validation to work without Jasper being available. (markt/kkolinko)
> > | 56039: Enable the JmxRemoteLifecycleListener to work over SSL. Patch by esengstrom. (markt)

> Other

> > | 55743: Enable the stop script to work when the shutdown port is disabled and a PID file is defined. This is only available on platforms that use `catalina.sh`. (markt)
> > | 55986: When forcing Tomcat to stop via `kill -9 $CATALINA_PID`, the `catalina.sh` script could incorrectly report that Tomcat had not yet completely stopped when it had. Based on a patch by jess. (markt)
> > | Package correct license and notice files with embedded JARs. (markt)
> > | Remove svn keywords (such as $Id) from source files and documentation. (kkolinko)
> > | Fix CVE-2014-0050, a denial of service with a malicious, malformed Content-Type header and multipart request processing. Fixed by merging latest code (r1565163) from Commons FileUpload. (markt)
> > | 56115: Expose the `httpusecaches` property of Ant's `get` task as some users may need to change the default. Based on a suggestion by Anthony. (markt)

Tomcat 7.0.50 (violetagg) | released 2014-01-08

> Catalina

> > | Handle the case where a `context.xml` file is added to a web application deployed from a directory. Previously the file was ignored until Tomcat was restarted. Now (assuming automatic deployment is enabled) it will trigger a redeploy of the web application. (markt)
> > | Fix string comparison in `HostConfig.setContextClass()`. (kkolinko)
> > | Streamline handling of WebSocket messages when no handler is configured for the message currently being received. (markt)
> > | Handle the case where a WebSocket annotation configures a message size limit larger than the default permitted by Tomcat. (markt)
> > | 55855: This is a partial fix that bypasses the relatively expensive check for a WebSocket upgrade request if no WebSocket endpoints have been registered. (markt)
> > | 55905: Prevent a NPE when web.xml references a taglib file that does not exist. Provide better error message. (violetagg)

> Coyote

> > | When using the BIO connector with an internal executor, do not display a warning that the executor has not shutdown as the default configuration for BIO connectors is not to wait. This is because threads in keep-alive connections cannot be interrupted and therefore the warning was nearly always displayed. (markt)

> Jasper

> > | JspC uses servlet context initialization parameters to pass configuration so ensure that the servlet context used supports initialization parameters. (markt)

> Cluster

> > | In `AbstractReplicatedMap#finalize`, remove rpcChannel from channel Listener of group channel before sending `MapMessage.MSG_STOP` message. This prevents that the node that sent the `MapMessage.MSG_STOP` by normal shutdown is added to member map again by ping at heartbeat thread in the node that received the `MapMessage.MSG_STOP`. (kfujino)
> > | Add time stamp to `GET_ALL_SESSIONS` message. (kfujino)

> Web applications

> > | Fix the sample configuration of `StaticMembershipInterceptor` in order to prevent warning log. uniqueId must be 16 bytes. (kfujino)

> Extras

> > | Update dependencies that are used to build tomcat-juli extras component. Apache Avalon Framework is updated to version 4.1.5, Apache Log4J to version 1.2.17. (rjung)

Tomcat 7.0.49 (violetagg) | not released

> Catalina

> > | Correct a regression in the new XML local resolver that triggered false failures when XML validation was configured. (markt)
> > | Prevent a NPE when destroying HTTP upgrade handler for WebSocket connections. (violetagg)

Tomcat 7.0.48 (violetagg) | not released

> Catalina

> > | 51294: Add support for unpacking WARs located outside of the Host's appBase in to the appBase. (markt)
> > | 55656: Configure the Digester to use the server class loader when parsing server.xml rather than the class loader that loaded StandardServer. Patch provided by Roberto Benedetti. (markt)
> > | 55664: Correctly handle JSR 356 WebSocket Encoder, Decoder and MessageHandler implementations that use a generic type such as `Encoder.Text<List<String>>`. Includes a test case by Niki Dokovski. (markt)
> > | Correctly handle WebSocket `Encoder`s, `Decoder`s and `MessageHandler`s that use arrays of generic types. (markt)
> > | 55681: Ensure that the WebSocket session is made available to `MessageHandler` method calls. (markt)
> > | Updated servlet spec version and documentation section-number reported when JAR files are rejected for containing a trigger class (e.g. javax.servlet.Servlet). (schultz)
> > | Modify the WebSocket handshake process so that the user properties `Map` exposed by the `ServerEndpointConfig` during the call to `Configurator.modifyHandshake()` is unique to the connection rather than shared by all connections associated with the Endpoint. This allows for easier configuration of per connection properties from within `modifyHandshake()`. (markt)
> > | 55684: Log a warning but continue if the memory leak detection code is unable to access all threads to check for possible memory leaks when a web application is stopped. (markt)
> > | Define the web-fragment.xml in tomcat7-websocket.jar as a Servlet 3.0 web fragment rather than as a Servlet 3.1 web fragment. (markt)
> > | 55715: Add a per web application executor to the WebSocket implementation and use it for calling `SendHandler.onResult()` when there is a chance that the current thread also initiated the write. (markt)
> > | Prevent file descriptors leak and ensure that files are closed when configuring the web application. (violetagg)
> > | Fixed the name of the provider-configuration file located in `tomcat7-websocket.jar!/META-INF/services` that exposes information for `javax.websocket.server.ServerEndpointConfig$Configurator` implementation. (violetagg)
> > | 55760: Remove the unnecessary setting of the `javax.security.auth.useSubjectCredsOnly` system property in the `SpnegoAuthenticator` as in addition to it being unnecessary, it causes problems with using SPNEGO with IBM JDKs. Patch provided by Arunav Sanyal. (markt)
> > | 55772: Ensure that the request and response are recycled after an error during asynchronous processing. Includes a test case based on code contributed by Todd West. (markt)
> > | 55778: Add an option to the JNDI Realm to control the QOP used for the connection to the LDAP server after authentication when using SPNEGO with delegated credentials. This value is used to set the `javax.security.sasl.qop` environment property for the LDAP connection. (markt)
> > | 55798: Log an error if the MemoryUserDatabase is unable to find the specified user database file. (markt)
> > | 55799: Correctly enforce the restriction in JSR356 that no more than one data message may be sent to a remote WebSocket endpoint at a time. (markt)
> > | When Catalina parses TLD files, always use a namespace aware parser to be consistent with how Jasper parses TLD files. The `tldNamespaceAware` attribute of the Context is now ignored. (markt)
> > | Deprecate the `tldNamespaceAware` Context attribute as TLDs are always parsed with a namespace aware parser. (markt)
> > | Correct a logic error that meant that unpackWARs was ignored and the WAR was always expanded if a WAR failed to deploy. (markt)
> > | Add support for defining `copyXML` on a per Context basis. (markt)
> > | Define the expected behaviour of the automatic deployment and align the implementation to that definition. (markt)
> > | When running under a security manager, change the default value of the Host's `deployXML` attribute to `false`. (markt)
> > | If a Host is configured with a value of `false` for `deployXML`, a web application has an embedded descriptor at `META-INF/context.xml` and no explicit descriptor has been defined for this application, do not allow the application to start. The reason for this is that the embedded descriptor may contain configuration necessary for secure operation such as a `RemoteAddrValve`. (markt)
> > | Prevent an NPE in the WebSocket `ServerContainer` when processing an HTTP session end event. (markt)
> > | 55801: Add the ability to set a custom `SSLContext` to use for client wss connections. Patch provided by Maciej Lypik. (markt)
> > | 55804: If the GSSCredential for the cached Principal expires when using SPNEGO authentication, force a re-authentication. (markt)
> > | 55811: If the main web.xml contains an empty absolute-ordering element and validation of web.xml is not enabled, skip parsing any web-fragment.xml files as the result is never used. (markt)
> > | 55839: Extend support for digest prefixes {MD5}, {SHA} and {SSHA} to all Realms rather than just the JNDIRealm. (markt)
> > | 55842: Ensure that if a larger than default response buffer is configured that the full buffer is used when a Servlet outputs via a Writer. (markt)
> > | 55851: Further fixes to enable SPNEGO authentication to work with IBM JDKs. Based on a patch by Arunav Sanyal. (markt)
> > | Fix CVE-2013-4590: Add an option to the Context to control the blocking of XML external entities when parsing XML configuration files and enable this blocking by default when a security manager is used. The block is implemented via a custom resolver to enable the logging of any blocked entities. (markt)

> Coyote

> > | Implement a number of small refactorings to the APR/native handler for upgraded HTTP connections. (markt)
> > | Fix an issue with upgraded HTTP connections over HTTPS (e.g. secure WebSocket) when using the APR/native connector that resulted in the unexpected closure of the connection. (markt)
> > | Ensure that the application class loader is used when calling the `ReadListener` and `WriteListener` methods when using non-blocking IO. A side effect of not doing this was that JNDI was not available when processing WebSocket events. (markt)
> > | Make the time that the internal executor (if used) waits for request processing threads to terminate before continuing with the connector stop process configurable. (markt)
> > | 55749: Improve the error message when `SSLEngine` is disabled in the `AprLifecycleListener` and SSL is configured for an APR/native connector. (markt)
> > | If a request that includes an `Expect: 100-continue` header receives anything other than a 2xx response, close the connection This protects against misbehaving clients that may not sent the request body in that case and send the next request instead. (markt)
> > | Improve the parsing of trailing headers in HTTP requests. (markt)

> Jasper

> > | 55735: Fix a regression caused by the fix to 55198. When processing JSP documents, attributes in XML elements that are template content should have their text xml-escaped, but output of EL expressions in them should not be escaped. (markt)
> > | 55807: The JSP compiler used a last modified time of -1 for TLDs in JARs expanded in to WEB-INF/classes (IDEs often do this expansion) when creating the dependency list for JSPs that used that TLD. This meant JSPs using that TLD were recompiled on every access. (markt)

> Cluster

> > | Add log message that initialization of `AbstractReplicatedMap` has been completed. (kfujino)
> > | The logger of `AbstractReplicatedMap` should be non-static in order to enable logging of each application. Side-effects of this change is to throw `RuntimeException` in `MapMessage#getKey()` and `getValue()` instead of Null return and error log. (kfujino)
> > | Simplify the code of `DeltaManager#startInternal()`. Reduce unnecessary nesting for acquisition of cluster instance. (kfujino)
> > | Remove unnecessary attributes of `stateTransferCreateSendTime` and `receiverQueue` from cluster manager template. These attributes should not be defined as a template. (kfujino)
> > | Fix MBean attribute definition of `stateTransfered`. The method name is not `isStateTransfered()` but `getStateTransfered()`. (kfujino)
> > | Correct stop failure log of cluster. Failure cause is not only Valve. (kfujino)
> > | Remove unnecessary sleep when sending session blocks on session sync phase. (kfujino)
> > | Expose `stateTimestampDrop` of `org.apache.catalina.ha.session.DeltaManager` via JMX. (kfujino)
> > | When the ping timeouted, make sure that `memberDisappeared` method is not called by specifying the members that has already been removed. (kfujino)
> > | Add log message of session relocation when member disappeared. (kfujino)
> > | If ping message fails, prevent wrong timeout detection of normal member that is no failure members. (kfujino)

> Web applications

> > | Add some documentation on the SSL configuration options for WebSocket clients. (markt)
> > | Add to cluster document a description of `notifyLifecycleListenerOnFailure` and `heartbeatBackgroundEnabled`. (kfujino)
> > | Update the documentation with information for WebSocket 1.0 specification and javadoc. (violetagg)
> > | 55703: Clarify the role of the singleton attribute for JNDI resource factories. (markt)
> > | 55746: Add documentation on the `allRolesMode` to the `CombinedRealm` and `LockOutRealm`. Patch by Cédric Couralet. (markt)
> > | Expand the information on web applications that ship as part of Tomcat in the security how-to section of the documentation web application. (markt)
> > | Expand the description of the WebSocket buffers in the documentation web application to clarify their purpose. (markt)
> > | Correct the documentation for Cluster manager. (kfujino)
> > | Add information on how to configure integrated Windows authentication when Tomcat is running on a non-Windows host. (markt)

> Extras

> > | Update commons-logging to version 1.1.3. (rjung)

> Other

> > | 52323: Add support for the Cobertura code coverage tool when running the unit tests. Based on a patch by mhasko. (markt/kkolinko)
> > | Update sample Eclipse IDE project. Explicitly use a Java 6 SE JDK. Exclude JSR356 WebSocket classes from build path, as they cannot be compiled with Java 6. (kkolinko)
> > | Update the Eclipse compiler to 4.3.1. (kkolinko/markt)

Tomcat 7.0.47 (violetagg) | released 2013-10-24

> Coyote

> > | Fix regression with legacy WebSocket implementation in NIO and APR connectors. (markt)

> Web applications

> > | Avoid hang observed with Java 6 on Windows when stopping the Tomcat process via CTRL-C. (markt)

> Other

> > | 55663: NOTICE files are corrected according to NOTICE files requirements. (violetagg)

Tomcat 7.0.46 (violetagg) | not released

> Catalina

> > | Only send a WebSocket close message on an IOException if the client has not yet received a close control message from the server as the IOException may be in response to the client continuing to send a message after the server sent a close control message. (markt)
> > | 49134: Ensure nested realms are correctly destroyed, when a CombinedRealm is destroyed. This ensures that the associated MBeans are deregistered. (markt)

> Coyote

> > | Refactor APR/native connector to reduce the scope of `localAddList`. (markt)
> > | 55602: Ensure that sockets removed from the Poller and then closed in the APR/native connector are removed and then closed in a thread-safe manner. (markt)
> > | Update the APR/native connector to version 1.1.29. (violetagg)

> Jasper

> > | 55642: Correct logic error in the JSP parser that was incorrectly identifying EL expressions in jsp:param element values as a literal string. (markt)

> Cluster

> > | Add support for notify periodic event of cluster. (kfujino)

> Web applications

> > | Correct the javadoc for `org.apache.catalina.Lifecycle`. (kfujino)
> > | Add document for sessionIdAttribute attribute in `org.apache.catalina.ha.session.JvmRouteBinderValve`. (kfujino)
> > | Handle the case when a user closes the browser whilst playing the snake game in the JSR356 WebSocket examples. (markt)
> > | Ensure Javadoc comments are associated with the correct elements in `org.apache.tomcat.jni.Poll`. (markt)
> > | Expand Context documentation for the use of `sessionCookiePath="/"` to make the implications for session fixation protection clearer. (markt)
> > | 55629: Ensure that the JMX notification listener added during initialization of the servlet org.apache.catalina.manager.StatusManagerServlet is removed in the destroy phase. (violetagg)
> > | Correct the documentation for Deployment Organization in the App Dev Guide. (violetagg)
> > | 55639: Add a Drawboard WebSocket example. (kpreisser)

Tomcat 7.0.45 (violetagg) | not released

> Catalina

> > | 55576: Preserve the order in which request parameters were received when accessing them via the Servlet API. (markt)

> Cluster

> > | Logger instance of cluster session manager is changed to non-static in order to enable logging of each application. (kfujino)

Tomcat 7.0.44 (violetagg) | not released

> Jasper

> > | 55582: Correct concurrency issue that can result in two instances of JspServletWrapper being created for one tag Patch provided by Sheldon Shao. (markt)

Tomcat 7.0.43 (violetagg) | not released

> Catalina

> > | 51526: `o.a.catalina.startup.Tomcat#addWebapp` methods now process the web application's `META-INF/context.xml` when it is available in the provided path. (violetagg)
> > | 55186: Ensure local name is recycled between requests so IP virtual hosting works correctly. (markt)
> > | 55210: Correct the processing of the provider-configuration file for `javax.servlet.ServletContainerInitializer` in the resource directory `META-INF/services` when this file contains comments and multiple SCIs. Patch provided by Nick Williams. (violetagg)
> > | 55230: Use the correct resource path when obtaining an InputStream for resources served by a ProxyDirContext. (markt)
> > | Ensure that the JAR scanning process scans the Apache Log4j version 2 JARs. Patch provided by Nick Williams. (markt)
> > | 55261: Fix failing unit test for file upload checks when running on platform / JVM combinations that have large network buffers. (markt)
> > | 55268: Added optional --service-start-wait-time command-line option to change service start wait time from default of 10 seconds.
> > | The `contextClass` attribute of `HostConfig` refers to the value of the `contextClass` attribute of Host. (kfujino)
> > | 55331: Dispatching to an asynchronous servlet from `AsyncListener.onTimeout()` should not trigger an `IllegalStateException`. (markt)
> > | 55333: Correct a regression in the fix for 55071. (markt)
> > | When using a security manager, ensure that calls to the ServletContext that are routed via an `AccessController.doPrivileged` block do not result in a call to a different underlying method on the ServletContext. (markt)
> > | 55354: Ensure that the naming context environment parameters are restored after associating the Principle with the user name. Based on patch provided by Richard Begg. (violetagg)
> > | 55357: Ensure the web application class loader is set as a thread context class loader during session deserialization. (violetagg)
> > | 55404: Log warnings about using security roles in web.xml without defining them as warnings. (markt)
> > | 55439: Don't try a forced stop when `stop -force` is used if Tomcat has already been stopped. This avoids error messages when the PID file has been cleared. If a forced stop is required, improve handling of the case when the PID file can be read from or written to but not deleted. (markt)
> > | 55454: Avoid NPE when parsing an incorrect content type. (violetagg)
> > | Back-port the JSR-356 Java WebSocket 1.0 implementation from Tomcat 8. Note that use of this functionality requires Java 7. (markt)
> > | Deprecate the Tomcat proprietary WebSocket API in favour of the new JSR-356 implementation. (markt)
> > | 55494: Reduce severity of log message from warning to information for JNDI Realm connection issues where the JNDI Realm automatically re-tries the action that failed. Make clear in the log message that the action is being re-tried. (markt)
> > | Correct several incorrect formats of `JdkLoggerFormatter`. (kfujino)
> > | 55521: Ensure that calls to `HttpSession.invalidate()` do not return until the session has been invalidated. Also ensure that checks on the validity of a session return a result consistent with any previous call to `HttpSession.invalidate()`. (markt)
> > | 55524: Refactor to avoid a possible deadlock when handling an `IOException` during output when using Tomcat' proprietary (and deprecated) WebSocket API. (markt)
> > | The loaded attribute never exists in `PersistentManager`. isLoaded is defined as operation in mbeans-descriptors. (kfujino)
> > | Added logging of logging.properties location when system property `org.apache.juli.ClassLoaderLogManager.debug=true` is set.
> > | 55570: Correctly log exceptions for all error conditions in the SPNEGO authenticator. (markt)

> Coyote

> > | 55228: Allow web applications to set a HTTP Date header. (markt)
> > | Expose the current connection count for each protocol handler via JMX. (markt)
> > | 55267: If an application configures a timeout for a Comet connection ensure it is only used for read and not write operations. This prevents a long timeout delaying the closing of the socket associated with a Comet connection after an error occurs. (markt)
> > | Ensure that `java.lang.VirtualMachineError`s are not swallowed when using the HTTP or AJP NIO connectors. (markt)
> > | 55399: Use the response locale to select the language to use for the status message in the HTTP response. (markt)
> > | Refactor the connectors to support the new JSR-356 Java WebSocket 1.0 implementation. The most noticeable change is that the AJP APR/native and HTTP APR/native connectors no longer support multiple poller threads. Both connectors now use a single poller thread. (markt)
> > | Internally, content length is managed as a `long`. Fix a few places in the AJP connector where this was restricted to an `int`. (markt)
> > | 55453: Ensure that the AJP connector does not permit response bodies to be included for responses with status codes and/or request methods that are not permitted to have a response body. (markt)
> > | 55500: Don't ignore the value of an asynchronous context timeout when using the AJP NIO connector. (markt)
> > | Fix CVE-2013-4286: Better adherence to RFC2616 for content-length headers. (markt)
> > | Fix CVE-2013-4322: Add support for limiting the size of chunk extensions when using chunked encoding. (markt)
> > | Update the APR/native connector to version 1.1.28. Make this the minimum acceptable version as the correct behaviour of the JSR-356 WebSocket implementation when using the APR/native HTTP connector depends on a bug fix in the 1.1.28 release. (markt)

> Jasper

> > | 55198: Ensure attribute values in tagx files that include EL and quoted XML characters are correctly quoted in the output. (markt)
> > | Ensure that `javax.el.ELContext.getContext(Class)` will throw `NullPointerException` when the provided class is null. (violetagg)
> > | Ensure that `FeatureDescriptor` objects returned by `javax.el.MapELResolver.getFeatureDescriptors(ELContext,Object)` will be created with a correct `shortDescription` - an empty string and a named attribute `ELResolver.RESOLVABLE_AT_DESIGN_TIME` - true. (violetagg)
> > | Ensure that `FeatureDescriptor` objects returned by `javax.el.ResourceBundleELResolver.getFeatureDescriptors(ELContext,Object)` will be created with a correct `shortDescription` - an empty string. `javax.el.ResourceBundleELResolver.isReadOnly(ELContext,Object,Object)` returns true if the base object is an instance of ResourceBundle. (violetagg)
> > | 55207: Enforce the restriction that a <jsp:text> element may not contain any sub-elements from any namespace. Patch provided by Jeremy Boynes. (markt)
> > | Ensure that `javax.el.ListELResolver.getFeatureDescriptors(ELContext,Object)` will always return null. `javax.el.ListELResolver.isReadOnly(ELContext,Object,Object)` will return a result when the property cannot be coerced into an integer. (violetagg)
> > | Ensure that `javax.el.ArrayELResolver.getFeatureDescriptors(ELContext,Object)` will always return null. `javax.el.ArrayELResolver.isReadOnly(ELContext,Object,Object)` and `javax.el.ArrayELResolver.getType(ELContext,Object,Object)` will return a result when the property cannot be coerced into an integer. (violetagg)
> > | 55309: Fix concurrency issue with JSP compilation and the tag plug-in manager. Patch provided by Sheldon Shao. (markt)
> > | Ensure that `javax.el.BeanELResolver.getFeatureDescriptors(ELContext,Object)` and `javax.el.BeanELResolver.getCommonPropertyType(ELContext,Object)` do not throw `NullPointerException` when the provided context is null. (violetagg)

> Cluster

> > | Add new attribute terminateOnStartFailure. Set to true if you wish to terminate replication map when replication map fails to start. If replication map is terminated, associated context will fail to start. If you set this attribute to false, replication map does not end. It will try to join the map membership in the heartbeat. Default value is false. (kfujino)
> > | Avoid ConcurrentModificationException when sending a heartbeat. (kfujino)
> > | Avoid NPE when the channel fails to start. (kfujino)
> > | 55301: Fix `IllegalArgumentException` thrown by simple test for McastService. (kfujino)
> > | 55332: Fix NPE in `FileMessageFactory.main` when specify empty file as arguments. (kfujino)
> > | More definite thread name for `MessageDispatch15Interceptor`. (kfujino)

> Web applications

> > | Remove the experimental label from the AJP NIO connector documentation. (markt)
> > | Correctly associated the default resource bundle with the English locale so that requests that specify an Accept-Language of English ahead of French, Spanish or Japanese get the English messages they asked for. (markt)
> > | 55469: Fixed tags that were not properly closed. Based on a patch provided by Larry Shatzer, jr. (violetagg)
> > | The WebSocket examples in the examples web application have been changed to use the new JSR-356 Java WebSocket 1.0 implementation. (markt)
> > | Add document for `org.apache.catalina.tribes.group.GroupChannel`. (kfujino)
> > | Correct Realm Component page of Tomcat documentation. (violetagg)

> jdbc-pool

> > | 54693: Add a validationQueryTimeout property. Patch provided by Daniel Mikusa. (kfujino)
> > | 54693#c6: Avoid NPE caused by `createConnection()` method returns null. Patch provided by Daniel Mikusa. (kfujino)
> > | 55342: Remove unnecessary reset of interrupted flag. If `InterruptedException` is thrown, the interrupted flag has been cleared. (kfujino)
> > | 55343: Add flag to ignore exceptions of connection creation while initializing the pool. (kfujino)
> > | Add undefined attributes and operations to mbeans-descriptor. (kfujino)

> Other

> > | 45428: Trigger a thread dump written to standard out if Tomcat fails to stop in a timely manner to aid diagnostics. This is only available on platforms that use `catalina.sh`. (markt)
> > | 55204: Correct namespace used in Servlet 2.4 test web application. Patch provided by Jeremy Boynes. (markt)
> > | 55205: Reorder elements so web.xml complies with schema for Servlet 3.0 test web application. Patch provided by Jeremy Boynes. (markt)
> > | 55211: Correct namespace in TLD files used in test web applications. Rename elements `tagclass` to `tag-class` so TLD files complies with DTD/schema. Patch provided by Jeremy Boynes. (violetagg)
> > | Update package renamed version of Commons BCEL to the latest code from Commons BCEL trunk. (markt)
> > | Update package renamed version of Commons FileUpload to the latest code from Commons FileUpload trunk. (markt)
> > | 55297: When looking for the jsvc executable, if an explicit path is not set and it is not found in $CATALINA_BASE, look in $CATALINA_HOME as well. (markt)
> > | 55336: Correctly escape parameters passed to eval in the catalina.sh script to ensure that Tomcat starts when installed on a path that contains multiple consecutive spaces. (markt)

Tomcat 7.0.42 (markt) | released 2013-07-05

> Catalina

> > | Enforce the restriction described in section 4.4 of the Servlet 3.0 specification that requires the new pluggability methods only to be available to `ServletContextListener`s defined in one of the specified ways. (markt)
> > | Better handle FORM authentication when requesting a resource as an unauthenticated user that is only protected for a sub-set of HTTP methods that does not include GET. (markt)
> > | 53777: Add support for a JAAS Realm instance to use a dedicated configuration rather than the JVM global JAAS configuration. This is most likely to be useful for per web application JAAS Realms. Based on a patch by eolivelli. (markt)
> > | 54745: Fix JAR file scanning when Tomcat is deployed via Java Web Start. Patch provided by Nick Williams. (markt)
> > | 55017: Add the ability to configure the RMI bind address when using the JMX remote lifecycle listener. Patch provided by Alexey Noskov. (markt)
> > | 55071: Ensure original exception is reported if JDBC Realm fails to read a user's credentials. (markt)
> > | 55073, 55108, 55109, 55110, 55158 & 55159: Small performance improvements. Patches provided by Adrian Nistor. (markt/violetagg)
> > | 55102: Add support for time to first byte in the AccessLogValve. Patch provided by Jeremy Boynes. (markt)
> > | 55125: If the Server container fails to start, don't allow the Catalina wrapper to start (used when running from the command line and when running as a service) since Tomcat will not be able to do any useful work. (markt)
> > | Update the `JreMemoryLeakPreventionListener` to take account of changes in the behaviour of `java.beans.Introspector.flushCaches()` and `sun.awt.AppContext.getAppContext()` in Java 7. (markt)
> > | Avoid WARNING log message of `Users:type=UserDatabase,database=UserDatabase` at Tomcat shutdown. (pero)
> > | Avoid `ClassCastException` when an asynchronous dispatch is invoked in an asynchronous cycle which is started by a call to `ServletRequest.startAsync(ServletRequest,ServletResponse)` where ServletRequest/ServletResponse are custom implementations. (violetagg)
> > | Correct a regression introduced in 7.0.39 (refactoring of base 64 encoding and decoding) that broke the JNDI Realm when `userPassword` was set and passwords were hashed with MD5 or SHA1. (markt/kkolinko)
> > | Correct the mechanism for the path calculation in `AsyncContext.dispatch()`. (violetagg)
> > | 55155: Avoid constant focus grabbing when running the Tomcat unit tests under Java 6 on OSX. Patch provided by Casey Lucas. (markt)
> > | 55160: Don't ignore connectionUploadTimeout setting when using HTTP NIO connector. (markt)
> > | 55176: Correctly handle regular expressions within SSI expressions that contain an equals character. (markt)

> Coyote

> > | 55177: Correctly handle infinite soTimeout for BIO HTTP connector. Based on a patch by Nick Bunn. (markt)
> > | 55180: Correctly handle infinite soTimeout when `disableUploadTimeout` is set to false. Patch provided by Nick Bunn. (violetagg)

> Cluster

> > | Delete leftover of war file from tempDir when removing invalid `FileMessageFactory`. (kfujino)
> > | Ensure that the keepAlive of NioSender works correctly when `keepAliveCount`/`keepAliveTime` is set to a value greater than 0. (kfujino)
> > | Add logging of when a member is unable to join the cluster. (kfujino)
> > | Replace Tribes's `TaskQueue` as executor's workQueue in order to ensure that executor's `maxThread` works correctly. (kfujino)
> > | 54086: Fix an additional code path that could lead to multiple threads attempting to modify the same selector key set. (markt)

> Web applications

> > | Complete the document for `MessageDispatch15Interceptor`. (kfujino)
> > | 53655: Document the circumstances under which Tomcat will add a `javax.mail.Authenticator` to mail sessions created via a JNDI resource. (markt)
> > | 55179: Correct the Javadoc for the remote IP valve so the correct name is used to refer to the `proxiesHeader` property. (markt)

> jdbc-pool

> > | 55031: Fixed `Export-Package` header and `uses` directives in MANIFEST.MF. Change the version for package `org.apache.juli.logging` to "0" in `Import-Package` header. Thus any version of that package can be used. Patch provided by Martin Lichtin. (violetagg)

> Other

> > | Update Maven Central location used to download dependencies at build time to be `repo.maven.apache.org`. (kkolinko)
> > | Update JUnit to version 4.11. Configure separate download for Hamcrest 1.3 core library as its classes are no longer included in junit.jar. (kkolinko)
> > | 54013: When using a forced stop, allow a short period of time (5s) for the process to die before returning. Patch provided by mukarram.baig. (markt)
> > | 55119: Ensure that the build process produces Javadoc that is not vulnerable to CVE-2013-1571. Based on a patch by Uwe Schindler. (markt)

Tomcat 7.0.41 (markt) | released 2013-06-10

> Catalina

> > | 54703: Make parsing of HTTP Content-Type headers tolerant of any CR or LF characters that appear in the value passed by the application. Also fix some whitespace parsing issues identified by the additional test cases. (markt)
> > | Prevent possible WAR file locking when reading a context.xml file from an unexpanded WAR file. Note that in normal usage, the `JreMemoryLeakPreventionListener` would protect against this. (markt)
> > | Ensure that when auto deployment runs for a Host, it uses the latest values for copyXML, deployXML and unpackWARs. (markt)
> > | 54939: Provide logging (using a UserDataHelper) when HTTP header parsing fails (e.g. when maxHeaderCount is exceeded). (markt)
> > | 54944: Enhancements to the unit tests for FORM authentication. Patch provided by Brian Burch. (markt)
> > | 54955: When a reload of the application is performed ensure that a subsequent request to the context root does not result in a 404 response. (violetagg)
> > | 54971: Ensure that the correct location is used when writing files via `javax.servlet.http.Part.write(String)`. (markt)
> > | 54974: Ensure that `SessionCookieConfig#set<methods>` will throw `IllegalStateException` if the `ServletContext` from which this `SessionCookieConfig` was acquired has already been initialized. (violetagg)
> > | 54981: Ensure that `ServletContext#getJspConfigDescriptor()` will return `null` when there is no jsp configuration provided by web.xml/web-fragment.xml. (violetagg)
> > | Ensure that when Tomcat's anti-resource locking features are used that the temporary copy of the web application and not the original is removed when the web application stops. (markt)
> > | 54984: Use the correct encoding when processing a form data posted as multipart/form-data even when the request parameters are not parsed. (violetagg)
> > | 54999: The old JSESSIONIDSSO needs to be removed when SSO is being used and logout() and login() occur within a single request. Patch provided by Keith Mashinter. (markt)
> > | 55035: Add support for the version attribute to the deploy command of the Ant tasks for interfacing with the text based Manager application. Patch provided by Sergey Tcherednichenko. (markt)
> > | 55046: Add a Servlet Filter that implements CORS. Patch provided by Mohit Soni. (markt)
> > | 55052: JULI's LogManager now additionally looks for logging properties without prefixes if the property cannot be found with a prefix. (markt)
> > | Ensure that only the first asynchronous dispatch operation for a given asynchronous cycle will be performed. Any subsequent asynchronous dispatch operation for the same asynchronous cycle will be ignored and `IllegalStateException` will be thrown. (violetagg)

> Coyote

> > | 54947: Fix the HTTP NIO connector that incorrectly rejected a request if the CRLF terminating the request line was split across multiple packets. Patch by Konstantin Preißer. (markt)

> Jasper

> > | 54964: Allow tag plug-ins to be packaged with a web application. Patch provided by Sheldon Shao. (markt)
> > | 54968: Return the correct version number (2.2) of the JSP specification that is supported by the JSP engine when `javax.servlet.jsp.JspEngineInfo#getSpecificationVersion()` is invoked. (violetagg)

> Cluster

> > | Add `maxValidTime` attribute to prevent the leak of `FileMessageFactory` in `FarmWarDeployer`. (kfujino)
> > | Simplify the code of `ReplicationValve`: Rather than get cluster instance from container on every request, use instance variable. (kfujino)
> > | Add `maxWait` attribute that the senderPool will wait when there are no available senders. (kfujino)
> > | Improve error message by including specified timeout if failed to retrieve a data sender. (kfujino)
> > | Add `removeSuspectsTimeout` attribute in order to remove a suspect node in TcpFailureDetector. (kfujino)

> Web applications

> > | 54931: Add information to the Window Service how-to about installing and running multiple instances. Based on a patch by Chris Derham. (markt)
> > | 54932: Correct the link to Tribes documentation. (violetagg)
> > | Add document for `o.a.c.tribes.group.interceptors.TcpFailureDetector`. (kfujino)

Tomcat 7.0.40 (markt) | released 2013-05-09

> Catalina

> > | Update Tomcat's internal copy of Commons FileUpload to FileUpload 1.3. (markt)
> > | 54178, CVE-2013-2071: Protect against `AsyncListener` implementations that throw `RuntimeException`s in response to an event. (markt)
> > | 54791: Restore `tools.jar` entry in `jarsToSkip` property to prevent warnings when running Tomcat from Eclipse. (markt)
> > | 54851: When scanning for web fragments, directories without any web-fragment.xml should not impact the status of distributable element. Patch provided by Trask Stalnaker. (violetagg)
> > | When an error occurs during the sending of a WebSocket message, notify the Inbound side (where all the events occur that the application reacts to) that an error has occurred and that the connection is being closed. (markt)
> > | 54906: Better error message if a `ConcurrentModificationException` occurs while checking for memory leaks when a web application stops. Also ensure that the exception does not cause remaining checks to be skipped. Based on a patch by NateC.
> > | Allow 204 responses (no content) to include entity headers as required by RFC2616. (markt)

> Coyote

> > | Ensure write errors when using HTTP Upgrade with the APR/native connector result in `IOException`s rather than errors being silently swallowed. (markt)

> Jasper

> > | 54802: Provide location information for exceptions thrown by JspDocumentParser. (kkolinko)
> > | 54801: Do not attempt to parse text that looks like an EL expressions inside a scriptlet in a JSP document because EL expressions are not permitted in scriptlets. (kkolinko/markt)
> > | 54821: Do not attempt to parse text that looks like an EL expressions in a JSP document if EL expressions have been disabled. (kkolinko/markt)
> > | 54888: Add support for CSV lists with the ForEach tag plugin. Patch provided by Sheldon Shao. (markt)

> Cluster

> > | Add several improvements for FarmWarDeployer. (kfujino)

> Web applications

> > | 54872: Correct Cluster Receiver page of Tomcat documentation. (violetagg)

> jdbc-pool

> > | Document `StatementCache` interceptor. (kkolinko)
> > | Fix minor threading issue in `ConnectionPool`. (markt/kkolinko)
> > | 54732: Fix leak of statements in `StatementCache` interceptor. (kkolinko)
> > | Fix NPE in `SlowQueryReportJmx` when running `TestSlowQueryReport` test. (kkolinko)

> Other

> > | Update to Eclipse JDT Compiler 4.2.2. (kkolinko)
> > | 54890: Update to Apache Commons Daemon 1.0.15. (mturk)
> > | Convert remaining unit tests to JUnit 4 and enable Checkstyle rule that forbids use of methods from JUnit 3. (markt/kkolinko)
> > | Remove unneeded permissions for reading UserDataHelper properties from `catalina.policy` file. The class that needed those was moved in 7.0.26. (kkolinko)

Tomcat 7.0.39 (markt) | released 2013-03-26

> Catalina

> > | Ensure a log message is generated when a web application fails to start due to an error processing a ServletContainerInitializer. (markt)
> > | Prevent NPE in JAR scanning when running in an environment where the bootstrap class loader is not an ancestor of the web application class loader such as OSGi environments. (violetagg)
> > | Ensure that, if a call to UEncoder#encodeURL is made, all internal structures are properly cleaned. (violetagg)
> > | 54660: Enable the modification of an access log's `fileDateFormat` attribute while the access log is in use. The change will take effect when the next entry is made to the access log. (markt)
> > | Update Tomcat's internal copy of Commons FileUpload to FileUpload trunk, revision 1458500 and the associated extract from Commons IO to 2.4. (markt)
> > | 54702: Prevent file descriptors leak and ensure that files are closed when parsing web application deployment descriptors. (violetagg)
> > | 54707: Further relax the parsing of DIGEST authentication headers to allow for buggy clients that quote values that RFC2617 states should not be quoted. (markt/kkolinko)
> > | Enable support for MBeans with multiple operations with the same name but different signatures. (markt)
> > | Deprecate Tomcat's internal Base 64 encoder/decoder and switch to using a package renamed copy of the Commons Codec implementation. (markt)
> > | Ensure that StandardJarScanner#scan will use the provided class loader when scanning the class loader hierarchy. (violetagg)

> Coyote

> > | 54690: Fix a regression caused by the previous fix for 54406. If no values are specified for sslEnabledProtocols or ciphers use the default values for server sockets rather than the default values for client sockets. (markt)

> Web applications

> > | Correct Deployer, Manager and Context pages of Tomcat documentation. (kkolinko)

> jdbc-pool

> > | 52318: Version for imported package `org.apache.juli.logging` is extended to include also 7.0.x versions. The fix is applicable only when running in OSGi environment. Patch provided by Martin Lichtin. (violetagg)
> > | 54599: Do not print connection password in `PoolProperties.toString()`. Based on a patch by Daniel Mikusa. (kkolinko)
> > | 54684: Add `javax.naming.spi` to `Import-Package` header in MANIFEST.MF in order to resolve `ClassNotFoundException` when running in OSGi environment. (violetagg)

> Other

> > | Update to Apache Commons Daemon 1.0.14 to resolve 54609 which meant that installation of Windows service could fail producing incorrect service launch command. (mturk)
> > | Ensure HEAD requests return the correct content length when the requested resource uses a Writer. Patch by Nick Williams. (markt)

Tomcat 7.0.38 (markt) | not released

> Catalina

> > | Ensure that the request start time (used by the access log valve to calculate request processing time) is correctly recorded for the HTTP NIO connector. In some cases the request processing time may have been longer than that recorded. (markt)
> > | Add one more library from JDK 7 to the value of `jarsToSkip` property in the `catalina.properties` file. (kkolinko)
> > | 53871: If annotation scanning results in a `StackOverflowError` due to broken class dependencies, add the class hierarchy that triggered the exception to the error message. (markt)
> > | Add a new option to the standard JarScanner implementation (`scanBootstrapClassPath`) to control if the bootstrap classpath is scanned or not. By default, it will not be scanned. (markt)
> > | Provide more consolidated servlet MBean data in the webapp MBean. (rjung)
> > | 54584: Take account of the delegate attribute when building the web application class path to pass to the JSP compiler. (markt)
> > | Copy the updated and re-packaged UTF-8 decoder from Tomcat 8.0.x and use this improved decoder for WebSocket connections. Remove the WebSocket specific UTF-8 decoder. (markt)
> > | 54602: Recycle the byte to character converter used for URIs between requests to ensure an error in one request does not trigger a failure in the next request. (markt)
> > | Use the newly added improved UTF-8 decoder for decoding UTF-8 encoded URIs and UTF-8 encoded request bodies. Invalid UTF-8 URIs will not cause an error but will make use of the replacement character when an error is detected. This will allow web applications to handle the URI which will most likely result in a 404 response. The fall-back to decoding with ISO-8859-1 if UTF-8 decoding fails has been removed. Invalid UTF-8 sequences in a request body will trigger an IOException. The way the decoder is used has also been improved. The notable change is that invalid sequences at the end of the input now trigger an error rather than being silently swallowed. (markt)
> > | 54624: Ensure that the correct request body length is used when swallowing a request body after FORM authentication prior to restoring the original request preventing possible hanging when restoring POST requests submitted over AJP. (markt)
> > | 54628: When writing binary WebSocket messages write from start position in array rather than the start of the array. Patch provided by blee. (markt)

> Coyote

> > | Refactor char encoding/decoding using NIO APIs. (remm)

> Web applications

> > | 54203: Complete the Javadoc for `javax.servlet.http.Part`. (markt)
> > | 54638: Fix display of "Used" memory value for memory pools on the status page in Manager web application when the page is rendered as XML. (kkolinko)
> > | Correct typos in configuration samples on SSL Configuration page of Tomcat documentation. (kkolinko)
> > | Disable support for comments on Changelog page of Tomcat documentation. (kkolinko)
> > | Fix several issues with `status.xsd` schema in Manager web application, testing it against actual output of StatusTransformer class. (kkolinko)
> > | Clarify the documentation on how context paths may be configured for web applications. (markt)

> Other

> > | 54601: Change `catalina.sh` to consistently use `LOGGING_MANAGER` variable to configure logging, instead of modifying `JAVA_OPTS` one. (kkolinko)

Tomcat 7.0.37 (markt) | released 2013-02-18

> Catalina

> > | 54521: Ensure that concurrent requests that require a DIGEST authentication challenge receive different nonce values. (markt)
> > | 54534: Ensure that, if a call to `StandardWrapper#isSingleThreadModel()` triggers the loading of a Servlet, the correct class loader is used. (markt)
> > | 54536: Ensure the default error page is displayed if a custom HTTP status code is used when calling `HttpServletResponse#sendError(int, String)`. (markt)

> Coyote

> > | 54456: Ensure that if a client aborts a request when sending a chunked request body that this is communicated correctly to the client reading the request body. (markt)
> > | Update the native component of the APR/native connector to 1.1.27 and make that version the recommended minimum version. (markt)

> Jasper

> > | 54239: Enable web applications to provide their own Expression Language interpreter to enable them to optimise processing of expressions. Based on a patch by Sheldon Shao. (markt)

> Web applications

> > | 54505: Create clearer links from the JNDI How-To to the Tomcat specific options for configuring JNDI resources. (markt)

> Other

> > | Update to Apache Commons Daemon 1.0.13. (markt)

Tomcat 7.0.36 (markt) | not released

> Catalina

> > | Make additional allowances for buggy client implementations of HTTP DIGEST authentication. This is a follow-on to 54060. (markt)
> > | 54438: Fix a regression in the fix for 52953 that triggered a NPE when digested passwords were used and an authentication attempt was made for a user that did not exist in the realm. (markt)
> > | 54448: Correctly handle `@Resource` annotations on primitives. Patch provided by Violeta Georgieva. (markt)
> > | 54450: Correctly handle resource injection when part of the servlet properties uses `@Resource` and the other uses `injection-target`. Patch provided by Violeta Georgieva. (markt)
> > | 54458: Include exception when logging errors in the DataSourceRealm. Patch provided by Violeta Georgieva. (markt)
> > | 54483: Correct one of the Spanish translations. Based on a suggestion from adinamita. (markt)
> > | Prevent the SSO deregister when web application is stopped or reloaded. When StandardManager(pathname="") or DeltaManager stops normally, all sessions in the context are expired. In this case, because most sessions is not time-out, SSO deregister was triggered. (kfujino)
> > | Include the exception in the log message if the parsing of the context.xml file fails. (markt/kkolinko)
> > | 54497: Make memory leak detection code more robust so a failure in the leak detection code does not prevent the Context from stopping unless the error is fatal to the JVM. (markt)
> > | 54507: Do not start the background thread that is used for expiring sessions (amongst other things) until the web application is fully started. Stop the background thread as soon as the web application is stopped. (markt)
> > | Allow WebSocket Ping/Pong messages to be sent between fragments of a fragmented message. (markt)
> > | 54612: Check if the socket is closed before trying to write a WebSocket message to it. Also, flush any partial buffered data before closing the socket. (markt)

> Coyote

> > | 54324: Allow APR connector to disable TLS compression if OpenSSL supports it. (schultz)
> > | 54406: Fix NIO HTTPS connector to prune specified `ciphers` and `sslEnableProtocols` options to those supported by the SSL implementation, sharing logic with the BIO connector. Modified ciphers and sslEnabledProtocols option pruning to not silently revert to JVM defaults when none of the options specified are supported - new behaviour is to warn and explicitly enable no options. (timw)
> > | Align NIO HTTP connector with other HTTP connectors and include leading blank lines when determining the size of the HTTP headers. (markt)

> Jasper

> > | 53869: Performance improvement for pages with lots of heavily nested tags. Retain a reference to the root JSP context rather than traversing the hierarchy on every call. Based on a patch suggested by Sheldon Shao. (markt)
> > | 54440: Correct a regression caused by the changes for 54240 that broke compilation of JSPs with JspC. Patch provided by Sheldon Shao. (markt)
> > | 54466: Improve error message by including the name of the file when the java file generated from a tag file cannot be compiled. Based on a patch by Sheldon Shao. (markt)

> Cluster

> > | Fix incorrect increment of `counterSend_EVT_SESSION_EXPIRED` and `counterSend_EVT_CHANGE_SESSION_ID`. These values are not incremented if no members active in cluster group. (kfujino)
> > | 54476: Correct error in Javadoc of GroupChannel send methods to maker clear that the minimum length of the destination member array is one, not two. (markt)
> > | Prevent SSO deregister when node shutdown normally in cluster environment. (kfujino)
> > | Check cluster member before sending replicate message in ClusterSingleSignOn. (kfujino)

> Web applications

> > | 54461: Improve the documentation for the compiler attribute in the Jasper how-to. (markt)
> > | Add Jespa to the list of third-party Windows authentication providers and make external links in the documentation for those providers `no-follow`. (markt)

> Tribes

> > | 54496: Don't use a hard-coded class name in `MemberImpl.toString()`. (markt)

> Other

> > | Update to Apache Commons Daemon 1.0.12. (markt)

Tomcat 7.0.35 (markt) | released 2013-01-16

> Catalina

> > | 54247: Prevent `ClassNotFoundException`s on stop when running as a service. (markt)
> > | 54249: Ensure resource properties are available when the context path contains encoded characters such as a space. This triggered compilation issues in Jasper. Patch provided by Polina Genova. (markt)
> > | 54256: Improve error reporting when a JAR file fails extension validation by including the name of the JAR file in the exception. (markt)
> > | Allow web applications to be stopped cleanly even if filters throw exceptions when their destroy() method is called. (markt/kkolinko)
> > | Fix memory leak of servlet instances when running with a SecurityManager and either init() or destroy() methods fail or the servlet is a SingleThreadModel one. (kkolinko)
> > | Cleanup method cache lookup code in `SecurityUtil` class. (kkolinko)
> > | Make the Tomcat 7 non-JSR356 WebSocket implementation non-blocking (where supported by the connector) between the HTTP upgrade and the first WebSocket message from the client to the server. (markt)
> > | 54262: Ensure that an empty `<absolute-ordering />` element in the main web.xml file disables scanning for web fragments. Based on a patch by Violeta Georgieva. (markt)
> > | 54284: As per clarification from the Servlet EG, anonymous Filters and Servlets are not permitted. Patch by Violeta Georgieva. (markt)
> > | 54371: Prevent exceptions when processing web fragments for unexpanded WAR files when the context path contains characters that need to be encoded in URLs such as spaces. Based on a patch by Polina Genova. (markt)
> > | 54372: Make HTTP Digest authentication header parsing tolerant of invalid headers sent by known buggy clients. (markt)
> > | 54377: Correctly set request attributes for AccessLog in RemoteIpFilter. Patch by Violeta Georgieva. (markt)
> > | 54379: Implement support for post-construct and pre-destroy elements in web.xml. Patch by Violeta Georgieva. (markt)
> > | 54380: Do not try to register servlets or contexts into the mapper too early (which just caused a warning to be logged). (kkolinko)
> > | Fix NPE in `WebappLoader.stopInternal` when stop is called after a failed start. (kkolinko)
> > | 54381: Add support for receiving WebSocket pong messages. (markt)
> > | 54382: Fix NPE when SSI processing is enabled and an empty SSI directive is present. (markt)
> > | Fix `ArrayIndexOutOfBoundsException` in `HttpParser` when parsing incorrect HTTP headers. (kkolinko)
> > | 54387: Deployment must fail when multiple servlets are mapped to the same url-pattern. (markt)
> > | 54391: Provide a value for the `javax.servlet.context.orderedLibs` attribute. (markt)

> Coyote

> > | 54248: Ensure that byte order marks are swallowed when using a Reader to read a request body with a BOM for those encodings that require byte order marks. (markt)
> > | Fix release of processors in `AjpNioProtocol`. Wrong object was used as a key in the connections map. (kkolinko)

> Jasper

> > | 54240: Add support for auto-detection and configuration of JARs on the classpath that provide tag plug-in implementations. Based on a patch by Sheldon Shao. (markt)
> > | 54241: Revert the fix for 35410 as it was not compliant with the JSP specification, specifically that `<%= obj %>` must be translated to `out.print(obj)` which in turn becomes `out.write(String.valueOf(obj))`. This will trigger a `NullPointerException` if `obj.toString()` returns `null`. The fix for 35410 incorrectly suppressed the `NullPointerException` in this case. (markt)
> > | 54242: Correct handle null iterations with in the JSTL ForEach tag plug-in implementation. Patch provided by Sheldon Shao. (markt)
> > | 54260: Avoid `NullPointerException` when using JSP unloading and tag files. (markt)
> > | 54370: Improve handling of nulls when trying to match sets of parameters to a method in EL. (markt)
> > | 54338: Correctly coerce the value to the expected type when using the tag plug-in for the JSTL set tag. Patch provided by Sheldon Shao. (markt)

> Web applications

> > | 54244: Clarify the documentation for the BIO and NIO SSL configuration attributes `sslEnabledProtocols` and `sslProtocol` within the documentation web application. (markt)
> > | Integrate documentation of Tomcat 7 with Apache Comments System. People can leave their comments when reading documentation online at the tomcat.apache.org site. (rjung)

> Other

> > | 54390: Use 'java_home' on Mac OS X to auto-detect JAVA_HOME. (schultz)

Tomcat 7.0.34 (markt) | released 2012-12-12

> Catalina

> > | 53871: Improve error message if annotation scanning fails during web application start due to poor configuration or illegal cyclic inheritance with the application's classes. (markt)
> > | Fix unit test for AccessLogValve when using non-GMT time zone. (rjung)
> > | 54170: Ensure correct registration of Filters and Servlets in the JMX registry if the Filter or Servlet name includes a character that must be quoted if used in an ObjectName value. (markt)
> > | Add new attribute `renameOnRotate` to the AccessLogValve. (rjung)
> > | 54190: Correct unit tests for BASIC authentication so that session timeout is correctly tested. Also refactor unit test to make it easier to add additional tests. Patch by Brian Burch. (markt)
> > | 54220: Ensure the ErrorReportValve only generates an error report if the error flag on the response has been set. (markt)
> > | Simplify time zone handling in the access log valve and correctly handle various edge cases for non-standard DST changes. (markt)

> Web applications

> > | 54198: Clarify that `HttpServletResponse.sendError(int)` results in an HTML response by default. (markt)
> > | 54207: Correct JNDI factory package name in Javadoc for `org.apache.naming.java.javaURLContextFactory`. (markt)

> jdbc-pool

> > | Fix a handful of Eclipse warnings in the JDBC pool source code including the warnings reported in 53565. (markt)
> > | 54150: Make sure that SlowQueryReportJmx mbean deregistered during webapp shutdown. Reported by Alex Franken. (kfujino)
> > | 54194: Make sure that connection pool mbean is not registered when jmxEnabled is false. Patch provided by tobias.gierke. (kfujino)

> Other

> > | Update to Eclipse JDT Compiler 4.2.1. (markt)

Tomcat 7.0.33 (markt) | released 2012-11-21

> Catalina

> > | 53960, 54115: Extensions to HttpClient test helper class. Patches by Brian Burch. (markt/kkolinko)
> > | 53993: Avoid a possible NPE in the AccessLogValve when the session ID is logged and a session is invalidated. (markt)
> > | Add support for LAST_ACCESS_AT_START system property to PersistentManager. (kfujino)
> > | Update MIME type mapping with additional / updated mime.types from the Apache web server. (markt)
> > | 54007: Fix a memory leak that prevented deletion of a context.xml file associated with a Context that had failed to deploy. Also fix the problems uncovered with undeploying such a Context once the leak had been fixed and the file could be deleted. (markt)
> > | 54044: Correct bug in timestamp cache used by logging (including the access log valve) that meant entries could be made with an earlier timestamp than the true timestamp. (markt)
> > | 54054: Do not share shell environment variables between multiple instances of the CGI servlet. (markt)
> > | 54060: Use a simple parser rather than a regular expression to parse HTTP Digest authentication headers so the header is correctly parsed. The new approach is also faster and generates less garbage. (markt)
> > | 54068: Rewrite the web fragment ordering algorithm to resolve multiple issues that resulted in incorrect ordering or failure to find a correct, valid order. (markt)
> > | The HTTP header parser added to address 52811 has been removed and replaced with the light-weight HTTP header parser created to address 54060. The new parser includes a work-around for a bug in the Adobe Acrobat Reader 9.x plug-in for Microsoft Internet Explorer that was identified when the old parser was introduced (53814).
> > | 54076: Add an alternative work-around for clients that use SPNEGO authentication and expect the authenticated user to be cached per connection (Tomcat only does this if an HTTP session is available). (markt)
> > | 54087: Correctly handle (ignore) invalid If-Modified-Since header rather than throwing an exception. (markt)
> > | 54096: In web.xml, <env-entry> should accept any type that has a constructor that takes a single String or char. (markt)
> > | 54127: Add support for sending a WebSocket Ping. Patch provided by Sean Winterberger. (markt)
> > | Fix CVE-2013-2067: In FormAuthenticator: If it is configured to change Session IDs, do the change before displaying the login form. (kkolinko)
> > | Ensure `AsyncListener.timeout()` and `AsyncListener.complete()` are called with the correct thread context class loader. (fhanik)
> > | 54123: If an asynchronous request times out without any `AsyncListener`s defined, a 500 error will be triggered. (markt)
> > | 54124: Correct provided value of request attribute `javax.servlet.async.request_uri` and add missing request attribute `javax.servlet.async.path_info`. (markt)
> > | Add `denyStatus` initialization parameter to `CsrfPreventionFilter`, allowing to customize the HTTP status code used for denied requests. (kkolinko)
> > | 54141: Increase the permitted number of nested Realm levels from 2 to 3 by default and make the limit configurable via a system property. (markt)
> > | Revert occasional API change in `BaseDirContext` class that was done in 7.0.32. Methods should not be `final`. (kkolinko)
> > | Prevent failures in the AccessLogValve when running under a SecurityManager and the first request received is an asynchronous one. (markt)

> Coyote

> > | Correct an issue that prevented WebSockets from being used over SSL when using the HTTP NIO connector. (markt)
> > | 54022: Ensure the Comet END event is triggered on client disconnect with APR/native on Windows Vista/2k8 or later. Patch provided by Douglas Beachy. (markt)
> > | 54067: Ensure responses with 1xx response codes are correctly marked as not containing an entity body. This caused an issue for some WebSocket clients when an Transfer-Encoding header was sent with the 101 (HTTP upgrade) response. (markt)

> Jasper

> > | 53867: Optimise the XML escaping provided by the PageContext implementation. Based on a patch by Sheldon Shao. (markt)
> > | 53896: Use an optimised CompositeELResolver for Jasper that skips resolvers that are known to be unable to resolve the value. Patch by Jarek Gawor. (markt)
> > | 53986: Correct a regression introduced by the fix for 53713. JSP comments that ended with the sequence ---%> (or any similar sequence with a odd number of - characters) was not correctly parsed. (markt)
> > | 54011: Fix a bug in the tag plug-in for `<c:out>` that triggered a JSP compilation error if the `escapeXml` attribute was used. Patch provided by Sheldon Shao. (markt)
> > | Follow up to 54011. Simplify generated code for `<c:out>`. Based on a patch by Sheldon Shao. (markt)
> > | 54012: Fix a bug in the tag plug-in infrastructure that meant the `<c:set>` triggered a JSP compilation error when used in a tag file. Based on a patch provided by Sheldon Shao. (markt)
> > | 54017: Simplify coercion of `String` instances to `Object`. (markt)
> > | 54144: Fix a bug in the tag plug-in for `<c:out>` that meant that if the value of the tag evaluated to a `java.io.Reader` object then it was not correctly handled. (markt)

> Cluster

> > | Add getSessionIdsFull operation to mbeans-descriptor. listSessionIdsFull no longer exist. (kfujino)
> > | 54086: Fix threading issue when stopping an `NioReceiver`. (markt)

> Web applications

> > | 54143: Add display of the memory pools usage (including PermGen) to the Status page of the Manager web application. (kkolinko)

> Tribes

> > | 54045: Make sure getMembers() returns available member when TcpFailureDetector works in static cluster. (kfujino)

Tomcat 7.0.32 (markt) | released 2012-10-09

> Catalina

> > | Revert multiple operation support for the `JMXProxyServlet` pending further discussion. (schultz)
> > | CVE-2012-4431: Fix bypass of `CsrfPreventionFilter` when there is no session. Improve session management in the filter. (kkolinko)

> Web applications

> > | Correct the couple of broken links in the Tomcat Javadoc. (markt)

> Other

> > | Update optional Checkstyle library to 5.6. (kkolinko)

Tomcat 7.0.31 (markt) | not released

> Catalina

> > | Add one library from JDK 7 to the value of `jarsToSkip` property in the `catalina.properties` file. (kkolinko)
> > | 52777: Add an option to automatically remove old, unused versions (ones where there are no longer any active sessions) of applications deployed using parallel deployment. (markt)
> > | 53828: Use correct status code when closing a WebSocket connection normally in response to a close frame from a client. (markt)
> > | `JMXProxyServlet` now allows multiple operation commands like `invokeAndSet`, `invokeAndGet`, etc. (schultz) Note: reverted in 7.0.32.
> > | 53843: `request.isAsyncStarted()` must continue to return true until the dispatch actually happens (which at the earliest isn't until the thread where `startAsync()` was called returns to the container). (markt)
> > | 53863: Ensure that the implicit servlets (JSP and default) are marked as override-able when using embedded mode. (markt)
> > | When the `DefaultServlet` is under heavy load, the HTTP header parser added to address 52811 generates large amounts of garbage and uses significant CPU time. A cache has been added that significantly reduces the overhead of this parser. (markt)
> > | 53854: Make directory listings work correctly when aliases are used. (markt)

> Jasper

> > | 53713: Performance improvement of up to four times faster parsing of JSP pages. Patch provided by Sheldon Shao. (markt)

> Cluster

> > | Make the cluster members and the cluster deployer associated with the cluster accessible via JMX. (markt)
> > | Fix a behavior of TcpPingInterceptor#useThread. If set to false, ping thread is never started. (kfujino)

> Web applications

> > | Improve the documentation web application to clarify the difference between the tag and version parameters when using text interface of the Manager web application. (markt)
> > | Make sessions saved in the `Store` associated with a `Manager` that extends `PersistentManager` optionally visible (via the showProxySessions Servlet initialisation parameter in web.xml) to the Manager web application. (markt)

Tomcat 7.0.30 (markt) | released 2012-09-06

> Catalina

> > | Automatically delete temporary files used by Servlet 3.0 file upload (for parts which size is greater than `file-size-threshold` option in web.xml) when request processing completes. (kkolinko)
> > | 53071: This additional fix for this issue improves the formatting of Jasper errors (or any exceptions that use a multi-line message) with the `ErrorReportValve`. (markt)
> > | 53469: If a URL passed to `javax.servlet.http.HttpServletResponse.encodeURL()` cannot be made absolute, never encode it and return it unchanged. Previously, the fix for 53062 meant than an `IllegalArgumentException` was thrown. (markt)
> > | 53481: Added support for SSLHonorCipherOrder to allow the server to impose its cipher order on the client. Based on a patch provided by Marcel Šebek. This feature requires Tomcat Native 1.1.25 or later. (schultz)
> > | 53498: Fix atomicity bugs in use of concurrent collections. Based on a patch by Yu Lin. (markt)
> > | Correct a regression in the previous fix for 53062 that did not always correctly normalize redirect URLs when the redirect URL included a query string or fragment component. (markt)
> > | Add missing getter and setter for `roleSearchAsUser` option on JNDI Realm. (markt)
> > | Add some HTTP status codes registered at IANA. (rjung)
> > | 53531: Fix ExpandWar.expand to check the return value of File.mkdir and File.mkdirs. (schultz)
> > | 53535: Reduce memory footprint when performing class scanning on Context start. Patch provided by Cedomir Igaly. (markt)
> > | 53541: Fix JAR scanning when WEB-INF/lib is provided via VirtualDirContext. Patch provided by Philip Zuev. (markt)
> > | 53574: Ensure Servlets defined using jsp-file are available when metadata-complete is true. (markt)
> > | 53584: Ignore path parameters when comparing URIs for FORM authentication. This prevents users being prompted twice for passwords when logging in when session IDs are being encoded as path parameters. (markt)
> > | 53623: When performing a asynchronous dispatch after series of forwards, ensure that the request properties are correct for the request at each stage. (markt)
> > | 53624: Ensure that `HttpServletResponse.sendRedirect()` works when called after a dispatch from an `AsyncContext`. (markt)
> > | 53641: Correct name of HTTP header used in WebSocket handshake for listing the preferred protocols. (markt)
> > | Document the constants that were added to the `RequestDispatcher` interface in Servlet 3.0. (kkolinko)
> > | Ensure custom error pages are not truncated if the page that triggered the error set a content length header. (markt)
> > | 53677: Ensure that a 500 response rather than no response is returned if the HTTP headers exceed the size limit. (markt)
> > | 53702: When merging web.xml fragments, allow for `<jsp-property-group>` elements having multiple `<url-pattern>` elements. (markt)
> > | Always make the resulting web.xml available even if metadata-complete is true. (markt)
> > | 53714: Provide separate system properties to control which JARs are excluded from which scans when using the JarScanner. This allows JARs to be excluded from all scans or only from TLD scanning and/or Servlet 3.0 pluggability scanning. (markt)
> > | Add several JDK libraries to the value of `jarsToSkip` property in the `catalina.properties` file. (markt, kkolinko)
> > | Fix typos etc. in the code that logs merged web.xml (as enabled by `logEffectiveWebXml` option on Context). (kkolinko)
> > | 53758: When adding filters via `FilterRegistration.Dynamic` the filters were added at the wrong point because the `isMatchAfter` logic was inverted. (markt)
> > | 53783: Correctly handle JARs generated by tools that do not create specific entries for directories. Patch provided by Violeta Georgieva. (markt)
> > | Improvements to DIGEST authenticator including the disabling caching of authenticated user in session by default, tracking server rather than client nonces and better handling of stale nonce values. (markt)
> > | Improve performance of DIGEST authenticator for concurrent requests. (markt)
> > | CVE-2012-3546: Fix bypass of security constraint checks with FORM authentication. Remove unneeded processing in `RealmBase`. (kkolinko)
> > | 53800: `FileDirContext.list()` did not provide correct paths for subdirectories. Patch provided by Kevin Wooten. (kkolinko)
> > | 53801: Overlapping URL patterns were sometimes merged incorrectly in security constraints leading to incorrect 401 responses. Note: it was possible for access to be denied when it should have been granted but it was not possible for access to be granted when it should have been denied. (markt)

> Coyote

> > | Remove the `socket.soTrafficClass` from the BIO and NIO HTTP and AJP connectors because any use of the option is either ignored or in some cases (Java 7 with NIO) throws an Exception. (markt)
> > | Prevent possible NPE when processing Comet requests during Connector shutdown. (markt)
> > | 42181: Better handling of edge conditions in chunk header processing. (kkolinko)
> > | 53697: Correct a regression in the fix for 51881 that mean that in some circumstances the `comet` flag was not reset on `HttpAprProcessor` instances. This caused problems when the Processor was re-used for a new connection that would trigger a `NullPointerException` and could result in a JVM crash. (markt)
> > | 53725: Fix possible corruption of GZIP'd output. (markt/kkolinko)
> > | Better parsing of line-terminators for requests using chunked encoding. (markt)
> > | Further improvements to handling of Comet END events when the connector is stopped. (markt)

> Jasper

> > | 53545: Ensure buffered data is cleared when using a jsp:forward action inside a classic custom tag. (markt)
> > | 53654: Support `file://` URLs for JSP dependencies. Patch provided by Viola Lu. (markt)
> > | 53792: Support `MethodExpression`s that include a method invocation that is not at the end of the expression. (markt)

> Cluster

> > | Fix an issue when running under Java 7 which throws exceptions when trying to set an invalid option whereas Java 6 silently swallowed them. The option using the problem was `soTrafficClass`. Investigations showed that this option had no effect for Cluster Channel Receivers so it was removed. (markt)
> > | 53513: Fix race condition between the processing of session sync message and transfer complete message. (kfujino)

> Web applications

> > | Update JSTL version information in the JNDI section of the documentation web application. (markt)
> > | 53524: Correct a typo in the cluster how-to section of the documentation web application. Also fix a handful of spelling errors. (markt)
> > | 53601: Clarify in documentation that building Apache Tomcat 7 from sources requires a Java 6 JDK. (kkolinko)
> > | 53653: Allow for wrapped source code example in config/context.html. Patch provided by Terence Bandoian. (schultz)
> > | 53793: Change links on the list of applications in the Manager to point to '/appname/' instead of '/appname'. (kkolinko)

> Tribes

> > | Avoid potential NPE identified by Find Bugs in `org.apache.catalina.tribes.io.ReplicationStream`. (markt)
> > | 53606: Fix potential NPE in `TcpPingInterceptor`. Based on a patch by F. Arnoud. (markt)
> > | 53607: To avoid NPE, set TCP PING data to ChannelMessage. Patch provided by F.Arnoud (kfujino)

> Other

> > | 53701: Javadoc fixes. Patch provided by sebb. (markt)
> > | Remove some unused code from Tomcat's package renamed, cut-down copy of Commons BCEL used for annotation scanning. (markt)
> > | 53735: Add support for Java 7 byte code to Tomcat's package renamed, cut-down copy of Commons BCEL used for annotation scanning. (markt)

Tomcat 7.0.29 (markt) | released 2012-07-08

> Catalina

> > | Add support for searching for roles in JNDI/LDAP using another value than the actual DN or username specified. Rather it will use a value from the users directory entry. The new attribute introduced to the JNDIRealm is userRoleAttribute (fhanik)
> > | Fix checking of recommended tcnative library version when using the APR connector. (rjung)
> > | 50306: Improve StuckThreadDetectionValve: add stuckThreadNames property as a pair for the stuckThreadIds one, add thread ids to the log messages. (kkolinko)
> > | 52135: Add support for a default error page to be defined in web.xml by defining an error page with just a nested location element. It appears this feature was intended to be included in the Servlet 3.0 specification but was accidently left out. (markt)
> > | 53450: Correct regression in fix for 52999 that could easily trigger a deadlock when deploying a ROOT web application. (markt)
> > | As per section 1.6.2 of the Servlet 3.0 specification and clarification from the Servlet Expert Group, the servlet specification version declared in web.xml no longer controls if Tomcat scans for annotations. Annotation scanning is now always performed - regardless of the version declared in web.xml - unless metadata complete is set to true. (markt)
> > | 53619: As per clarification from the Servlet Expert Group, JARs will always be scanned for ServletContainerInitializers regardless of the setting of metadata complete. However, if an absolute ordering is specified and a JAR is excluded from that ordering it will not be scanned for ServletContainerInitializers nor will it be scanned for matches to any HandleTypes annotations. (markt)
> > | 53465: Populate mapped-name property for resources defined in web.xml. Based on a patch by Violeta Georgieva. (markt)
> > | Make the request available when establishing a WebSocket connection. (markt)
> > | 53467: Correct a regression in the fix for 53257 that introduced problems for JSPs that used characters that must be encoded if used in a URI. (markt)

> Coyote

> > | 53430: Avoid a JVM crash when a connector that requires the APR/native library is explicitly specified and the library, or a recent enough version of it, is not available. (markt)

> Jasper

> > | 53421: Provide a more helpful error message if a getter or setter cannot be found for a bean property when using expression language. (markt)
> > | 53460: Allow container to handle errors if the creation of the PageContext fails rather than swallowing the error. (markt)

> Web applications

> > | Update the WebSocket examples in the examples web application so that they work with secure connections (wss) as well as non-secure (ws) connections. (markt)
> > | 53456: Minor corrections and improvements to the HTTP connector configuration reference. Patch provided by sebb. (markt)
> > | 53459: Correction and clarifications to the SSL Connector configuration examples in the SSL how-to. (markt)
> > | 53464: Correct reference to sample init.d script for use with jsvc in the documentation web application. (markt)
> > | 53473: Correct the allowed values for the SSI option `isVirtualWebappRelative` which are `true` or `false`. (markt)
> > | Document `roleNested` property of `JNDIRealm` in Configuration Reference. (kkolinko)

> jdbc-pool

> > | 53445 (r1354173): Allow configurable name for SlowQueryReportJmx (fhanik)
> > | 53416 (r1354641): Multiple pools with the same name should register under JMX (fhanik)

> Other

> > | Fix cleanup of temporary files in `TestNamingContext` test. (kkolinko)
> > | Remove a few files from the source distribution that are not required since they are copied / generated during the build. (markt)
> > | Add manifest files to the set of files for which the line-ending is changed to match the OS defaults in the source distributions. (markt)
> > | Align Jk Ant tasks definitions between antlib.xml and catalina.tasks files, introducing `jkupdate` as synonym for `jkstatus`. The latter one is deprecated. Simplify `bin/catalina-tasks.xml`, replacing `taskdef` with `typedef` and adding Ant condition implementations used with JMX to `jmxaccessor.tasks` file. (kkolinko)
> > | 53454: Return correct content-length header for HEAD requests when content length is greater than 2GB. (markt)

Tomcat 7.0.28 (markt) | released 2012-06-19

> Catalina

> > | 52055: An additional fix to ensure that the ChunkedInputFilter is correctly recycled. (markt)
> > | 52954: Make DIGEST authentication tolerant of clients (mainly older Android implementations) that do not follow RFC 2617 exactly. (markt)
> > | 52955: Implement custom thread factory for container start-stop thread pool. It allows to use daemon threads and give them more distinct names. (kfujino)
> > | 52999: Remove synchronization bottleneck from the firing of `Container` events. (markt)
> > | 53008: Additional test cases for BASIC authentication and RFC2617 compliance. Patch provided by Brian Burch. (markt)
> > | 53021: Correct WebSocket protocol version detection. (pero)
> > | Add new attributes of `allow` and `deny` to UserConfig. (kfujino)
> > | 53024: Fix context reloading so requests received during the reload are paused and processed when reloading completes rather than receiving 404 responses. (markt)
> > | Improve the handling of watched resources so that changes trigger a reload rather than a stop followed by a start which allows requests received to be paused and processed when reloading completes rather than receiving 404 responses. (markt)
> > | Remove potential bottleneck on creation of new WebSocket connections. (markt)
> > | 53047: If a JDBC Realm or DataSource Realm is configured for an all roles mode that only requires authorization (and no roles) and no role table or column is defined, don't populate the Principal's roles. (markt)
> > | 53056: Add APR version number to tcnative version INFO log message. (schultz)
> > | 53057: Add OpenSSL version number INFO log message when initializing. (schultz)
> > | Save a bit of memory in annotations cache in `DefaultInstanceManager` by trimming annotation lists to their size. (kkolinko)
> > | Correctly configure the parser used to process server.xml so that external entities may be used to include the content of external files into server.xml. (markt)
> > | Make sure ContextMBean#findFilterDefs returns correct filter definitions. (kfujino)
> > | Ensure that `maxParameterCount` applies to multi-part requests handled via the Servlet 3 file upload API. (markt)
> > | 53062: When constructing absolute URLs for redirects from relative URLs ensure that the resulting URLs are normalized. (markt)
> > | 53067: Ensure the WebSocket Servlet continues to work when requests are wrapped. (markt)
> > | Enable host's xmlBase attribute in ContextConfig. (kfujino)
> > | 53071: Use the message from the throwable (if there is one) when generating the report in the `ErrorReportValve` and no message has been specified via `sendError()`. (markt)
> > | 53074: Switch to an infinite socket timeout by default for WebSocket connections. (markt)
> > | 53081: Do not always cache resources loaded by the web application class loader since they may be very large which in turn could trigger a memory leak. Calls to the web application class loader's `getResourceAsStream()` method will now access the resource directly rather than via the cache in most cases. (markt)
> > | 53090: Include superclasses when considering injection targets. Patch provided by Borislav Kapukaranov. (markt)
> > | 53161: Provide a better error message if a `ClassFormatException` occurs during annotation scanning and do not prevent the web application from starting in this case. (markt)
> > | 53180: Improve check for setter method when processing annotations. Patch provided by Violeta Georgieva. (markt)
> > | 53225: Fix an IllegalStateException due to the JAR file being closed when accessing static resources in a JAR file when `urlCacheProtection="false"` in the `JreMemoryLeakPreventionListener`. (markt)
> > | 53230: Changed ManagerBase to throw TooManyActiveSessionsException instead of IllegalStateException when the maximum number of sessions has been exceeded and a new session will not be created. (schultz)
> > | 53257: Ensure that resources, including JSP files, that have names that include characters with special meanings in URLs (such as ampersand, semicolon, plus, hash and percent) are correctly handled. This bug is partially a regression caused by the original fix for 51584 and partially an existing issue that had not previously been identified. This fix reverts the original fix for 51584, correctly fixes that issue and fixes the additional issues identified by the test cases that were also added as part of this fix. (markt/kkolinko)
> > | 53266: If a class specified in a `@HandlesTypes` annotation on a `ServletContainerInitializer` is missing log a more helpful message and do not prevent the web application from starting. (markt)
> > | 53267: Ensure that using the GC Daemon Protection feature of the `JreMemoryLeakPreventionListener` does not trigger a full GC every hour. (markt)
> > | 53285: Do not require `security-role-ref` elements to contain a `role-link` element. (markt)
> > | 53301: Prevent double initialization of pre-created Servlet instances when used in embedded mode. (markt)
> > | 53322: When processing resource injection, correctly infer property name from its setter method if the name starts with several uppercase characters. (kkolinko)
> > | 53333: When processing JNDI resources, take account of the types of any specified injection targets to ensure that the resource definition and the injection target types are consistent. Based on a patch provided by Violeta Georgieva. (markt)
> > | 53337: Forwarding via a `RequestDispatcher` to an asynchronous Servlet always failed. Includes a test case based on code by Rossen Stoyanchev. (markt)
> > | 53339: Ensure WebSocket call backs (`onOpen` etc.) are called using the web application's class loader. (markt)
> > | 53342: To avoid BindException, make startStopThreads into a demon thread. (kfujino)
> > | 53353: Make the internal HTTP header parser more tolerant of Content-Type values that contain invalid parameters by ignoring the invalid parameters. It is a followup to bug 52811. (markt)
> > | 53354: Correctly handle `@WebFilter` annotations that do not include a mapping. (markt)
> > | 53356: Add support for servlets mapped explicitly to the context root of a web application. (markt)
> > | 53366: Ensure new HTTP header parser works correctly when running Tomcat under a security manager. (markt/kkolinko)
> > | 53368: Configure the default security policy to allow web applications to use WebSocket when running under a security manager. (markt/kkolinko)
> > | 53373: Allow whitespace around delimiters in <Context> aliases for readability. (schultz)

> Coyote

> > | 52858, CVE-2012-4534: Correct fix for high CPU load. (fhanik)
> > | 53138: Broken Sendfile on SSL introduced in 7.0.27 (fhanik)
> > | 52055: Additional fix required to ensure that `InputFilter`s are recycled between requests. (markt)
> > | 53061: Fix a problem in the NIO connector whereby if the poller was under low but consistent load (>1 request/per second and always less than 1 second between requests) timeouts never took place. (markt)
> > | 53063: When using an Executor with BIO, use the executor's maxThreads as the default for maxConnections. (markt)
> > | 53119: Prevent buffer overflow errors being reported when a client disconnects before the response has been fully written from an AJP connection using the APR/native connector. (markt)
> > | 53169: Allow developers to avoid chunked encoding for a response of unknown length by setting the `Connection: close` header. Based on a patch suggested by Philippe Marschall. (markt)
> > | 53173: Properly count down maxConnections (fhanik)
> > | Update default value of pollerThreadCount for the NIO connector. The new default value will never go above 2 regardless of available processors. (fhanik)
> > | Allow to retrieve the current `connectionCount` via getter from the endpoint and as JMX attribute of the ThreadPool mbean. (rjung)
> > | Correct an edge case where Comet END events were not send to connected clients when the Tomcat connector was stopped. (markt)
> > | 53406: Fix possible stack overflow on connection close when using Comet. (fhanik)
> > | Improve `InternalNioInputBuffer.parseHeaders()`. (kkolinko)
> > | Implement `maxHeaderCount` attribute on Connector. It is equivalent of LimitRequestFields directive of Apache HTTPD. Default value is 100. (kkolinko)

> Jasper

> > | 48097#c7, 53366#c1: If JSP page unexpectedly fails to initialize PageContext instance, write exception to the logs instead of silent swallowing. (kkolinko)
> > | 53032: Modify `JspC` so it extends `org.apache.tools.ant.Task` enabling it to work with features such as namespaces within build.xml files. (markt)

> Cluster

> > | Avoid NPE when reload if a state of a BackupManager is FAILED. (kfujino)
> > | 53087: In order to avoid that a backup node expire a session, replicate session access time in BackupManager. (kfujino)
> > | Add support for SecureRandom to cluster manager template. (kfujino)

> Web applications

> > | Remove obsolete bug warning from Windows service documentation page. (rjung)
> > | 50182: Various improvements to the Compression Filter. Patch provided by David Becker. (markt)
> > | 52853: Clarify how Jar Scanner handles directories. (markt)
> > | 53158: Fix documented defaults for DBCP 1.x. Patch provided by ph.dezanneau at gmail.com. (rjung)
> > | 53203: Correct documentation for the default value of `connectionTimeout` attribute for AJP protocol connectors. (kkolinko)
> > | 53289: Clarify `ResourceLink` example that uses DataSource.getConnection(username, password) method. Not all data source implementations support it. (kkolinko)
> > | Fix several HTML markup errors in servlets of examples web application. (kkolinko)
> > | 53398: Correct spelling of "received" in the Manager application's XML output. (markt)
> > | 53403: Update a reference to the Servlet specification in the first web application section of the documentation web application to include newer versions of the specification. (markt)

> jdbc-pool

> > | 50864 (r1311844): JMX enable most pool properties (fhanik)
> > | 53254 (r1340160): Add in the ability to purge connections from the pool (fhanik)
> > | 53367 (r1346691): Prevent pool from hanging during database failure (fhanik)
> > | When a connection is reconnected due to failed validation make sure the ConnectionState is reset or it will assume incorrect values (fhanik)
> > | 53374 (r1348056): Add support for the following properties in DataSourceFactory: `commitOnReturn`, `rollbackOnReturn`, `useDisposableConnectionFacade`, `logValidationErrors` and `propagateInterruptState`. Based on patch proposed by Suresh Avadhanula. (kkolinko)

> Other

> > | Update to Eclipse JDT Compiler 3.7.2 at maven tomcat-jasper.pom. (pero)
> > | Update the native component of the Tomcat APR/native connector to 1.1.24. (markt)
> > | Add missing dependencies in pom files. (markt)
> > | 53034: Add `project.url` and `project.licenses` sections to the POMs for the Maven artifacts. (markt)
> > | Properly mention `jsp_2_2.xsd` in the main LICENSE and INSTALLLICENSE files. (kkolinko)
> > | 53115: Fix using the command "`catalina.bat run`" when the value of `%TEMP%` contains spaces. (kkolinko)
> > | Add dependencies and description to "validate" target in `build.xml`, so that it could be run separately. Improve `BUILDING.txt` and `RUNNING.txt`. (kkolinko)

Tomcat 7.0.27 (markt) | released 2012-04-05

> Catalina

> > | Explicitly ignore empty path values in `virtualClasspath` attribute of `VirtualWebappLoader` class. Document that whitespace around the values is trimmed. Reformat documentation examples to make them more readable. (kkolinko)
> > | Further improve fix for 51197 to allow an error reporting Valve to write a response body if `sendError()` is called during an asynchronous request on a container thread. (markt)
> > | Correct fix for 51741 (r1307600): If `VirtualDirContext` class is configured with non-empty value of `extraResourcePaths` option (a feature added in 7.0.24), do not implicitly set `allowLinking` option to the value of `true`. If it is really needed, it should be set explicitly. (kkolinko)
> > | 52500: Added configurable mechanism to retrieve user names from X509 client certificates. Based on a patch provided by Michael Furman. (schultz)
> > | 52719: Fix a theoretical resource leak in the JAR validation that checks for non-permitted classes in web application JARs. (markt)
> > | Code clean-up identified by 52723, 52724, 52726, 52727, 52729, 52731 and 52732. (markt)
> > | 52792: Improve error message when a JNDI resource can not be found. (markt)
> > | 52811: Fix parsing of Content-Type header in `HttpServletResponse.setContentType()`. Introduces a new HTTP header parser that follows RFC2616. (markt/kkolinko)
> > | 52830: Correct JNDI lookups when using `javax.naming.Name` to identify the resource rather than a `java.lang.String`. (markt)
> > | 52833: Handle the case where the parent class loader for the Catalina object does not have the system class loader in its hierarchy. This may happen when embedding. Patch provided by olamy. (markt)
> > | 52839: Add a unit test for DigestAuthenticator and SingleSignOn. Patch provide by Brian Burch. (markt)
> > | 52846: Make sure NonLoginAuthenticator registers not MemoryUser but GenericPrincipal into a session when UserDatabaseRealm is used. (kfujino)
> > | 52850: Extend memory leak prevention and detection code to work with IBM as well as Oracle JVMs. Extend unit tests to check direct and indirect ThreadLocal memory leak detection. Based on a patch provided by Rohit Kelapure. (markt)
> > | Add support for the WebSocket protocol (RFC6455). Both streaming and message based APIs are provided and the implementation currently fully passes the Autobahn test suite. Also included are several examples. A significant contribution to this new functionality was provided by Johno Crawford — particularly the examples. Contributions were also provided by Petr Praus, Jonathan Drake & Slávka. (markt)
> > | When stopping a Context, ensure that any Servlets registered with JMX are unregistered. (markt)
> > | Make the implementation of `Catalina.getParentClassLoader` consistent with similar methods across the code base and have it return the system class loader if no parent class loader is set. (markt)
> > | 52953: Ensure users can authenticate when using DIGEST authentication with digested passwords if the digested password is stored using upper case hexadecimal characters since DIGEST authentication expects digests to use lower case characters. Based on a patch provided by Neale Rudd. (markt)
> > | 52957: Ensure that a Valve implements Lifecycle before calling any Lifecycle methods on that Valve. (markt)
> > | 52958: Fix MBean descriptors for `org.apache.catalina.realm` package. (markt)
> > | 52974: Fix `NameNotFoundException` when field/method is annotated with `@Resource` annotation. Patch provided by Violet Agg. (markt)
> > | Add support for multi-thread deployment in UserConfig. (kfujino)

> Coyote

> > | Correctly register NIO sockets with poller after processing Comet events to ensure that no read events are missed. This fixes an intermittent issue observed in the unit tests. (fhanik/markt)
> > | 52770: Fix a bug in the highly unlikely circumstance that an infinite timeout was specified for writing data to a client when using NIO. (markt)
> > | 52858: Fix high CPU load with SSL, NIO and sendfile when client breaks the connection before reading all the requested data. (markt)
> > | 52926: Avoid NPE when an NIO Comet connection times out on one thread at the same time as it is closed on another thread. (markt)
> > | Include port number when known in connector name when logging messages from connectors that use automatic free port allocation. (markt)
> > | Don't try an unlock the acceptor thread if it is not locked. This is unlikely to impact normal usage but it does fix some unit test issues. (markt)
> > | When using the APR connector ensure that any connections in a keep-alive state are closed when the connector is stopped rather than when the connector is destroyed. This is important when stop() followed by start() is called on the connector. (markt)

> Jasper

> > | 52725: Use configurable package name for tags rather than hard-coded value so configuration actually works. (markt)
> > | 52758: Implement additional interface methods in Eclipse JDT integration required for Jasper to correctly with the latest Eclipse development code. (markt)
> > | 52772: Ensure uriRoot is fully validated before it is used. Patch based on a suggestion by Eugene Chung. (markt)
> > | 52776: Refactor the code so JspFragment.invoke cleans up after itself. Patch provided by Karl von Randow. (markt)
> > | 52970: Take account of coercion rules when invoking methods via EL. (markt)
> > | 52998: Partial fix. Remove static references to the EL expression factory and use per web application references instead. (markt)
> > | 52998: Remainder of fix. Cache the class to use for the EL expression factory per class loader. (kkolinko)
> > | 53001: Revert the fix for 46915 since the use case described in the bug is invalid since it breaks the EL specification. (markt)

> Cluster

> > | Replicate principal in ClusterSingleSignOn. (kfujino)

> Web applications

> > | 52760: Fix expires filter mime type in javascript examples. (rjung)
> > | 52842: Exception in MBeanDumper when dumping MBean for StandardThreadExecutor. (rjung)
> > | Bring built-in mime types for embedded Tomcat more in line with the ones defined in the default web.xml configuration file. (rjung)
> > | Add support to the JMXProxyServlet which is part of the Manager application for fetching a specific key from a `CompositeData` value. Updated documentation, so that the entire 'get' command for the JMX proxy servlet is documented, including the new optional 'key' parameter. (schultz/markt)

> jdbc-pool

> > | Pool cleaner thread should be created using the classloader that loaded the pool, not the context loader (fhanik)
> > | 52804: Make pool properties serializable and cloneable. (fhanik)
> > | 51237 (r1302902): Slow Query Report should log using WARN level when queries are slow and within the threshold of caching it. (fhanik)
> > | 52002 (r1302948): Add in configuration option to disallow connection reuse. (r1305862): useDisposableConnectionFacade is by default enabled (fhanik)
> > | 52493 (r1302969): Java 7 DataSource method addition. (fhanik)
> > | 51893 (r1302990): Throw an error and notification when pool is exhausted. (fhanik)
> > | 50860 (r1303031): Add in option to configure logging for validation errors. (fhanik)
> > | 52066 (r1305931): Add in configuration option, progagateInterruptState, to allow threads to retain the interrupt state. (fhanik)

> Other

> > | 52750: Fix the way how daemon.sh parses command options so that more then one can be provided. (mturk)
> > | Rearrange `validate-eoln` target in `build.xml` so that it could be run ahead of compilation. (kkolinko)
> > | Update Apache Commons Daemon to 1.0.10. (mturk)
> > | Update the native component of the Tomcat APR/native connector to 1.1.23 and take advantage of the simplified distribution. (mturk)
> > | Update to Eclipse JDT Compiler 3.7.2. (markt)

Tomcat 7.0.26 (markt) | released 2012-02-21

> Catalina

> > | Provide constants for commonly used `Charset` objects and use these constants where appropriate. (markt)
> > | Refactor the fix for 52184 to correct two issues (a missing class and incorrect class/method names) when using the extras logging packages. (markt)
> > | 52444: Only load classes during HandlesTypes processing if the class is a match. Previously, every class in the web application was loaded regardless of whether it was a match or not. (markt)
> > | 52488: Correct typo: exipre -> expire. (markt)
> > | Add a unit test for SSO authentication. Patch provided by Brian Burch. (markt)
> > | 52511: Correct regression in the fix for 51741 that caused a harmless exception to be logged when scanning for annotations and `WEB-INF/classes` did not exist. (markt)
> > | Refactor to remove a circular dependency between `org.apache.catalina` and `org.apache.naming`. (markt)
> > | Remove some initialisation code from the standard start process (i.e. via the scripts) that was intended for embedding but is not required when performing a standard start.(markt)
> > | Add new method to `MBeanFactory` that allows any Valve to be created and deprecate the methods to create specific Valves. (markt)
> > | Partial sync of MIME type mapping with mime.types from the Apache web server. (rjung)
> > | 52577: Fix a regression in the fix for 52328. Prevent output truncation when `reset()` is called on a response. (markt)
> > | 52586: Remove an old and now unnecessary hack that modified the path info reported via the `javax.servlet.forward.path_info` request attribute when forwarding to an error page. (markt)
> > | 52587: Ensure that if it is necessary to fall back to the default NullRealm, the NullRealm instance is created early enough for it to be correctly initialised. (markt)
> > | Fix millisecond output in AccessLogValve when using a SimpleDateFormat based time pattern. (rjung)
> > | 52591: When dumping MBean data, skip attributes where getters throw `UnsupportedOperationException`. (markt)
> > | 52607: Ensure that the extension validator checks the JARs in the shared and common class loaders for extensions. (markt)
> > | Correct a threading issue in the generation of the list of standard authenticators during Context initialization that could lead to a web application failing to start if Contexts were started in parallel. (markt)
> > | 52669: Correct regression that broke annotation processing in `/WEB-INF/classes` for web applications deployed as WARs, packageless classes and some embedding scenarios. The regression was introduced by the invalid assumptions made in the fix for 51741. (markt)
> > | 52671: When dumping MBean data, skip attributes where getters throw `NullPointerException`. (markt)

> Coyote

> > | 51543: Provide a meaningful error message when writing more response headers than permitted. (markt)
> > | 52547: Ensure that bytes written (which is used by the access log) is correctly reset after an HTTP 1.0 request has been processed. (markt)
> > | Minor refactoring to reduce code duplication in the HTTP connectors. (markt)
> > | 52606: Ensure that POST bodies are available for reply after FORM authentication when using the AJP connectors. (markt)

> Jasper

> > | 52474: Ensure that leading and trailing white space is removed from listener class names when parsing TLD files. (markt)
> > | 52480: When converting class path entries from URLs to files/directories, ensure that any URL encoded characters are converted. Fixes JSP compilation with javac when Tomcat is installed at a path that includes spaces. (markt)
> > | 52666: Correct coercion order in EL when processing the equality and inequality operators. (markt)

> Web applications

> > | Improve `BUILDING.txt`. Update instructions for building. Add instructions for using Checkstyle and running the tests. (kkolinko)
> > | 38216: Improve handling of `null` return values in the JMX proxy servlet which is part of the Manager application. (kkolinko)
> > | 52515: Make it clear in the Realm how-to in the documentation web application that digested password storage when using DIGEST authentication requires that MD5 digests are used. (markt)
> > | 52634: Fix typos in JSP examples. Patch provided by Felix Schumacher. (rjung)
> > | 52641: Remove mentioning of ldap.jar from docs. Patch provided by Felix Schumacher. (rjung)

> jdbc-pool

> > | Fix code style issues and enable Checkstyle checks for jdbc-pool when it is built within Tomcat. (kkolinko)
> > | 51582 Correct set and reset the query cache to avoid NPE (fhanik)

> Other

> > | Update Commons Daemon to 1.0.9 to resolve 52548 which meant that services created with service.bat did not set the `catalina.home` and `catalina.base` system properties. (markt)
> > | Implement check for correct end-of-line characters in the source files. It is run as separate target in `build.xml`. (kkolinko)

Tomcat 7.0.25 (markt) | released 2012-01-21

> Web applications

> > | Restore format of the first line of error message for JMX proxy servlet in case scripts were depending on it. (markt)

> Other

> > | When building a Windows installer do not copy whole "res" folder to output/dist, but only the files that we need. Apply fixcrlf filter only after the files are copied, so that `INSTALLLICENSE` file had correct line ends. (kkolinko)
> > | Remove `res/License.rtf`. The file that is actually shown by the Windows installer is `res/INSTALLLICENSE`. (kkolinko)
> > | Automate the OpenPGP signature generation for the release process. (markt)
> > | Don't exclude directories named target from the build process. (rjung)

Tomcat 7.0.24 (markt) | not released

> Catalina

> > | 52184: Provide greater control over the logging of errors triggered by invalid input data (i.e. data over which Tomcat has no control). (markt/kkolinko)
> > | 52225: Fix ClassCastException in an Alias added to existing host through JMX. (kkolinko)
> > | Do not throw IllegalArgumentException from parseParameters() call when chunked POST request is too large, but treat it like an IO error. The `FailedRequestFilter` filter can be used to detect this condition. (kkolinko)
> > | 52245: Don't allow web applications to package classes from the `javax.el` package. Patch provided by pid. (markt)
> > | 52259: Fix regression caused by the addition of the threaded component start (46264) that triggered a deadlock on startup if no Realm was configured. (markt)
> > | 52293: Correctly handle the case when `antiResourceLocking` is enabled at the Context level when `unpackWARs` is disabled at the Host level. Based on a patch by Justin Miller. (markt)
> > | In `ExtendedAccessLogValve` when printing %-encoded value of a parameter, use UTF-8 encoding to convert parameter value to bytes instead of platform default encoding. (markt/kkolinko)
> > | 52303: Allow web applications that do not have a login configuration to participate in a SSO session. Patch provided by Brian Burch. (markt)
> > | 52316: When using sendfile, use the number of bytes requested to be written to the response in the access log valve for bytes written rather than recording a value of zero. (markt)
> > | 52326: Reduce log level for class loading errors during `@HandlesTypes` processing to debug. (markt)
> > | 52328: Improve performance when large numbers of single characters and/or small strings are written to the response via a Writer. (markt)
> > | 52384: Do not fail with parameter parsing when debug logging is enabled. (kkolinko)
> > | Do not flag extra '&' characters in parameters as parse errors. (kkolinko)
> > | Reduce log level for the message about hitting `maxParameterCount` limit from WARN to INFO. (kkolinko)
> > | 52387: Ensure that the correct host is used when configuring logging when Tomcat is embedded. Patch provided by David Calavera. (markt)
> > | 52405: Align the Servlet 3.0 implementation with the changes defined in the first maintenance release (also know as Rev. A). See the JCP documentation for a detailed list of changes (markt)
> > | Improve JMX names for objects related to Connectors that have the address attribute set. (markt)
> > | Remove some stale attributes from MBeans. (rjung)
> > | Move destruction of `ContainerBase` objects to `ContainerBase` to ensure that they are destroyed. (markt)
> > | 52443: Change the behaviour of the default Realm in the embedded use case so it is set once on the Engine rather than on every Context thereby avoiding the Lifecycle issues with having the same Realm set on multiple Contexts. (markt)
> > | Provide a new Realm implementation, the NullRealm, that does not contain any users and is used as the default Realm implementation (rather than the JAAS Realm which was used prior to this change) if no Realm is specified. (markt)
> > | 52461: Don't assume file based URLs when checking last modified times for global and host level web.xml files. Patch provided by violetagg. (markt)
> > | Add test cases for the BASIC and NonLogin Authenticators when not using SSO. Patch provided by Brian Burch. (markt)

> Coyote

> > | 52028: Add support for automatic binding to a free port by a connector if the special value of zero is used for the port. This is mainly useful in embedded and testing scenarios. (markt)
> > | Remove obsolete `emptySessionPath` JMX attribute. (rjung)
> > | Correct error in fix for 49683. (markt)
> > | Ensure that the process of unlocking the acceptor thread does not trigger processing of the connection as if it were a valid request. (markt)

> Jasper

> > | 52450: Add setter for entityResolver in ParserUtils. This is mainly useful when jasper and dtds are in different class loaders. (mturk)
> > | 52321: Ensure that the order of multiple prelude/coda values for JSP pages is respected. (markt)
> > | 52335: Only handle `<\%` and not `\%` as escaped in template text. (markt)
> > | 52440: Ensure that when using `ValueExpression.getValueReference()` if the expression is an EL variable that the value returned is the `ValueReference` for the `ValueExpression` associated with the EL variable. (markt)
> > | 52445: Don't assume that EL method expressions have exactly three components (identifier, method name, parameters). (markt)

> Web applications

> > | 38216: Add the ability to invoke MBean operations to the JMX proxy servlet in the Manager application. Based on a patch by Christopher Hlubek. (markt)
> > | Further clarify the relation between values used by `RemoteIpValve` and `RemoteIpFilter` and their use by `AccessLogValve`. (kkolinko)
> > | 52243: Improve windows service documentation to clarify how to include `#` and/or `;` in the value of an environment variable that is passed to the service. (markt)
> > | 52366: Fix typo in VirtualWebappLoader documentation (configuration example). (rjung)
> > | Replace Bugzilla search link on `ROOT/index.jsp` page with one pointing to the bug reporting page of Tomcat site. (kkolinko)
> > | Move MBean dump code from JMXProxyServlet into a utility class. (rjung)

> Tribes

> > | 52208: Fix threading issue that may lead to harmless NPE during shutdown that has occasionally been observed when running the unit tests. (markt)
> > | 52213, 52354, 52355 and 52356: Fix some potential concurrency issues in `FastQueue`. (markt)

> jdbc-pool

> > | r1207712: Pool cleaner should be a global thread, not spawn one thread per connection pool. (fhanik)

> Other

> > | Update Apache Commons Daemon to 1.0.8. (mturk)
> > | Update Apache Commons Pool to 1.5.7. (kkolinko)
> > | Fix line ends in `.gitignore` files contained in source distributions. (rjung)
> > | Run Mapper performance test twice if the first run took too long, to ignore occasional failures. (kkolinko)
> > | Align `.gitignore` and `build.xml` exclude patterns with `svn:ignore`. (kkolinko)
> > | Configure `defaultexcludes` for Ant 1.8.1/1.8.2. The `.git` and `.gitignore` patterns are in since Ant 1.8.2, but we include `.gitignore` in src distributions. (kkolinko)
> > | 52237: Allow JUnit logs to be generated in formats other than plain text. Patch provided by M Hasko. (markt/kkolinko)
> > | Fix build condition for tomcat-dbcp to always rebuild when a new version of commons-pool or commons-dbcp is downloaded. (kkolinko)
> > | Add example of configuration for `SetCharacterEncodingFilter` to the default `web.xml` file. (kkolinko)
> > | Switch unit tests to bind Connectors to localhost rather than all available IP addresses. (markt)
> > | Update to Eclipse JDT Compiler 3.7.1. (markt)
> > | Add Netbeans `nbproject` folder to `svn:ignore` and `.gitignore`. (rjung)
> > | Align `.gitignore` with trunk. (rjung)

Tomcat 7.0.23 (markt) | released 2011-11-25

> Catalina

> > | 46264: Add the ability to start and stop containers (primarily Contexts) using a thread pool rather than a single thread. This can significantly improve start and stop time. Based on patches by Joe Kislo and Felix Schumacher. (markt)
> > | 50570: Enable FIPS mode to be set in AprLifecycleListener. Based upon a patch from Chris Beckey. (schultz/kkolinko)
> > | 51744: Throw the correct exception if an application attempts to modify the associated JNDI context. (markt)
> > | 51744: Add an option to the StandardContext that allows exception throwing when an application attempts to modify the associated JNDI context to be disabled. (markt)
> > | 51910: Prevent NPE on connector stop if Comet applications are being used without the CometConnectionManagerValve. (markt)
> > | 51940: Do not limit saving of request bodies during FORM authentication to POST requests since any HTTP method may include a request body. Based on a patch by Nicholas Sushkin. (markt/kkolinko)
> > | 51956: RemoteAddrFilter used getRemoteHost instead of getRemoteAddr when filtering Comet events. (schultz)
> > | 51952: Make the inclusion of a response body with a redirect response introduced to address 41718 optional and disabled by default due to the side-effects of including a body with the response in this case. (markt)
> > | 51972: Correctly handle protocol relative URLs when used with `sendRedirect()`. (markt)
> > | Simplify the deployment code and use full paths in log messages to remove any ambiguity in where a context is being deployed from. (markt)
> > | 52009: Fix a NPE during access log entry recording when an error occurred during the processing of a Comet request. (markt)
> > | In `OneLineFormatter` log formatter in JULI always use the US locale to format the date (esp. the month names). (rjung)
> > | Cache the results of parsing the global and host level web.xml files to improve web application start time. (markt)
> > | 52042: Correct threading issue in annotation caching that could lead to an NPE if multiple threads were processing the same class hierarchy for annotations. (markt)
> > | Correct additional threading and premature clearance issues with the annotation cache. (markt)
> > | Correct a regression in the fix for 49779 that parameters POSTed by an unauthenticated user to a page that required FORM authentication were lost during the authentication process. (markt)
> > | 52055: Ensure that the input and output buffers are correctly reset between keep-alive requests when using Servlet 3.0 asynchronous request processing. (markt)
> > | Ensure changes to the configuration of the RemoteHostValve and the RemoteAddrValve via JMX are thread-safe. (markt)
> > | Ensure that the memory leak protection for the HttpClient keep-alive always operates even if the thread has already stopped. (markt)
> > | Remove the Java 1.2 specific error handling around the adding of the shutdown hook. (markt)
> > | Correct errors in i18n resources and resource usage that meant some messages were either not used or were incorrectly formatted. (markt)
> > | Replace the use of deprecated auth method names from `authenticator.Constants` with the auth method names from `HttpServletRequest`. (kkolinko)
> > | Make configuration issues for security related Valves and Filters result in the failure of the valve or filter rather than just a warning message. (markt)
> > | Improve performance of parameter processing for GET and POST requests. Also add an option to limit the maximum number of parameters processed per request. This defaults to 10000. Excessive parameters are ignored. Note that `FailedRequestFilter` can be used to reject the request if some parameters were ignored. (markt/kkolinko)
> > | 52091: Address performance issues related to lock contention in StandardWrapper. Patch provided by Taiki Sugawara. (markt)
> > | Switch to using Collections.enumeration() rather than custom code that does the same thing. (markt)
> > | 52113: Don't assume presence of context.xml file with JMX deployment. (markt)
> > | In `RequestFilterValve` (`RemoteAddrValve`, `RemoteHostValve`): refactor value matching logic into separate method and expose this new method `isAllowed` through JMX. (kkolinko)
> > | 52156: Ensure that `getServletContext().getResource(path)` returns the correct resource when path contains `/../` sequences or any other sequences that require normalization. (markt)
> > | Report existence of HTTP request parameter parsing errors via new special ServletRequest attribute, `org.apache.catalina.parameter_parse_failed`. (kkolinko)
> > | New filter `FailedRequestFilter` that will reject a request if there were errors during HTTP parameter parsing. (kkolinko)
> > | Improve special attributes handling in Request object by using hash table lookup instead of series of string comparisons. (kkolinko)
> > | Deprecate unused methods in `IntrospectionUtils` class. (kkolinko)
> > | Improve processing of errors that are wrapped in `InvocationTargetException`. Rethrow fatal errors that must be rethrown. (kkolinko)
> > | Improve handling of failed web application deployments during automatic deployment. Once deployment of a web application fails in one form (e.g. WAR), no further attempt (e.g. directory) will be made to deploy that web application. The base Lifecycle implementation has been improved to allow failed web applications to be started once the configuration issues have been resolved. Any changes to a context.xml file (global, per host or web application specific) will now result in a redeploy of the affected web application(s) that ensures that any changes are correctly applied rather than a reload which ignores changes in context.xml files. (markt/kkolinko)
> > | 52173: Improve Javadoc for `delegate` attribute of WebappClassLoader. Based on a patch by bmargulies. (markt)
> > | Add `denyStatus` attribute to `RequestFilterValve` (`RemoteAddrValve`, `RemoteHostValve` valves) and `RequestFilter` (`RemoteAddrFilter`, `RemoteHostFilter` filters). It allows to use different HTTP response code when rejecting denied request. E.g. 404 instead of 403. (kkolinko)
> > | Slightly improve performance of UDecoder.convert(). Align `%2f` handling between implementations. (kkolinko)

> Coyote

> > | 51881: Correctly complete Comet requests when the Comet END event is triggered asynchronously. (markt)
> > | 51905: Fix infinite loop in AprEndpoint shutdown if acceptor unlock fails. Reduce timeout before forcefully closing the socket from 30s to 10s. (kkolinko)
> > | 51912: Fix HTTP header processing in NIO HTTP connector. (kkolinko)
> > | Improve MimeHeaders.toString(). (kkolinko)
> > | Fix threading issue in NIO connectors during shutdown that meant Comet connections were not always shut down cleanly. (markt)
> > | In HTTP connectors: self-guard against using a non-recycled input buffer. Requests will be rejected with response status 400. (kkolinko)
> > | 52121: Fix possible output corruption when compression is enabled for a connector and the response is flushed. Includes a test case provided by David Marcks. (kkolinko/markt)
> > | Improve multi-byte character handling in Coyote output for HTTP and AJP. (rjung)
> > | Refactor acceptor unlock code to reduce waiting time during connector pause and stop. (markt)

> Jasper

> > | Correct possible (but very small) memory leak when using maxLoadedJsps to limit the number of JSPs loaded at any one time. (markt)
> > | 52051: Better handling of missing resource problems with non-standard Servlet mappings so that a 404 response is returned to the client rather than a 500 response. (markt)
> > | 52091: Address performance issues related to log creation in TagHandlerPool. Patch provided by Taiki Sugawara. (markt)
> > | Switch to using Collections.enumeration() rather than custom code that does the same thing. (markt)

> Cluster

> > | Avoid an unnecessary session ID change notice. Notice of changed session ID by JvmRouteBinderValve is unnecessary to BackupManager. In BackupManager, change of session ID is replicated by the call of a setId() method. (kfujino)
> > | Fix duplicate `resetDeltaRequest()` call in `DeltaSession.setId(String)`. (kkolinko)
> > | Work around a known JVM bug that is fixed in 1.7.0_01 but still present in 1.6.0_29 and was triggering intermittent unit test failure for `org.apache.catalina.tribes.group. TestGroupChannelMemberArrival.testMemberArrival`. The bug affects any components that use NIO although it was more likely to be observed in the clustering module than the HTTP or AJP NIO connector. (markt)
> > | When Context manager does not exist, no context manager message is replied in order to avoid timeout (default 60sec) of GET_ALL_SESSIONS sync phase. (kfujino)
> > | Fix setting maxInactiveInterval, sessionIdLength and processExpiresFrequency for cluster managers. Use setter when setting maxActiveSessions. (rjung)

> Web applications

> > | 50923: Use distinct background color for `code` tag in Tomcat documentation, for better readability. (kkolinko)
> > | 51630: Fix bug in async0 example that triggered an IllegalStateException in the application log. (markt)
> > | 52025: Add additional information regarding DriverManager, the service provider mechanism and memory leaks. (markt)
> > | 52049: Improve setup instructions for running as a Windows service: remove references to specific Windows operating systems - it easily becomes dated; correct information on how a JRE is identified and selected. (markt)
> > | 52172: Clarify Tomcat build instructions. Patch provided by bmargulies. (kkolinko)

> jdbc-pool

> > | 52015: In jdbc-pool: JdbcInterceptor passes not 'this' but 'proxy' to `getNext().invoke`. (kfujino)
> > | In jdbc-pool: Improve handling of Errors that originate from methods invoked through reflection. In `TrapException` interceptor: rethrow Error as is, without wrapping it in a RuntimeException. (kkolinko)
> > | In jdbc-pool: Unwrap InvocationTargetException if it is caught in `ResultSetProxy`, like we do it elsewhere. (kkolinko)
> > | When building jdbc-pool from within Tomcat, use Tomcat's `output` directory location. This allows to move all build output away from the source tree. (kkolinko)

> Other

> > | Update the package re-named copy of Commons BCEL (formerly Jakarta BCEL) to the latest code from Commons BCEL trunk. (markt)
> > | Remove some unused code from the packaged renamed Commons BCEL. (markt)
> > | 52059: In Windows uninstaller: Do not forget to remove Tomcat keys from 32-bit registry on deinstallation. (kkolinko)
> > | Start the process of deprecating unused and unnecessary code that will be removed in the next major release (8.0.x). (markt)
> > | Ignore `.git` directory when building the source distributive. (markt)
> > | Remove trailing whitespace from the default configuration files. (kkolinko)
> > | Improve `RUNNING.txt`. (kkolinko)
> > | Update optional Checkstyle library to 5.5. (kkolinko)
> > | In test suite: add `LoggingBaseTest` class to allow use of Tomcat logging configuration in tests that do not start Tomcat. (kkolinko)
> > | In test suite: speed up `TestGroupChannelSenderConnections`. Remove 48 seconds worth of waits. (kkolinko)
> > | 52148: Add tomcat-coyote.jar to catalina-tasks.xml as this JAR is now required by the Ant tasks. Patch provided by Volker Krebs. (markt)
> > | Add sample Apache Commons Daemon JSVC wrapper script `bin/daemon.sh` that can be used with `/etc/init.d`. (mturk)

Tomcat 7.0.22 (markt) | released 2011-10-01

> Catalina

> > | 51550: An additional change that ensures any exceptions thrown by an Authenticator (or any other Valve configured for the Context) will be handled by the custom error pages for the Context if an appropriate error page is configured. (markt)
> > | 51580: Added a nicer error message when a WAR file contains filenames not properly encoded in UTF-8. (schultz)
> > | 51687: Added (optional) protection against sun.java2d.Disposer thread pinning a WebappClassLoader into memory in the JreMemoryLeakPreventionListener. (schultz)
> > | 51741: Fixes a problem with Eclipse WTP "Serve modules without publishing" feature where applications failed to access resources when using getResource() on the classloader. (slaurent)
> > | 51744: Prevent application code from closing the associated JNDI context while the application is running. (markt)
> > | Correct a regression with the fix for 51653 that broke custom error pages for 4xx responses from the Authenticators. Error handling and request listeners are now handled in the StandardHostValve to ensure they wrap all Context level activity. (markt)
> > | 51758: The digester (used for processing XML files) used the logger name `org.apache.commons.digester.Digester` rather than the expected `org.apache.tomcat.util.digester.Digester`. The digester has been changed to use the expected logger name. (markt/kkolinko)
> > | 51774: Fix incorrect cached method signature that prevented session tracking modes from being defined in web.xml when running under a security manager. (markt)
> > | Add an annotation cache to the `DefaultInstanceManager` that improves performance for applications that make use of a lot of non-poolable objects (e.g. tag files) that need to be scanned for annotations when created. (markt)
> > | Use the specification compliant request attribute of `javax.servlet.request.ssl_session_id` to access the SSL session ID and deprecated the Tomcat specific request attribute. (markt)
> > | Allow to overwrite the check for distributability of session attributes by session implementations. (rjung)
> > | Add Java 7 sunec.jar and zipfs.jar to the list of JARs to skip when scanning for TLDs and web fragments. (rjung)
> > | 51862: Added a `classesToInitialize` attribute to `JreMemoryLeakPreventionListener` to allow pre-loading of configurable classes to avoid some classloader leaks. (slaurent)
> > | Reduce visibility of static field `ManagerBase.name` and make it final. (kkolinko)
> > | Add thread name to juli OneLineFormatter. (rjung)
> > | Ensure Servlets that implement ContainerServlet always get treated as restricted. (markt)
> > | 51872: Ensure that the access log always uses the correct value for the remote IP address associated with the request and that requests with multiple errors do not result in multiple entries in the access log. (markt)

> Coyote

> > | Remove unused and undocumented socketCloseDelay attribute from NIO connector. (markt)
> > | 49683: Support separate connection and keep-alive timeouts for the APR/native connector HTTP and AJP connectors. (markt)
> > | Further re-factoring of the HTTP connectors to align the BIO, NIO and APR implementations. (markt)
> > | 51794: Fix race condition in NioEndpoint. (fhanik)
> > | 51811: Correct SSL configuration property name from sslImplemenationName to sslImplementationName. (rjung)
> > | Fix a timing issue in NIO connector that meant that stopping a connector did not trigger a Comet END event if the associated processor was processing a READ event when the connector was stopped. (markt)
> > | Replace unneeded call that iterated events queue in NioEndpoint.Poller. (kkolinko)
> > | 51860: Fix issues if using NIO with a custom SSLImplementation. Based on a suggestion by Roman Tsirulnikov. (markt)
> > | Allow the BIO HTTP connector to be used with SSL when running under Java 7. (markt)
> > | Don't send AJP CPONG if endpoint is already paused. (rjung)
> > | Align APR AJP connector with NIO one. Send 503 if endpoint is paused. (rjung)
> > | Accept AJP request even if endpoint is paused, if CPING was successful. (rjung)

> Jasper

> > | When unloading JSPs due to configuration of the `maxLoadedJsps` initialisation parameter, the unloading code was retaining a reference to the unloaded JSP preventing the associated class from being unloaded until the JSP that replaced it was itself unloaded. (markt)
> > | 51852: Correct two problems in the handling of varargs methods with the BeanELResolver. The first meant the wrong method was sometimes called and the second that an ArrayIndexOutOfBoundsExceptions could be thrown. Patch (including a test case) provided by Matt Benson. (markt)

> Cluster

> > | Refactor cluster manager configuration: move handling of common attributes to base class. (kfujino, rjung)
> > | New cluster manager attribute `sessionAttributeFilter` allows to filter which session attributes are replicated using a regular expression applied to the attribute name. (rjung)

> Web applications

> > | Correct the documentation for `connectionLinger` attribute for the AJP and HTTP connectors. (markt)
> > | Document caveat of using `RemoteAddrValve` with IPv6 addresses. (kkolinko)

> jdbc-pool

> > | In jdbc-pool: Avoid IllegalArgumentException when setting maxActive less than or equal to 0. ArrayBlockingQueue doesn't allow capacity of 0 or less. (kfujino)
> > | 48392 (r1169796): Fix typo in `StatementDecoratorInterceptor`. (fhanik)
> > | 51139: In jdbc-pool: validatorClassName and suspectTimeout are ignored. In order to support them correctly, validatorClassName and suspectTimeout are added to a property list. (kfujino)
> > | 51786: In jdbc-pool: Discarded connection is not active in a pool any longer. It removes from the active connection list. (kfujino)
> > | 51871: Fix dependency in Maven POM file of tomcat-jbdc. (kkolinko)

> Other

> > | Update the "test" target in the default build file to report a test failure only after all available connector variants (bio, nio, apr) have been tested. Do not stop after first connector that fails. (kkolinko)
> > | 51887: When running the unit tests, use a fast but insecure random number source for session ID generation to reduce the delays caused by waiting for entropy. (kkolinko/markt)
> > | Code clean-up to further reduce the number of warnings reported by Eclipse, FindBugs and CheckStyle. (markt/kkolinko)

Tomcat 7.0.21 (markt) | released 2011-09-01

> Catalina

> > | 41718: Include a response body when sending a redirect. (markt)
> > | 51640: Improve the memory leak prevention for leaks triggered by java.sql.DriverManager. (markt)
> > | 51644: Fix annotation scanning for contexts with a multi-level context path such as /a/b. (markt)
> > | Unregisters MBean of DataSource when web application stops. (kfujino)
> > | 51650: Code clean-up. Patch provided by Felix Schumacher. (markt)
> > | 51653: Move application level error page handling from the Host to the Context. This ensures that application error page handling is completed before the requestDestroyed event of any ServletRequestListener is fired. (markt)
> > | 51654: Improve handling of invalid appBase settings for Host elements. (markt)
> > | 51658: Fix possible NPE when logging a failed request. Based on a suggestion by Felix Schumacher. (markt)
> > | 51688: JreMemoryLeakPreventionListener now protects against AWT thread creation. (schultz)
> > | 51712: Ensure cache control headers are sent when appropriate even if the request is secure. Patch provided by Michael Zampani. (markt)
> > | 51713: Improve message that is logged if there is an error in the value of `protocol` in a `Connector`. (kkolinko)
> > | 51739: When using a landing page with FORM authentication ensure that the request has a valid HTTP method. (markt)

> Coyote

> > | 51641: Use correct key when removing processor instances from the connections map during clean-up. Patch provided by zhh. (markt)
> > | More changes to align the code between the different HTTP connectors. (markt)
> > | Ensure AjpMessage headers are correct for the direction of the message. (markt)
> > | Code clean-up and re-factoring to reduce duplicate code in the AJP processor implementations. (markt)
> > | Detect incomplete AJP messages and reject the associated request if one is found. (markt)
> > | 51698: Fix CVE-2011-3190. Prevent AJP message injection. (markt)

> Jasper

> > | 41673: Use platform line-endings when reporting compilation errors. (markt)

> Cluster

> > | 51736: Make rpcTimeout configurable in BackupManager. (kfujino)

> Web applications

> > | 51649: Update the documentation web application to include the ThreadLocal leak prevention listener. (markt)

> jdbc-pool

> > | 51583 (r1157874, r1162102): Fix shutdown delay in jdbc-pool. (fhanik/kkolinko)

> Other

> > | 51558: Don't force the use of StandardManager when using any of the `Tomcat#addWebapp()` methods. (markt)
> > | 51704: Make use of `File#mkdirs()` more robust. (markt)

Tomcat 7.0.20 (markt) | released 2011-08-11

> Catalina

> > | Corrected missing comma in the value of `jarsToSkip` property in `conf/catalina.properties` file, which caused tomcat-jdbc.jar and commons-beanutils*.jar to be not ignored when scanning jars for tag libraries. (kkolinko)
> > | 41709: Provide exception messages where no message is provided currently for IllegalStateExcpetions triggered by calling HttpServletResponse methods when the response is committed. (markt)
> > | 51509: Fix potential concurrency issue in CSRF prevention filter that may lead to some requests failing that should not. (markt)
> > | 51518: Correct error in web.xml parsing rules for the <others/> tag when using absolute ordering. (markt)
> > | Move the SetCharacterEncoding filter from the examples web application to the `org.apache.catalina.filters` package so it is available for all web applications. (markt)
> > | 51550: Internal errors in Tomcat components that process requests before they are passed to a web application, such as Authenticators, now return a 500 response rather than a 200 response. (markt)
> > | 51555: Allow destroy() to be called on Lifecycle components that are in the initialized state. (markt)
> > | Add x-threadname pattern format token to ExtendedAccessLogValve to log the current request thread name. Based on a patch from Felix Schumacher. (timw)
> > | 51584: Ensure file paths are encoded/decoded when translated to/from URLs when working with resources from a Context so special characters don't cause issues. (markt)
> > | 51586: Expand error handling to cover anything that is recoverable (or might be recoverable) when loading classes during HandlesTypes processing. (markt)
> > | 51588: Make it easier to extend the AccessLogValve to add support for custom elements. (markt)
> > | Ensure that calls to StandardWrapper methods() that may trigger creation of a Servlet instance always do so in way that correctly instantiates a Servlet instance. (markt)
> > | In JDBCStore: Committing connection if autoCommit is false. Make sure committed connection is returned to the pool if datasource is enabled. (kfujino)
> > | Split `condition` attribute of AccessLogValve into two, `conditionIf` and `conditionUnless`. Implement conditional logging that logs only if a request attribute is present. (kkolinko)
> > | Allow to have several AccessLogValve instances in the same scope (e.g. in the same Context). (kkolinko)
> > | 51610: If an unchecked exception occurs during a lifecycle transition (e.g. web application start) ensure that the component is put into the failed state. (markt)
> > | 51614: Avoid calling store.load() and session.expire() twice in PersistentManager when expiring sessions. (kfujino)
> > | Prevent spurious log warnings on container stop if a child component has previously failed. (markt)
> > | Add missing getter and setter for the alwaysUseSession attribute of the authenticators. (markt)

> Coyote

> > | 49595: Prevent JVM crash with the AJP APR connector when flushing a closed socket. (jfclere)
> > | 50394: Return -1 instead of throwing an exception when encountering an EOF while processing an input stream with the HTTP APR connector. (jfclere)
> > | Correctly handle a connectionTimeout value of -1 (no timeout) for the HTTP NIO and AJP NIO connectors. (markt)
> > | 51503: Add additional validation that prevents a connector from starting if it does not have a port > 0. (markt)
> > | 51557: Ignore HTTP headers that do not comply with RFC 2616 and use header names that are not tokens. (markt)
> > | Improve error handling for HTTP APR if an error occurs while using sendfile. (markt)
> > | Ensure that when using sendfile, HTTP APR sockets are not added to multiple pollers. This may cause errors during shutdown. (markt)
> > | Set `reuse` flag of final AJP `END_RESPONSE` packet to `0` if we plan to close the connection. (rjung)
> > | Correctly indicate if socket is closing when calling recycle for the AJP NIO processor. Note since the flag is unused in this case there were no bugs triggered by the re-factoring error. (rjung)

> Jasper

> > | 51532: JSP files with dependencies in JARs were recompiled on every access leading to poor performance. (markt)
> > | 51544: Correctly resolve bean methods in EL so accessible methods that are overridden by inaccessible methods do not cause an IllegalAccessException. (markt)

> Web applications

> > | 41498: Add the allRolesMode attribute to the Realm configuration page in the documentation web application. (markt)
> > | 48997: Fixed some typos and correct cross-referencing to the HTTP Connector documentation with the SSL How-To page of the documentation web application. (markt)
> > | 49122: Improvements and fixes for index page for ROOT web application. Based on a patch provided by pidster. (markt)
> > | 51516: Correct documentation web application to show correct system property name for changing the name of the SSO session cookie. (markt)
> > | Configure the Manager and Host Manager web applications with the Set Character Encoding Filter to make the default request character encoding UTF-8 to improve i18n support. Note that best results will be obtained if the connector is also configured with `URIEncoding="UTF-8"`.(markt)
> > | Update the documentation web application to be even more explicit about the implications of setting the path attribute on a Context element in server.xml. (markt)
> > | 51561: Update the Realm page within the documentation web application to recommend the use of digest.[bat|sh] to generate digests rather than calling RealmBase directly. (markt)
> > | 51567: Update the class loading page of the documentation web application to include information on the search order for the common class loader when separate values are used for $CATALINA_HOME and $CATALINA_BASE. (markt)
> > | Improve class loading documentation and logging documentation. (kkolinko)
> > | Add information to the security page of the documentation web application for the ciphers attribute of the Connector element. (markt)

> Other

> > | 51503: Add additional validation to Windows installer that ensure that the shutdown port, HTTP port and AJP port are all specified during the install process. (markt)
> > | 51531: Update sample Eclipse classpath file to reflect updated ECJ jar. Patch provided by Ian Brandt. (markt)
> > | Convert Tomcat unit tests to JUnit 4. (kkolinko)
> > | Update optional CheckStyle library to 5.4. (kkolinko)
> > | Remove `resolveHosts` attribute from AccessLogValve configuration in the default `server.xml`. It was documented in 7.0.19 that it has no effect. (kkolinko)
> > | Simplify mapping for `jsp` servlet in the default `web.xml`. (kkolinko)
> > | Correctly handle uninstall with the Windows installer if the service is installed with a name that contains a '-' character. (markt)
> > | 51598: Prevent direct invocation of the Windows uninstaller without a service name from executing since the uninstall will not be complete. (markt)
> > | Use Tomcat icon (cat) instead of Apache Commons Daemon (feather) one in the list of uninstallable programs on Windows. (kkolinko)
> > | Update to Apache Commons Daemon 1.0.7. (markt)
> > | 51621: Add additional required JARs to the deployer distribution. (markt)
> > | Fix a small number of warnings reported by FindBugs. (markt)
> > | Update to version 1.1.22 of the native component for the AJP APR/native and HTTP APR/native connectors. (markt)

Tomcat 7.0.19 (markt) | released 2011-07-19

> Catalina

> > | Add option to activate access log for unit tests. (rjung)
> > | Fix regression in year number formatting for AccessLogValve. (rjung)
> > | 46252: Allow to specify character set to be used to write the access log in AccessLogValve. (kkolinko)
> > | 51494: Prevent an NPE when a long running request completes if the associated web application was destroyed while the request was processing. (markt)
> > | Allow choosing a locale for timestamp formatting in AccessLogValve. (rjung)
> > | When generating access logs for errors, log at the Context/Host level if a Context or Host can be identified for the failed request. (markt)
> > | Create a directory for access log or error log (in AccessLogValve and in JULI FileHandler) automatically when it is specified as a part of the file name, e.g. in the `prefix` attribute. Earlier this happened only if it was specified with the `directory` attribute. (kkolinko)
> > | Log a failure if access log file cannot be opened. (kkolinko)
> > | Use en_US as locale for timestamps in ExtendedAccessLogValve. (rjung)
> > | Use en_US as locale for creationdate in WebdavServlet. (rjung)

> Coyote

> > | 51477: Support all SSL protocol combinations in the APR/native connector. This only works when using the native library version 1.1.21 or later, which is not yet released. (rjung)
> > | Various refactorings to reduce code duplication and unnecessary code in the connectors. (markt)
> > | Correct regression introduced in 7.0.17 that triggered 400 entries in the AccessLog when using the AJP/BIO connector. (markt)
> > | Fix regression producing invalid MBean names when using IPV6 addresses for connectors. (rjung)
> > | Add missing thread name in RequestProcessor when Servlet 3 Async is used. Fixes null thread name in access log and JMX MBean. (rjung)
> > | Fix CVE-2011-2526. Protect against infinite loops (HTTP NIO) and crashes (HTTP APR) if sendfile is configured to send more data than is available in the file. (markt)
> > | Prevent NPEs when a socket is closed in non-error conditions after sendfile processing when using the HTTP NIO connector. (markt)

> Cluster

> > | Remove unnecessary server.xml parsing code for old cluster implementation that does not ship as part of Tomcat 7. (markt)

> Web applications

> > | Add additional information to the documentation web application on the benefits and remaining risks when running under a security manager. (markt)
> > | 51490: Correct broken HTML in JSP tag plugin examples and improve the <c:if> example to make failures more obvious. Based on suggestions by Charles. (markt)
> > | Document ExtendedAccessLogValve. (rjung)
> > | Correct default value of `enableLookups` for connectors and mention, that `resolveHosts` for the AccessLogValve is replaced by `enableLookups`. (rjung)

> jdbc-pool

> > | Include jdbc-pool into Tomcat release. (fhanik)

> Other

> > | Update to Apache Commons Daemon 1.0.6. (markt)
> > | Update to Eclipse JDT Compiler 3.7. (markt)

Tomcat 7.0.18 (markt) | not released

> Catalina

> > | Correct regression introduced in 7.0.17 that triggered an NPE if a CrawlerSessionManagerValve was used without setting crawlerUserAgents. (markt)
> > | 51466: Correct comment typos in HostManagerServlet. Patch provided by Felix Schumacher. (markt)
> > | 51467: Invoke Thread.start() rather than Thread.run() so that listeners and filters are stopped in a separate thread rather than the current thread. Patch provided by Felix Schumacher. (markt)
> > | 51473: Fix concatenation of values in `SecurityConfig.setSecurityProperty()`. (kkolinko)
> > | Fix response.encodeURL() for the special case of an absolute URL with no path segment (http://name). (rjung)

> Coyote

> > | Correct regression caused by connector re-factoring that made AJP APR/native connector very unstable on Windows platforms. (markt)
> > | Correct regression caused by connector re-factoring that meant that sendfile data was not reset between pipe-lined HTTP requests. (markt)

> Tribes

> > | Re-factor tests to align packages for tests with the classes under test. Start to convert non-JUnit tests to JUnit. Remove unnecessary code. (markt)
> > | Add synchronization to receiver socket binding to prevent test failures on Linux. (markt)

> Other

> > | More code clean-up to remove unused code and reduce IDE warnings. (markt/kkolinko)
> > | Further improvements to the Windows installer. (markt/kkolinko)

Tomcat 7.0.17 (markt) | not released

> Catalina

> > | 48956: Add regular expression support for SSI. (markt)
> > | 49165: Allow any time stamp formats supported by SimpleDateFormat in AccessLogValve. Support logging begin and/or end of request. (rjung)
> > | 50677: Allow system property variables to be used in the values of "common.loader" and other "*.loader" properties in the `catalina.properties` file. (kkolinko)
> > | 51376: When adding a Servlet via ServletContext#addServlet(String, Servlet), the Servlet was not initialized when the web application started and a load on startup value was set. (markt)
> > | 51386: Correct code for processing @HandlesTypes annotations so only types of interest are reported to a ServletContainerInitializer. (markt)
> > | Add the Tomcat extras, ant-junit and Java Help Jars to the list of JARs to skip when scanning for TLDs and web fragments. (rjung)
> > | The fix for bug 51310 caused a regression that re-introduced bug 49957 and deleted the contents of the work directory when Tomcat was shutdown. This fix ensures that the work directory for an application is not deleted when Tomcat is shutdown. (markt)
> > | Correct issues with JULI's OneLineFormatter including: correctly re-using formatted timestamps when possible; thread-safety issues in timestamp formatting; correcting the output of any milliseconds to include leading zeros and formatting any parameters present. (kkolinko/markt/rjung)
> > | 51395: Fix memory leak triggered when an application that includes a SAXParserFactory is the first web application to be loaded. (markt)
> > | 51396: Correctly handle jsp-file entries in web.xml when the JSP servlet has been configured via code when embedding Tomcat. (markt)
> > | 51400: Avoid known bottleneck in JVM when converting between Strings and bytes by always providing a Charset rather than an encoding name. Based on a patch by Dave Engberg. (markt)
> > | 51401: Correctly initialise shared WebRuleSet instance used by the digesters that parse web.xml and prevent incorrect warnings about multiple occurrences of elements that are only allowed to appear once in web.xml and web-fragment.xml. (kfujino)
> > | 51403: Avoid NPE in JULI FileHandler if formatter is misconfigured. (kkolinko)
> > | Previous improvements in JAR scanning performance introduced a start-up performance penalty for some use cases. This fix addresses those performance penalties while retaining the original improvements. (markt)
> > | 51418: Provide more control over Context creation when embedding Tomcat. Based on a patch by Benson Margulies. (markt/kkolinko)
> > | Remove redundant copy of catalina.properties from o.a.c.startup. Generate this copy for inclusion in bin and src jars during the ant "compile" task. (rjung)
> > | Use system properties loaded from catalina.properties via the class path in unit tests. (rjung)
> > | Improve JMX unit test. (rjung)
> > | Fix IllegalStateException for JavaScript files when switching from Writer to OutputStream. The special handling of this case in the DefaultServlet was broken due to a MIME type change for JavaScript. (funkman)
> > | Fix CVE-2011-2204. Prevent user passwords appearing in log files if a runtime exception (e.g. OOME) occurs while creating a new user for a MemoryUserDatabase via JMX. (markt)
> > | Fix an issue with the CrawlerSessionManagerValve that meant sessions were not always correctly tracked. (markt)
> > | 51436: Send 100 (Continue) response earlier to enable ServletRequestListener implementations to read the request body. Based on a patch by Simon Olofsson. (markt)
> > | Ensure an access log entry is made if an error occurs during asynchronous request processing and the socket is immediately closed. (markt)
> > | Ensure that if asyncDispatch() is called during an onTimeout event and the target Servlet does not call startAsync() or complete() that Tomcat calls complete() once the target Servlet exits. (markt)
> > | Improve the handling for Servlets that implement the deprecated SingleThreadModel when embedding Tomcat. (markt)
> > | 51445: Correctly initialise all instances of Servlets that implement SingleThreadModel. Based on a patch by Felix Schumacher. (markt)
> > | 51453: Fix a regression in the preemptive authentication support (enhancement 12428) that could trigger authentication even if preemptive authentication was disabled. (markt)
> > | Prevent possible NPE when serving Servlets that implement the SingleThreadModel interface. (markt)
> > | In launcher for embedded Tomcat: do not change `catalina.home` system property if it had a value. (kkolinko)
> > | When using Servlets that implement the SingleThreadModel interface, add the single instance created to the pool when it is determined that a pool of servlets is required rather than throwing it away. (markt)

> Coyote

> > | Fix unit test for bindOnInit which was failing for APR on some platforms. (rjung)
> > | Remove superfluous quotes from thread names for connection pools. (rjung)
> > | Fix crash observed during pausing the connector when using APR. Only add socket to poller if we are sure we don't close it later. (rjung)
> > | Various refactorings to reduce code duplication and unnecessary code in the connectors. (markt)
> > | Correct a regression introduced in Apache Tomcat 7.0.11 that broke certificate revocation list handling. (markt)

> Jasper

> > | Improve the message printed by TldLocationsCache and add configuration example to the `logging.properties` file. (kkolinko)
> > | 33453: Recompile JSPs if last modified time of the source or any of its dependencies changes either forwards or backwards. Note that this introduces an incompatible change to the code generated for JSPs. Tomcat will automatically re-compile any JSPs and tag files found in the work directory when upgrading from 7.0.16 or earlier to 7.0.17 or later. If you later downgrade from 7.0.17 or later to 7.0.16 or earlier, you must empty the work directory as part of the downgrade process. (markt)
> > | 36362: Handle the case where tag file attributes (which can use any valid XML name) have a name which is not a Java identifier. (markt/kkolinko)
> > | Broaden the exception handling in the EL Parser so that more failures to parse an expression include the failed expression in the exception message. Hopefully, this will help track down the cause of 51088. (markt)

> Cluster

> > | 51306: Avoid NPE when handleSESSION_EXPIRED is processed while handleSESSION_CREATED is being processed. (kfujino)
> > | Notifications of changes in session ID to other nodes in the cluster should be controlled by notifySessionListenersOnReplication rather than notifyListenersOnReplication. (markt)
> > | The change in session ID is notified to the container event listener on the backup node in cluster. This notification is controlled by notifyContainerListenersOnReplication.(kfujino)

> Web applications

> > | Update Maven repository information in the documentation to reflect current usage. (markt)
> > | 43538: Add host name and IP address to the HTML Manager application. Patch by Dennis Lundberg. (markt)
> > | Add `session="false"` directive to the index page of the ROOT web application. (kkolinko)
> > | 51443: Document the notifySessionListenersOnReplication attribute for the DeltaManager. (markt)
> > | 51447: Viewing a back up session in the HTML Manager web application no longer changes the session to a primary session. Based on a patch provided by Eiji Takahashi. (markt)

> Other

> > | 33262: Install monitor to auto-start for current user only rather than all users to be consistent with menu item creation. (markt)
> > | 40510: Provide an option to install shortcuts for the current user or all users. Also ensure registry is correctly cleaned on uninstall for 64-bit platforms. (markt)
> > | 50949: Provide the ability to specify the AJP port and service name when installing Tomcat using the Windows installer. This permits multiple instances of the same Tomcat version to be installed side-by-side. (markt)
> > | Clean up shell and batch scripts (improve consistency, clarify comments, add `configtest` command support for Windows). (rjung)
> > | 51206: Make CATALINA_BASE visible for setenv.sh. (rjung)
> > | Remove unnecessary variable BASEDIR from scripts. (rjung)
> > | 51425, 51450: Update Spanish translations. Based on patches provided by Jesus Marin. (markt)

Tomcat 7.0.16 (markt) | released 2011-06-17

> Catalina

> > | 51249: Further improve system property replacement code in ClassLoaderLogManager of Tomcat JULI to cover some corner cases. (kkolinko)
> > | 51264: Improve the previous fix for this issue by returning the connection to the pool when not in use so it does not appear to be an abandoned connection. Patch provided by Felix Schumacher. (markt)
> > | 51324: Improve handling of exceptions when flushing the response buffer to ensure that the doFlush flag does not get stuck in the enabled state. Patch provided by Jeremy Norris. (markt)
> > | Correct a regression in the fix for 51278 that prevented any web application from being marked as distributable. (kfujino/markt)
> > | Correct a regression in the fix for 51278 that prevented a web application from overriding the default welcome files. (markt)
> > | Enable remaining valves for Servlet 3 asynchronous processing support. (markt)
> > | Avoid possible NPE when logging requests received during embedded Tomcat shutdown. (markt)
> > | 51340: Fix thread-safety issue when parsing multiple web.xml files in parallel. Apache Tomcat does not do this but products that embed it may. (markt)
> > | 51344: Fix problem with Lifecycle re-factoring for deprecated embedded class that prevented events being triggered. (markt)
> > | 51348: Prevent possible NPE when processing WebDAV locks. (markt)

> Coyote

> > | When parsing the port in the HTTP host header, restrict the value to be base 10 integer digits rather than hexadecimal ones. (rjung/markt/kkolinko)
> > | Various refactorings to reduce code duplication and unnecessary code in the connectors. (markt)

> Jasper

> > | Change JAR scanning log messages where no TLDs are found to DEBUG level and replace the multiple messages with a single INFO level message that indicates that at least one JAR was scanned needlessly and how to obtain more info. (markt)

> Cluster

> > | Enable Servlet 3 asynchronous processing support when using clustering. (markt)

> Web applications

> > | Correct the log4j configuration settings when defining conversion patterns in the documentation web application. (markt)

Tomcat 7.0.15 (markt) | not released

> Catalina

> > | 27122: Remove a workaround for a very old and since fixed Mozilla bug and change the default value of the securePagesWithPragma attribute of the Authenticator Valves to false. These changes should reduce the likelihood of issues when downloading files with IE. (markt)
> > | 35054: Check that a file is not specified for a Host's appBase and log an error if it is. (markt)
> > | 51197: Fix possible dropped connection when sendError or sendRedirect are used during async processing. (markt)
> > | 51221: Correct Spanish translation of text used in a 302 response. Patch provided by Paco Soberón. (markt)
> > | 51249: Correct ClassLoaderLogManager system property replacement code so properties of the form "}${...}" can be used without error. (markt)
> > | 51264: Allow the JDBC persistent session store to use a JNDI datasource to define the database in which sessions are persisted. Patch provided by Felix Schumacher. (markt)
> > | 51274: Add missing i18n strings in PersistentManagerBase. Patch provided by Eiji Takahashi. (markt)
> > | 51276: Provide an abstraction for accessing content in JARs so the most efficient method can be selected depending on the type of URL used to identify the JAR. This improves startup time when JARs are located in $CATALINA_BASE/lib. (markt)
> > | 51277: Improve error message if an application is deployed with an incomplete FORM authentication configuration. (markt)
> > | 51278: Allow ServletContainerInitializers to override settings in the global default web.xml and the host web.xml. (markt)
> > | 51310: When stopping the Server object on shutdown call destroy() after calling stop(). (markt)

> Coyote

> > | 51145: Add an AJP-NIO connector. (markt/rjung)

> Jasper

> > | 51220: Add a system property to enable tag pooling with JSPs that use a custom base class. Based on a patch by Dan Mikusa. (markt)
> > | Include a comment header in generated java files that indicates when the file was generated and which version of Tomcat generated it. (markt)
> > | 51240: Ensure that maxConnections limit is enforced when multiple acceptor threads are configured. (markt)

> Cluster

> > | 51230: Add missing attributes to JMX for ReplicationValve and JvmRouteBinderValve. Patch provided by Eiji Takahashi. (markt)

> Web applications

> > | Add documentation for AJP-NIO connector. (markt/rjung)
> > | 51182: Document JAAS supported added in 51119. Patch provided by Neil Laurance. (markt)
> > | 51225: Fix broken documentation links for non-English locales in the HTML Manager application. Patch provided by Eiji Takahashi. (markt)
> > | 51229: Fix bugs in the Servlet 3.0 asynchronous examples. Patch provided by Eiji Takahashi. (markt)
> > | 51251: Add web application version support to the Ant tasks. Based on a patch provided by Eiji Takahashi. (markt)
> > | 51294: Clarify behaviour of unpackWAR attribute of StandardContext components. (markt)

> Other

> > | 46451: Configure svn:bugtraq properties for Tomcat trunk. Based on a patch provided by Marc Guillemot. (markt)
> > | 51309: Correct logic in catalina.sh stop when using a PID file to ensure the correct message is shown. Patch provided by Caio Cezar. (markt)

Tomcat 7.0.14 (markt) | released 2011-05-12

> Catalina

> > | Stylistic improvements to MIME type sync script. Based on a patch provided by Felix Schumacher. (rjung)
> > | Ensure that the SSLValve provides the SSL key size as an Integer rather than a String. (markt)
> > | Ensure that the RemoteIpValve works correctly with Servlet 3.0 asynchronous requests. (markt)
> > | Use safe equality test when determining event type in the MapperListener. (markt)
> > | Use correct class loader when loading Servlet classes in StandardWrapper. (markt)
> > | Provide additional configuration options for the RemoteIpValve and RemoteIpFilter to allow greater control over the values returned by ServletRequest#getServerPort() and ServletRequest#getLocalPort() when Tomcat is behind a reverse proxy. (markt)
> > | Ensure session cookie paths end in `/` so that session cookies created for a context with a path of `/foo` do not get returned with requests mapped to a context with a path of `/foobar`. (markt)

> Jasper

> > | 51177: Ensure Tomcat's MapElResolver always returns `Object.class` for `getType()` as required by the EL specification. (markt)

Tomcat 7.0.13 (markt) | not released

> Catalina

> > | Correct mix-up in Realm Javadoc. (markt)
> > | Fix display of response headers in AccessLogValve. (kkolinko)
> > | Implement display of multiple request headers in AccessLogValve: print not just the value of the first header, but of the all of them, separated by commas. (kkolinko)
> > | 50306: New StuckThreadDetectionValve to detect requests that take a long time to process, which might indicate that their processing threads are stuck. Based on a patch provided by TomLu. (slaurent)
> > | 51038: Ensure that asynchronous requests are included in access logs. (markt)
> > | 51042: Don't trigger session creation listeners when a session ID is changed as part of the authentication process. (markt)
> > | 51050: Add additional common but non-standard file extension to MIME type mappings for MPEG 4 files. Based on a patch by Cédrik Lime. (markt)
> > | Add some additional common JARs that do not contain TLDs or web fragments to the list of JARs to skip when scanning for TLDs and web fragments. (markt)
> > | While scanning JARs for TLDs and fragments, avoid using JarFile and use JarInputStream as in most circumstances where JARs are scanned, JarFile will create a temporary copy of the JAR rather than using the resource directly. This change significantly improves startup performance for applications with lots of JARs to be scanned. (markt)
> > | Ensure response is committed when `AsyncContext#complete()` is called. (markt)
> > | Add a container event that is fired when a session's ID is changed, e.g. on authentication. (markt)
> > | 51099: Correctly implement non-default login configurations (configured via the loginConfigName attribute) for the SPNEGO authenticator. (fhanik/markt)
> > | 51119: Add JAAS authentication support to the JMXRemoteLifecycleListener. Patch provided by Neil Laurance. (markt)
